'-------------------------------------------------------------------------------
'
' Demo.bas - original author of the menu code unknown
' Bring together all the miscellaneous items I have
' NB: This file is a bit of a mixture of "old" & "new" from RapidFRM
' generated code. The dialog code for font, color, open, save, print
' has been integrated into RQInclude.bi as of RapidFRM v1.58
'
'   d_homans@yahoo.com.au
'   23 Mar 2012
'
'-------------------------------------------------------------------------------
#INCLUDE "windows.bi"
#INCLUDE "win/commdlg.bi"
#INCLUDE "win/commctrl.bi"

InitCommonControls()

#INCLUDE "win/RQInclude.bi"

CONST CRLF=CHR(13)+CHR(10)

' MenuItems->objIndex values starting at 1 (for convenience!)
ENUM MENUID_ENUM
    MENUID_FILE_OPEN = 1
    MENUID_FILE_SAVE
    MENUID_FILE_EXIT
    MENUID_FONT_DLG
    MENUID_COLOR_DLG
    MENUID_PRINT_DLG
    MENUID_EDIT_CUT
    MENUID_EDIT_COPY
    MENUID_EDIT_PASTE
    MENUID_EDIT_UNDO
    MENUID_EDIT_REDO
    MENUID_SEARCH_FINDNEXT
    MENUID_SEARCH_FINDPREV
    MENUID_SEARCH_REPLACE
    MENUID_ABOUT
END ENUM

#DEFINE END_MENU MENUID_ABOUT

DECLARE SUB Menu_Select(Index AS integer)
DECLARE SUB GetFileName
DECLARE SUB SaveFileName
DECLARE SUB SetFont
DECLARE SUB SetColor
DECLARE SUB SetPrint
DECLARE SUB UpDownChange(Sender AS QUPDOWN)
DECLARE SUB ExitClick(Sender AS QBUTTON)
DECLARE SUB ShowAbout

DECLARE SUB TimeOut(Sender AS QTIMER)
'-------------------------------------------------------------------------------
' Global data from Form designer sheet
'-------------------------------------------------------------------------------
DIM SHARED AS HMENU mnuMain, mnuFile, mnuDlg, mnuEdit, mnuSearch, mnuFind, mnuHelp
DIM SHARED fnMenuPtr AS SUB(Index AS integer) = @Menu_Select

DIM SHARED AS QFORM Form1
DIM SHARED AS QBUTTON Butn
DIM SHARED AS QSTATUSBAR StatBar
DIM SHARED AS QUPDOWN Spin
DIM SHARED AS QEDIT Edit
DIM SHARED AS QLABEL Label
DIM SHARED AS QPROGRESSBAR PBar

DIM SHARED AS QFORM PTR lpForm1     = @Form1
DIM SHARED AS QBUTTON PTR lpBtn     = @Butn
DIM SHARED AS QSTATUSBAR PTR lpStat = @StatBar
DIM SHARED AS QUPDOWN PTR lpSpin    = @Spin
DIM SHARED AS QEDIT PTR lpEdt       = @Edit
DIM SHARED AS QLABEL PTR lpLbl      = @Label
DIM SHARED AS QPROGRESSBAR PTR lpBar= @PBar

DIM SHARED AS QTIMER Timer1
DIM SHARED AS QTIMER PTR lpTimer    = @Timer1

'-------------------------------------------------------------------------------
' Configure components
'-------------------------------------------------------------------------------
SUB ConfigureComponents
    lpForm1->objIndex=0
    lpForm1->Width=300: lpForm1->Height=380
    lpForm1->Caption=Application.Name
    lpForm1->Visible=1

    lpBtn->objIndex=END_MENU+1
    lpBtn->Left=100: lpBtn->Top=250
    lpBtn->Width=100: lpBtn->Height=25
    lpBtn->Hint = "A hint!"
    lpBtn->ShowHint = True
    lpBtn->Caption="EXIT"
    lpBtn->OnClick=CAST(ANY PTR, @ExitClick)

    lpStat->objIndex=END_MENU+2
'    lpStat->Height=19
    lpStat->SimplePanel=True
    lpStat->SimpleText=""
    lpStat->SizeGrip=0

    lpSpin->objIndex=END_MENU+3
'    lpSpin->Left=20: lpSpin->Top=20
    lpSpin->Width=25: lpSpin->Height=75
    lpSpin->Align=0
    lpSpin->Orientation=spVertical
    lpSpin->Min=1: lpSpin->Max=100
    lpSpin->Position=1
    lpSpin->OnChange=CAST(ANY PTR, @UpDownChange)

'   Buddy edit control
    lpEdt->objIndex=END_MENU+4
    lpEdt->Left=50: lpEdt->Top=100
    lpEdt->Width=50: lpEdt->Height=25
    lpEdt->Text=STR(lpSpin->Position)

    lpLbl->objIndex=END_MENU+5
    lpLbl->Left=120: lpLbl->Top=100
    lpLbl->Width=150: lpLbl->Height=25
    lpLbl->Caption="UpDown Spin control"
    lpLbl->Alignment=taLeftJustify

    lpBar->objIndex=END_MENU+6
    lpBar->Left=0: lpBar->Top=lpForm1->Height-80
    lpBar->Width=lpForm1->Width: lpBar->Height=15
    lpBar->Min=1: lpBar->Max=100
    lpBar->ForeColor = &hc0: lpBar->BackColor = &hbfbfff
    lpBar->Visible=0

    lpTimer->objIndex=END_MENU+7
    lpTimer->Interval = 100
    lpTimer->Enabled=True
    lpTimer->OnTimer=CAST(ANY PTR, @TimeOut)
END SUB

'-------------------------------------------------------------------------------
' Load components
'-------------------------------------------------------------------------------
SUB LoadComponents
    SendMessage(Application.hMainForm, WM_LOAD_COMPONENTS, 0, 0)
END SUB


'-------------------------------------------------------------------------------
' Create components
'-------------------------------------------------------------------------------
SUB init_menus(Parent AS HWND)
    ' Create blank menus
    mnuMain     = CreateMenu()
    mnuFile     = CreateMenu()
    mnuDlg      = CreateMenu()
    mnuEdit     = CreateMenu()
    mnuSearch   = CreateMenu()
    mnuFind     = CreateMenu()
    mnuHelp    = CreateMenu()

    ' Create the main menu items
    InsertMenu(mnuMain, 0, MF_POPUP, CINT(mnuFile), "&File")
    InsertMenu(mnuMain, 0, MF_POPUP, CINT(mnuDlg), "&Dialogs")
    InsertMenu(mnuMain, 0, MF_POPUP, CINT(mnuEdit), "&Edit")
    InsertMenu(mnuMain, 0, MF_POPUP, CINT(mnuSearch), "Sear&ch")
    InsertMenu(mnuMain, 0, MF_POPUP, CINT(mnuHelp), "&Help")
    ' SubItem #1
    AppendMenu(mnuFile, 0, MENUID_FILE_OPEN, "&Open")
    AppendMenu(mnuFile, 0, MENUID_FILE_SAVE, "&Save As")
    AppendMenu(mnuFile, 0, 0, 0)                                ' separator
    AppendMenu(mnuFile, 0, MENUID_FILE_EXIT, "E&xit")
    ' SubItem #2
    AppendMenu(mnuDlg, 0, MENUID_FONT_DLG, "&Font")
    AppendMenu(mnuDlg, 0, MENUID_COLOR_DLG, "&Color")
    AppendMenu(mnuDlg, 0, MENUID_PRINT_DLG, "&Print")
    ' SubItem #3
    AppendMenu(mnuEdit, 0, MENUID_EDIT_CUT, "&Cut")
    AppendMenu(mnuEdit, 0, MENUID_EDIT_COPY, "C&opy")
    AppendMenu(mnuEdit, MF_DISABLED OR MF_GRAYED, MENUID_EDIT_PASTE, "&Paste")
    AppendMenu(mnuEdit, MF_MENUBARBREAK, MENUID_EDIT_UNDO, "&Undo")
    AppendMenu(mnuEdit, 0, MENUID_EDIT_REDO, "&Redo")
    ' SubItem #4
    InsertMenu(mnuSearch, 3, MF_POPUP, CINT(mnuFind), "&Find")
    AppendMenu(mnuFind, 0, MENUID_SEARCH_FINDNEXT, "Find &Next")
    AppendMenu(mnuFind, 0, MENUID_SEARCH_FINDPREV, "Find &Prev")
    AppendMenu(mnuSearch, MF_CHECKED, MENUID_SEARCH_REPLACE, "&Replace")
    ' SubItem #5
    AppendMenu(mnuHelp, 0, MENUID_ABOUT, "&About")

    SetMenu(Parent, mnuMain)
    DrawMenuBar(Parent)
END SUB

SUB AddChildObjects
DIM AS UINT StdStyle, ExtStyle
DIM AS string ObjCaption
DIM AS HWND Parent=lpForm1->Handle

    init_menus(Parent)

    lpBtn->PreSetConfig()
    ObjCaption=lpBtn->Caption
    lpBtn->Parent=Parent
    StdStyle=lpBtn->objStyle
    IF lpBtn->Visible THEN StdStyle += WS_VISIBLE
    ExtStyle=0

    lpBtn->Handle=CreateWindowEx(ExtStyle,lpBtn->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpBtn->Left, lpBtn->Top, lpBtn->Width, lpBtn->Height, _
                    Parent, CAST(HMENU, lpBtn->objIndex), 0, 0)

    lpBtn->PostConfig()
    EnableWindow(lpBtn->Handle, lpBtn->Enabled)

    lpStat->PreSetConfig()
    lpStat->Handle=CreateWindowEx(0, "msctls_statusbar32", "", _
                                    WS_CHILD OR WS_VISIBLE OR lpStat->ObjStyle, _
                                    0, 0, 0, 0, Parent, CAST(HMENU,lpStat->ObjIndex), 0, 0)
    lpStat->PostConfig()
    EnableWindow(lpStat->Handle, lpStat->Enabled)

    lpEdt->PreSetConfig()
    ObjCaption=lpEdt->Text
    StdStyle=lpEdt->ObjStyle
    IF lpEdt->Visible THEN StdStyle += WS_VISIBLE
    ExtStyle=WS_EX_CLIENTEDGE
    lpEdt->Parent=Parent
    lpEdt->Handle=CreateWindowEx(ExtStyle, "EDIT", ObjCaption, _
                    WS_CHILD OR WS_CLIPSIBLINGS OR ES_AUTOHSCROLL OR WS_TABSTOP OR StdStyle, _
                                    lpEdt->Left, lpEdt->Top, lpEdt->Width, lpEdt->Height, _
                                    Parent, CAST(HMENU,lpEdt->ObjIndex), 0, 0)
    lpEdt->PostConfig()
    EnableWindow(lpEdt->Handle, lpEdt->Enabled)

    lpSpin->Parent=Parent
    ExtStyle = UDS_SETBUDDYINT
    ExtStyle += UDS_ARROWKEYS                                        ' Enable keybord input
'    ExtStyle += UDS_WRAP                                             ' Wrap to the beginning (or end)
    IF lpSpin->Align=0 THEN ExtStyle += UDS_ALIGNLEFT ELSE ExtStyle += UDS_ALIGNRIGHT
    IF lpSpin->Visible THEN  ExtStyle += WS_VISIBLE
    lpSpin->Handle=CreateUpDownControl( _
                        WS_CHILD OR WS_CLIPSIBLINGS OR WS_TABSTOP OR ExtStyle, _
                                0, 0, 0, 0, Parent, CAST(HMENU,lpSpin->ObjIndex), 0, _
                                lpEdt->Handle, lpSpin->Max, lpSpin->Min, lpSpin->Position)
'                                   ^^^ Set buddy to spin control
    lpSpin->PostConfig()
    EnableWindow(lpSpin->Handle, lpSpin->Enabled)

    lpLbl->Parent=Parent
    lpLbl->Handle=CreateWindowEx(0, "STATIC", lpLbl->Caption, _
                        WS_VISIBLE OR WS_CHILD OR WS_BORDER OR SS_NOTIFY OR lpLbl->Alignment, _
                        lpLbl->Left, lpLbl->Top, lpLbl->Width, lpLbl->Height, _
                        Parent, CAST(HMENU,lpLbl->objIndex), 0, 0)
    lpLbl->PostConfig()
    EnableWindow(lpLbl->Handle, lpLbl->Enabled)

    lpBar->Parent=Parent
    lpBar->Handle=CreateWindowEx(0, PROGRESS_CLASS, "", WS_CHILD, _
                                    lpBar->Left, lpBar->Top, lpBar->Width, lpBar->Height, _
                                                                Parent, lpBar->ObjIndex, 0, 0)
    lpBar->PostConfig()

    lpTimer->Parent=Parent
    SetTimer(Parent, lpTimer->ObjIndex, lpTimer->Interval, 0)
END SUB

'-------------------------------------------------------------------------------
' Remove Timers on Exit
'-------------------------------------------------------------------------------
SUB KillAllTimers

    KillTimer(Application.hMainForm, SYS_TIMER_IDX)
    lpTimer->Enabled=False
    KillTimer(Application.hMainForm, lpTimer->ObjIndex)
END SUB

'-------------------------------------------------------------------------------
' System timer - Display hints
'-------------------------------------------------------------------------------
SUB SysDisplayHint(Parent AS HWND, HintString AS string)
DIM AS TOOLINFO ti

    ti.cbSize=sizeof(ti)
    ti.uFlags=TTF_SUBCLASS: ti.hwnd=Parent
    ti.hinst=NULL: ti.lpszText=STRPTR(HintString)
    GetClientRect(Parent, @ti.rect)

    Application.hWndTTip=CreateWindowEx(WS_EX_TOPMOST, TOOLTIPS_CLASS, "", _
                                    WS_POPUP OR TTS_NOPREFIX OR TTS_ALWAYSTIP, _
                   CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, _
                                                                Parent, 0, 0, 0)
    SetWindowPos(Application.hWndTTip, HWND_TOPMOST, 0, 0, 0, 0, _
                                      SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOACTIVATE)
    SendMessage(Application.hWndTTip, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))	
END SUB

SUB CheckSystemTimers
STATIC AS HWND TT_LastHWND
DIM AS HWND TT_hWnd
DIM AS Point TT_pnt
DIM AS integer ShowIt=False

    TT_pnt.X=Screen.MouseX: TT_pnt.Y=Screen.MouseY
    TT_hWnd=WindowFromPoint(TT_pnt)
    IF TT_LastHWND<>TT_hWnd THEN
        TT_LastHWND=TT_hWnd
        SELECT CASE TT_hWnd
            CASE lpForm1->Handle
                IF lpForm1->ShowHint THEN
                    SysDisplayHint(lpForm1->Handle, lpForm1->Hint)
                    ShowIt=True
                END IF
            CASE lpBtn->Handle
                IF lpBtn->ShowHint THEN
                    SysDisplayHint(lpBtn->Handle, lpBtn->Hint)
                    ShowIt=True
                END IF
        END SELECT
        IF (ShowIt=False) AND (Application.hWndTTip <> 0) THEN
            DestroyWindow(Application.hWndTTip)
            Application.hWndTTip=0
        END IF
    END IF
END SUB

'-------------------------------------------------------------------------------
' Start of Main WndProc code
'-------------------------------------------------------------------------------
SUB CheckWmCommandMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)

    SELECT CASE LOWORD(wParam)
        CASE lpBtn->ObjIndex
            IF lpBtn->OnClick>0 THEN lpBtn->OnClick(lpBtn)
    END SELECT
END SUB

SUB CheckWmPaintMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)

    IF lpForm1->OnPaint>0 THEN lpForm1->OnPaint(lpForm1)
END SUB

SUB CheckWmTimers(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)

    SELECT CASE wParam
        CASE App_Timer.ObjIndex:  CheckSystemTimers

        CASE lpTimer->ObjIndex
            IF lpTimer->OnTimer>0 THEN lpTimer->OnTimer(lpTimer)

    END SELECT
END SUB

SUB CheckWmNotifyMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB


SUB CheckWmHitTest(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB


SUB CheckWmObjScroll(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmDrawItem(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmContextMenu(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB


FUNCTION WndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    
    SELECT CASE wMsg
        CASE WM_COMMAND
            IF lParam<>0 THEN
                CheckWmCommandMsg(hWnd, wMsg, wParam, lParam)
            ELSE
                IF HIWORD(wParam) = 0 THEN                              ' Menu msg?
                    fnMenuPtr(LOWORD(wParam))                           ' Call user sub
                    RETURN 0
                ' ELSE
                '     Accelerator message code goes here...
                END IF
            END IF

        CASE WM_PAINT
            CheckWmPaintMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_TIMER
            CheckWmTimers(hWnd, wMsg, wParam, lParam)

        CASE WM_NCHITTEST
            CheckWmHitTest(hWnd, wMsg, wParam, lParam)

        CASE WM_NOTIFY
            CheckWmNotifyMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_HSCROLL, WM_VSCROLL
            IF lParam<>0 THEN CheckWmObjScroll(hWnd, wMsg, wParam, lParam)

        CASE WM_DRAWITEM
            CheckWmDrawItem(hWnd, wMsg, wParam, lParam)

        CASE WM_MOUSEMOVE
            IF lpForm1->OnMouseMove>0 THEN lpForm1->OnMouseMove(LOWORD(lParam), _
                                                            HIWORD(lParam), 0, lpForm1)
        CASE WM_LBUTTONDBLCLK
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_LBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_RBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_RBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_CONTEXTMENU
            CheckWmContextMenu(hWnd, wMsg, wParam, lParam)

        CASE WM_KEYDOWN
            IF lpForm1->OnKeyDown>0 THEN lpForm1->OnKeyDown(LOWORD(wParam), 0, lpForm1)

        CASE WM_KEYUP
            IF lpForm1->OnKeyUp>0 THEN lpForm1->OnKeyUp(LOWORD(wParam), 0, lpForm1)

        CASE WM_CHAR
            IF lpForm1->OnKeyPress>0 THEN lpForm1->OnKeyPress(LOBYTE(wParam), lpForm1)

        CASE WM_CREATE

        CASE WM_LOAD_COMPONENTS
            AddChildObjects
            InitSystemTimers(hWnd)

        CASE WM_CLOSE
            DIM AS integer Action=1                                      ' Default Action is quit
            IF lpForm1->OnClose>0 THEN lpForm1->OnClose(Action, lpForm1) ' Action passed by reference so
            IF Action=0 THEN RETURN 0                                    ' user can change default action

        CASE WM_DESTROY
            KillAllTimers()
            PostQuitMessage(0)

    END SELECT

    RETURN DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'-------------------------------------------------------------------------------
' WndProc hooks for additional components
'-------------------------------------------------------------------------------
'
' ***Add additional WndProcs as required***
'

'-------------------------------------------------------------------------------
' Main startup code
'-------------------------------------------------------------------------------
FUNCTION WinMain(hInst AS HINSTANCE, hPrevInstance AS HINSTANCE, _
                            szCmdLine AS string, iCmdShow AS integer) AS integer
DIM AS MSG wMsg

WITH wc
    .cbSize = SizeOf(WNDCLASSEX)
    .style = CS_HREDRAW OR CS_VREDRAW
    .lpfnWndProc = @WndProc
    .hInstance = hInst
    .hIcon = LoadIcon(0, IDI_APPLICATION)
    .hCursor = LoadCursor(0, IDC_ARROW)
    .hbrBackground = Cast(HBRUSH, COLOR_WINDOW)
    .lpszClassName = @"RQClass"
    .hIconSm = .hIcon
END WITH

    IF RegisterClassEx(@wc) = 0 THEN
        ShowMessage("Register class error")
        RETURN 0
    END IF

    lpForm1->Parent = 0
    lpForm1->Handle = CreateWindowEx(0, "RQClass", lpForm1->Caption, _
                    WS_OVERLAPPEDWINDOW, _
                    lpForm1->Left, lpForm1->Top, lpForm1->Width, lpForm1->Height, _
                    0, 0, hInst, 0)
    Application.hMainForm = lpForm1->Handle

    ' Load remainder of components
    ConfigureComponents()
    LoadComponents()

    ' You may wish to delete the following line
    lpForm1->Center

    IF lpForm1->OnShow>0 THEN lpForm1->OnShow(lpForm1)
    ShowWindow(lpForm1->Handle, SW_SHOW)

    HookTheMouse()
'
'   The following loop is the equivalent of a "Form.ShowModal"
'
    WHILE GetMessage(@wMsg, NULL, 0, 0) <> FALSE
        TranslateMessage(@wMsg)
        DispatchMessage(@wMsg)
    WEND

    UnHookTheMouse()

    RETURN wMsg.wParam
END FUNCTION
'
' Main Entry Point
'
END WinMain(Application.hInstance, NULL, Command(), SW_NORMAL)

'-------------------------------------------------------------------------------
' Code for the component events
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
' User added event Subs & code
'-------------------------------------------------------------------------------
SUB Menu_Select(Index AS integer)
DIM AS string tstr="Last menu selected: id " & Index
DIM AS MENUITEMINFO mii
DIM AS integer i

    StatBar.SimpleText=tstr
    SELECT CASE Index
        CASE MENUID_FILE_OPEN
            GetFileName
        CASE MENUID_FILE_SAVE
            SaveFileName
        CASE MENUID_FONT_DLG
            SetFont
        CASE MENUID_COLOR_DLG
            SetColor
        CASE MENUID_PRINT_DLG
            SetPrint                                        ' no actual print done
        CASE MENUID_FILE_EXIT
            StatBar.SimpleText="Menu exit"
            Application.Terminate
        CASE MENUID_SEARCH_REPLACE
'            CLEAR(@mii,0,SIZEOF(mii))
'            mii.cbSize=SIZEOF(mii)
'            mii.fMask=MIIM_ID OR MIIM_CHECKMARKS
'            mii.wID=MENUID_SEARCH_REPLACE
'
'            GetMenuItemInfo(mnuSearch,MENUID_SEARCH_REPLACE,0,@mii)
'            IF mii.fState=MFS_CHECKED THEN
'                ShowMessage("Checked")
'            ELSE
'                ShowMessage("FIXME: unChecked!")
'            END IF
        CASE MENUID_ABOUT
            ShowAbout
    END SELECT
END SUB

SUB GetFileName
DIM opn AS QOPENDIALOG

    ' using all defaults
    IF opn.Execute THEN
        ShowMessage("Selected: "+opn.Filename)
    END IF
    ' Set some properties
    opn.Caption="My very own open dialog"
    opn.Filter="Bas Files (*.bas)|*.bas|Include Files (*.bi)|*.bi|All Files (*.*)|*.*"
    opn.FilterIndex=2
    opn.InitialDir="C:\"
    IF opn.Execute THEN
        ShowMessage("Selected: "+opn.Filename)
    END IF
END SUB

' The progress bar is just for demo purposes
SUB SaveFileName
DIM sav AS QSAVEDIALOG

    sav.Filter="Text Files (*.txt)|*.txt|All Files (*.*)|*.*"
    sav.FilterIndex=1
    IF sav.Execute THEN
        lpBar->Position=1
        lpBar->Visible=True                     ' A visible "save indicater"?
        ShowMessage("Save file name: "+sav.filename+CRLF+"(with a demo progress bar indicater)")
    END IF
END SUB

' FontDialog returns the handle to the new font or 0
SUB SetFont
DIM fntDlg AS QFONTDIALOG
DIM nuFont AS HFONT

    nuFont=fntDlg.Execute
    IF nuFont THEN SendMessage(lpLbl->Handle,WM_SETFONT,CAST(WPARAM,nuFont),1)
END SUB

SUB SetColor
DIM colr AS QCOLORDIALOG

    ' Some presets to override defaults
    colr.Color=&hff0000
    colr.Style=cdFullOpen
    IF colr.Execute THEN
        ShowMessage("You chose &h"+HEX(colr.Color))
    END IF
END SUB

SUB SetPrint
DIM prnt AS QPRINTDIALOG

    prnt.AllowToFile=False
'    prnt.AllowToNetwork=False
    IF prnt.Execute THEN
        ShowMessage("Printer selected: "+prnt.PrinterName)
    END IF
'    IF OPEN lpt("LPT:" + prnt.PrinterName + ",EMU=TTY", FOR OUTPUT, AS #1) <> 0 THEN
'        ShowMessage("Error: Printer open failed")
'        EXIT SUB
'    END IF
'    ShowMessage("Printing to: "+prnt.PrinterName)
'    PRINT #1, "Hello, world!"
'    CLOSE #1
END SUB

SUB UpDownChange(Sender AS QUPDOWN)
    lpStat->SimpleText="Current count: "+STR(Sender.Position)
END SUB

SUB TimeOut(Sender AS QTIMER)
    IF lpBar->Visible=False THEN EXIT SUB
    IF lpBar->Position < lpBar->Max THEN
        lpBar->Position = lpBar->Position + 1
        IF lpBar->Position=lpBar->Max THEN lpBar->Visible=False
    END IF
END SUB

SUB ShowAbout
DIM AS string tstr

    tstr="Demo of some of the dialogs, UpDown Spin control & ProgressBar."+CRLF
    tstr=tstr+"Also some additional components that have not been integrated"+CRLF
    tstr=tstr+"into RQInclude.bi yet, and include:"+CRLF
    tstr=tstr+"Menus (Edit & Search menus demonstrate different properties)"+CRLF+CRLF
    tstr=tstr+"ToolBar and ReBar in two separate files."+CRLF+CRLF
    ShowMessage(tstr)
END SUB

SUB ExitClick(Sender AS QBUTTON)
    Application.Terminate
END SUB
