 '*******  globals *********

'------------------------------------------------------------------------------


'-----  constants  ------------
CONST CRLF = CHR$(13) + CHR$(10)
CONST Quot$ = CHR$(34)
CONST TAB = CHR$(9)
CONST sQuot = CHR$(39)                                  'single quote mark
CONST Comma = CHR$(44) 
CONST FileTabDelimitr = CHR$(187) 'CHR$(131)            'for searching across File tabControl
CONST LineNumDelimitr = CHR$(255)                       'for getting a line number out of QListView (SubItems doesn't work on sort)
CONST cDebugFileName = "freeqdebug___"                  'debugger output file without extension
CONST gSubstitutionsString = "%FILE% = FileName of active file" + CRLF + _
                              "%FILENAME% = Full path and FileName of active file" + CRLF + _
                              "%EXT% = File extension of active file" + CRLF + _
                              "%FULLPATHNOEXT% = Full path, no extension of active file" + CRLF + _
                              "%FILENAMENOEXT% = Filename, no extension of active file" + CRLF + _
                              "%CURRPATH% = Current Path" + CRLF + _
                              "%PATH% = Path of active file" + CRLF + _
                              "%APPPATH% = Path of FreeQ exe"

  
                                                       
'--------  RapidQ Objects ----------------             
DIM MFE_List            AS QSTRINGLIST                 '--- list of file names in all tabs
DIM IDE_RecentFileList  AS QSTRINGLIST                 '--- list of recently opened file names
DIM tmpList             AS QSTRINGLIST                 '--- temporary list -- use in sub then forget it
DIM fDialog             AS QFILEDIALOG                 'open save dialog for multiselection
DIM gMem                AS QMEMORYSTREAM               'global memorystream
DIM gFStream            AS QFILESTREAM                 'global memorystream
DIM IDE_ColorSelector   AS QColorDialog                'global color dialog
DIM FontDialog          AS QFONTDIALOG                 'global font dialog
DIM ini                 AS QINI                        'read ini files
DIM IDE_InactiveFont    AS QFONT                        'general trash Font
'    IDE_InactiveFont.Name = "Times New Roman"
    IDE_InactiveFont.Size = 9
    IDE_InactiveFont.Bold = False


CREATE SubFuncImageList AS QImageList
    Height = 16
    Width = 8
    AddICOHandle SUB_ICO
    AddICOHandle FUNC_ICO
END CREATE



'-----  variables at run-time -------------
DEFINT zzz                                             'trash global integer
DEFINT Screen_Width = GetSystemMetrics(SM_CXVIRTUALSCREEN )'in case we have dual monitors...
DEFINT Screen_Height = GetSystemMetrics(SM_CYVIRTUALSCREEN ) 
DEFSTR TheMainIniFile = Application.Path + "\FreeQ.ini"
DEFINT IDE_MAX_FILES = 47                              
DEFINT IDE_MAX_RECENTFILES = 15                        


TYPE IDE_TYPE <MaxDim> EXTENDS QOBJECT
    ' ==== basic setup for mainform  ====
    MainFormLeft                AS INTEGER
    MainFormTop                 AS INTEGER
    MainFormWidth               AS INTEGER
    MainFormHeight              AS INTEGER
    ShowSplashScreen            AS INTEGER
    RightSplitterPos            AS INTEGER
    LeftSplitterPos             AS INTEGER

    ViewStatusBar               AS INTEGER
    ViewQuickSearch             AS INTEGER
    ViewLeftPanel               AS INTEGER
    ViewRightPanel              AS INTEGER
    ViewBottomPanel             AS INTEGER
    ViewTopPanel                AS INTEGER
    ViewFileToolPanel           AS INTEGER
    ViewEditToolPanel           AS INTEGER
    ViewCompileToolPanel        AS INTEGER
    ViewViewToolPanel           AS INTEGER
    ViewCodeFoldingToolPanel    AS INTEGER
    ViewFormatToolPanel         AS INTEGER
    ViewBookMarkToolPanel       AS INTEGER
    ViewIconToolPanel           AS INTEGER
    ViewWidgetToolPanel         AS INTEGER


    ' =========== hilighting colors =============
    MainFont                    AS QFONT
    BackGround                  AS INTEGER     'no fore ground use MainFont
    SelectionFore               AS INTEGER
    SelectionBack               AS INTEGER
    LineNumbersFore             AS INTEGER
    LineNumbersBack             AS INTEGER
    ActiveLineBack              AS INTEGER

    CommentFore                 AS INTEGER
    CommentBack                 AS INTEGER      'backgr color
    CommentBold                 AS INTEGER
    CommentItalic               AS INTEGER
    CommentUnderL               AS INTEGER

    NumberFore                  AS INTEGER
    NumberBack                  AS INTEGER      'backgr color
    NumberBold                  AS INTEGER
    NumberItalic                AS INTEGER
    NumberUnderL                AS INTEGER

    StringFore                  AS INTEGER
    StringBack                  AS INTEGER      'backgr color
    StringBold                  AS INTEGER
    StringItalic                AS INTEGER
    StringUnderL                AS INTEGER

    PreProcessorFore            AS INTEGER
    PreProcessorBack            AS INTEGER      'backgr color
    PreProcessorBold            AS INTEGER
    PreProcessorItalic          AS INTEGER
    PreProcessorUnderL          AS INTEGER

    OperatorFore                AS INTEGER
    OperatorBack                AS INTEGER
    OperatorBold                AS INTEGER
    OperatorItalic              AS INTEGER
    OperatorUnderL              AS INTEGER

    KeywordFore                 AS INTEGER
    KeywordBack                 AS INTEGER
    KeywordBold                 AS INTEGER
    KeywordItalic               AS INTEGER
    KeywordUnderL               AS INTEGER

    Keyword2Fore                AS INTEGER
    Keyword2Back                AS INTEGER
    Keyword2Bold                AS INTEGER
    Keyword2Italic              AS INTEGER
    Keyword2UnderL              AS INTEGER

    Keyword3Fore                AS INTEGER
    Keyword3Back                AS INTEGER
    Keyword3Bold                AS INTEGER
    Keyword3Italic              AS INTEGER
    Keyword3UnderL              AS INTEGER

    FileTabContolBack           AS INTEGER
    FileTabContolInactive       AS INTEGER


    ' === editor specific =====
    SearchFlag                  AS INTEGER          'search flags for find/replace
    HiLighting                  AS INTEGER          'toggle on/off
    LineNumbers                 AS INTEGER
    UseTabs                     AS INTEGER
    TabSpaces                   AS INTEGER
    CodePage                    AS INTEGER
    AutoIndent                  AS INTEGER
    CodeFolding                 AS INTEGER
    CodeFoldCollapseAll         AS INTEGER
    CodeFoldExpandAll           AS INTEGER
    ViewIndents                 AS INTEGER
    FontZoom                    AS INTEGER
    WordWrap                    AS INTEGER
    ViewBookMarks               AS INTEGER
    LastTab                     AS INTEGER          'go back to last file tab
    CurrTab                     AS INTEGER          'this is to store for OnChange event
    TabBeforeFindDecl           AS INTEGER          'allow to go back/return after find definition
    CursorBeforeFindDecl        AS INTEGER          'and it's curor location

    ' ====  compiler specific variables  =====
    MFEActiveProject            AS STRING
    MFEActiveFile               AS STRING
    ActiveFile                  AS STRING
    NewFileIndex                AS INTEGER
    MainFileForCompiler         AS STRING
    FilesWereModified           AS INTEGER
    CompiledOK                  AS INTEGER      'did compile work?

    FileFilter                  AS STRING
    LastDir                     AS STRING
    UseAppDirectory             AS INTEGER      'set directory to main app when compiling source, overrides Path
    ConstPath                   AS STRING       'use a constant path when compiling source
    Path                        AS STRING       'set directory to this path when compiling source
    CompilerPath                AS STRING       'path to find the compiler
    CompilerLibPath             AS STRING
    CompilerIncPath             AS STRING
    CompilerIconPath            AS STRING
    CompilerHelpFile            AS STRING
    CompilerTemplatePath        AS STRING

    FBCompilerPath              AS STRING
    FBCommandLine               AS STRING
    FBCompilerHelpFile          AS STRING
    FBRunCmd                    AS STRING
    FBPauseAfterRun             AS INTEGER
    FBRunAfterFile              AS STRING
    IsJava                      AS INTEGER

    IconName                    AS STRING
    OptimizeOn                  AS INTEGER
    TypeCheckOn                 AS INTEGER
    VerboseOn                   AS INTEGER
    ByteCodeOn                  AS INTEGER
    GenerateManifest            AS INTEGER
    SaveFileBeforeCompile       AS INTEGER
    SaveAllBeforeCompile        AS INTEGER
    ScriptBeforeCompile         AS STRING

    DefaultLexLanguage          AS INTEGER      'default lexer language for SciLexer
    HiLightCompileErr           AS INTEGER      'toggle compile error line highlighting
    HiLightTurnOFF              AS INTEGER      'turn off temporary line highlighting after sub/func search, compile error
    ShowSubsAfterLoad           AS INTEGER
    SortSubs                    AS INTEGER
    SaveSettingsOnExit          AS INTEGER
    SingleInstanceOnly          AS INTEGER
    BackupFiles                 AS INTEGER
    BackupFilesExt              AS STRING
    HighlightBraces             AS INTEGER
    AutoComplete                AS INTEGER
    NewTabAtStartup             AS INTEGER
    AutoOpenLastProj            AS INTEGER
    FindDeclDialogBox           AS INTEGER
    ShowWelcome                 AS INTEGER
    NewFileName                 AS STRING
    NewFileAutoSave             AS INTEGER
    MenuIcons                   AS INTEGER
    DebugFileName               AS STRING

    AutoDeclClipboardActiveFile AS INTEGER
    AutoDeclClipboardAllFiles   AS INTEGER
    AutoDeclAtTopActiveFile     AS INTEGER
    AutoDeclAtTopAllFiles       AS INTEGER
    AutoDeclInFile              AS INTEGER
    AutoDeclInFileName          AS STRING

    CancelOnClose               AS INTEGER      'signal cancelling out of cancel loops, etc (use this since SUB can't return value)
    FileMonitorHook             AS INTEGER      'keep track of file changes in a directory


    BeautifyCodeTabSpaces       AS INTEGER      'Beautify code spaces for each tab
    BeautifyCodeCommentSpaces   AS INTEGER      ' spaces for comments


    'external applications
    HomePage                    AS STRING
    SearchEngine                AS STRING
    ExternalApp1                AS STRING
    ExternalApp2                AS STRING
    ExternalApp3                AS STRING
    ExternalApp4                AS STRING

    'specific external applications
    upx                         AS STRING      'need this for un/re -pack of exe for modifying resources
    ResHacker                   AS STRING      'to change the icon, assembly information in resources
    DecompressEXE               AS INTEGER      'should we decompress the output exe -- may help in virus warning, or whatever

    'embedded resources
    EmbedManifest               AS INTEGER
    EmbedVersionInfo            AS INTEGER
    FileVersion                 AS STRING
    ProductVersion              AS STRING
    CompanyName                 AS STRING
    CompanyEmail                AS STRING
    FileDescription             AS STRING
    LegalCopyright              AS STRING

    'custom menu lists
    MenuShortCutFile            AS STRING       'if not null contains a file with menu captions, shortcuts and visible properties
    MenuShortCutList            AS STRING       'list of all menu captions, shortcuts and visible prop
    MenuFuncPtr(1024)           AS INTEGER      'menu short-cut keys to function pointer conversion
                                                'bit 10 (high) = Shift key is pressed (1024)
                                                'bit 9 (high) = Alt key is pressed  (512)
                                                'bit 8 (high) = Ctrl key is pressed (256)
                                                'bits 0-7 = virtual key code pressed (0-255)

    'specific variables for each document
    DocPtr(MaxDim)              AS LONG         'pointers to multiple documents in QScintilla
    CursorPos(MaxDim)           AS LONG         'where was the cursor when switching between tabs
    AnchorPos(MaxDim)           AS LONG         'where was the anchor when switching between tabs
    FirstLine(MaxDim)           AS LONG         'First line visible when switching between tabs
    BookMark(MaxDim, 19)        AS LONG         'list of line # that have a bookmark, max 20 bookmarks/document
    BookMarkCount(MaxDim)       AS LONG
    ListIncludes(MaxDim)        AS QSTRINGLIST  'list of include files for each file
    ListResources(MaxDim)       AS QSTRINGLIST  'list of resource files for each file
    LexLanguage(MaxDim)         AS INTEGER      'lexer language for Scintilla (ie SCLEX_VB)
    ModuleType(MaxDim)          AS INTEGER      'what type of module? 0 = default (RapidQ), 1 = FreeBasic, 2 = Freebasic DLL,
    ProjectTreeParsed(MaxDim)   AS INTEGER      'keep track if the projectTree is already parsed and loaded

    'Keyword lookups for highlighting
    KeyWordList                 AS QSTRINGLIST
    KeyWordList2                AS QSTRINGLIST
    KeyWordList3                AS QSTRINGLIST
    KeyWordLookUp               AS QSTRINGLIST  'quick help

    KeyWordListFile             AS STRING       'custom file for keywords
    KeyWordListFile2            AS STRING       'for properties / methods
    KeyWordListFile3            AS STRING       'for spare keyword highlighting


    ' menu item icons
    BackBMP                     AS QBITMAP
    gBMP                        AS QBITMAP      'global bitmap
    hDC                         AS INTEGER      'for general device context

    '-----  set defaults -----------
    SUB NEW
      WITH IDE_TYPE
        .MainFormLeft = 48
        .MainFormTop = 48
        .MainFormWidth = Screen.ClientWidth - 80
        .MainFormHeight = Screen.ClientHeight - 120      'give large buffer
        .ShowSplashScreen = True
        .RightSplitterPos = .MainFormWidth * 0.8        '80%
        .LeftSplitterPos = .MainFormWidth * 0.2         '20%


        'tool bar views
        .ViewStatusBar            = True
        .ViewQuickSearch          = True
        .ViewLeftPanel            = False
        .ViewRightPanel           = True
        .ViewBottomPanel          = True
        .ViewTopPanel             = True
        .ViewFileToolPanel        = True
        .ViewEditToolPanel        = True
        .ViewCompileToolPanel     = True
        .ViewViewToolPanel        = True
        .ViewCodeFoldingToolPanel = True
        .ViewFormatToolPanel      = True
        .ViewBookMarkToolPanel    = True
        .ViewIconToolPanel        = True
        .ViewWidgetToolPanel      = False


        .BackGround      = clWhite
        .SelectionFore   = clBlack
        .SelectionBack   = RGB(186,186,186)
        .LineNumbersFore = clBlack
        .LineNumbersBack = RGB(181,197,219)
        .ActiveLineBack = -1                     'turn off
    
        .CommentFore     = RGB(0,128,12)
        .CommentBack     = RGB(255,255,250)      'drk green on vanilla
        .CommentBold     = False
        .CommentItalic   = True
    
        .NumberFore      = RGB(90,16,0)
        .NumberBack      = clWhite  
        .NumberBold      = False
    
        .StringFore      = RGB(102,23,14)
        .StringBack      = clWhite
        .StringBold      = False
    
        .PreProcessorFore    = RGB(0,6,214)
        .PreProcessorBack    = clWhite
        .PreProcessorBold    = True
    
        .OperatorFore   = RGB(0,12,45)
        .OperatorBack   = clWhite 
        .OperatorBold   = False
         
        .KeywordFore    = RGB(0,35,202)
        .KeywordBack    = clWhite
        .KeywordBold    = False
    
        .Keyword2Fore    = RGB(134,35,35)
        .Keyword2Back    = clWhite
        .Keyword2Bold    = False
    
        .Keyword3Fore    = clBlack
        .Keyword3Back    = clWhite
        .Keyword3Bold    = False
    
        .MainFont.Name          = "Courier New"
        .MainFont.Color         = 0
        .MainFont.Size          = 10
        .MainFont.Bold          = False
        .MainFont.Italic        = False
                               
        .FileTabContolBack      = RGB( 240, 240, 240 )
        .FileTabContolInactive  = RGB(201,201,201)
        .HiLighting             = True
        .LineNumbers            = True
        .UseTabs                = False
        .TabSpaces              = 4
        .CodePage               = 0         'single byte, ascii
        .AutoIndent             = False
        .WordWrap               = False
        .CodeFolding            = False
        .CodeFoldCollapseAll    = False
        .CodeFoldExpandAll      = True
        .ViewIndents            = False
        .FontZoom               = 0
        .ViewBookMarks          = False
        .LastTab                = -1


        .ConstPath              = ""            'no set path
        .UseAppDirectory        = True          'set to  app path, easy for F5 run and go!
        .Path                   = CurDir$       'so now set it
        .FileFilter             = "RapidQ files|*.bas;*.rqb;*.rq;*.rqw;*.inc;*.QProj|Include|*.inc|All files|*.*"
        .LastDir                = ""
        .CompilerPath           = IDE_AttemptToFindFile("\Rapidq\rc.exe")
        .CompilerLibPath        = IDE_AttemptToFindFolder("\Rapidq\lib")
        .CompilerIncPath        = IDE_AttemptToFindFolder("\Rapidq\include")
        .CompilerIconPath       = IDE_AttemptToFindFolder("\Rapidq\icon")
        .CompilerHelpFile       = IDE_AttemptToFindFile("\Rapidq\help\rapidq.chm")
        .CompilerTemplatePath   = IDE_AttemptToFindFolder("\Rapidq\templates")

        .FBCompilerPath         = IDE_AttemptToFindFile("\Program Files\FreeBasic\fbc.exe")
        .FBCommandLine          = ""
        .FBCompilerHelpFile     = IDE_AttemptToFindFile("\Program Files\FreeBasic\freebasic.chm")
        .FBRunCmd               = ""
        .FBPauseAfterRun        = 0
        .FBRunAfterFile         = ""
        .IsJava                 = False

        .OptimizeOn             = False
        .TypeCheckOn            = True
        .VerboseOn              = False
        .ByteCodeOn             = False
        .GenerateManifest       = False
        .SaveFileBeforeCompile  = True
        .SaveAllBeforeCompile   = False
        .ScriptBeforeCompile    = ""
        .MFEActiveProject       = ""

        .DefaultLexLanguage          = SCLEX_VB     'this covers RQ very well
        .HiLightCompileErr           = True         'toggle compile error line highlighting
        .HiLightTurnOFF              = False
        .ShowSubsAfterLoad           = True
        .SortSubs                    = True
        .SaveSettingsOnExit          = True
        .SingleInstanceOnly          = False
        .BackupFiles                 = False
        .BackupFilesExt              = ".~bck"
        .HighlightBraces             = True
        .AutoComplete                = False
        .NewTabAtStartup             = False
        .AutoOpenLastProj            = False
        .FindDeclDialogBox           = False
        .ShowWelcome                 = False
        .NewFileName                 = "~New"
        .NewFileAutoSave             = True
        .DebugFileName               = ""           'run in debugger sets this
        .MenuIcons                   = False
    
        .AutoDeclClipboardActiveFile = True
        .AutoDeclClipboardAllFiles   = False
        .AutoDeclAtTopActiveFile     = False
        .AutoDeclAtTopAllFiles       = False
        .AutoDeclInFile              = False
        .AutoDeclInFileName          = "QDeclare.inc"

        .MainFileForCompiler    = ""
        .FilesWereModified      = False
        .CompiledOK             = False

        .HomePage               = "http://tech.groups.yahoo.com/group/rapidq/"
        .SearchEngine           = "http://www.google.com/search?hl=en&source=hp&q="
        .ExternalApp1           = ""
        .ExternalApp2           = ""
        .ExternalApp3           = ""
        .ExternalApp4           = ""
        .upx                    = IDE_AttemptToFindFile(Application.Path + "\tools\upx.exe")
        .ResHacker              = IDE_AttemptToFindFile(Application.Path + "\tools\ResHacker.exe")
        .DecompressEXE          = False

        .EmbedManifest          = False
        .EmbedVersionInfo       = False
        .FileVersion            = "1,0,0,0"
        .ProductVersion         = "1,0,0,0"
        .CompanyName            = "My Company"
        .CompanyEmail           = "me@Company.com"
        .FileDescription        = "program developed in FreeQ"
        .LegalCopyright         = "Copyright 2012, my company"

        .MenuShortCutFile       = ""

        .CancelOnClose          = False         'only for return value of CANCEL during Closing files
        .FileMonitorHook        = -1

        .BeautifyCodeTabSpaces   = 4
        .BeautifyCodeCommentSpaces   = 0

        .KeyWordListFile        = ""
        .KeyWordListFile2       = ""
        .KeyWordListFile3       = ""

        'keyword lists.... 1st list is highest priority in autocomplete ...
        .KeyWordList.AddItems(_
                "$apptype", _
                "$define", _
                "$endif", _
                "$escapechars", _
                "$ifdef", _
                "$ifndef", _
                "$include", _
                "$optimize", _
                "$option", _
                "$typecheck", _
                "$undef", _
                "as", _
                "byref", _
                "bytecode", _
                "case", _
                "cgi", _
                "clipboard.", _
                "clipboard.clear", _
                "clipboard.close", _
                "clipboard.open", _
                "clipboard.text", _
                "clipboard.getastext", _
                "clipboard.setastext", _
                "clipboard.getashandle", _
                "clipboard.setashandle", _
                "const", _
                "console", _
                "constructor", _
                "create", _
                "decimal", _
                "declare", _
                "dim", _
                "do", _
                "else", _
                "elseif", _
                "end", _
                "explicit", _
                "extractresource", _
                "for", _
                "function", _
                "functioni", _
                "gtk", _
                "gui", _
                "icon", _
                "if", _
                "loop", _
                "memcpy", _
                "memcmp", _
                "memset", _
                "next", _
                "off", _
                "on", _
                "printer", _
                "private", _
                "property", _
                "public", _
                "qform", _
                "qbutton", _
                "qbitmap", _
                "qcanvas", _
                "qcheckbox", _
                "qcombobox", _
                "qcoolbtn", _
                "qdirtree", _
                "qdxscreen", _
                "qdxtimer", _
                "qdximagelist", _
                "qd3dframe", _
                "qd3dmeshbuilder", _
                "qd3dface", _
                "qd3dlight", _
                "qd3dmesh", _
                "qd3dtexture", _
                "qd3dvector", _
                "qd3dvisual", _
                "qd3dwrap", _
                "qedit", _
                "qfilestream", _
                "qfilelistbox", _
                "qfont", _
                "qfontdialog", _
                "qgauge", _
                "qglassframe", _
                "qgroupbox", _
                "qheader", _
                "qimage", _
                "qimagelist", _
                "qlabel", _
                "qlistbox", _
                "qlistview", _
                "qmainmenu", _
                "qmenuitem", _
                "qmemorystream", _
                "qmysql", _
                "qnotifyicondata", _
                "qovalbtn", _
                "qopendialog", _
                "qobject", _
                "qolecontainer", _
                "qoleobject", _
                "qoutline", _
                "qpanel", _
                "qpopupmenu", _
                "qradiobutton", _
                "qrichedit", _
                "qrect", _
                "qregistry", _
                "qsavedialog", _
                "qscrollbar", _
                "qscrollbox", _
                "qstatusbar", _
                "qsocket", _
                "qsplitter", _
                "qstringlist", _
                "qstringgrid", _
                "qtabcontrol", _
                "qtimer", _
                "qtrackbar", _
                "qtreeview", _
                "qabout", _
                "qbitmapex", _
                "qcanvasex", _
                "qchart", _
                "qcolordialog", _
                "qdebug", _
                "qdir", _
                "qdockform", _
                "qfiledialog", _
                "qfontdialog", _
                "qformex", _
                "qformmdi", _
                "qimageex", _
                "qinputbox", _
                "qmenuex", _
                "qredex", _
                "qsplash", _
                "qstatusbarex", _
                "qstringgridex", _
                "qsystem", _
                "qcalendardlg", _
                "$resource", _
                "resource", _ 
                "resourcecount", _
                "select", _
                "sub", _
                "set", _
                "screen.", _
                "screen.mousex", _
                "screen.mousey", _
                "screen.height", _
                "screen.width", _ 
                "screen.consolex", _
                "screen.consoley", _
                "screen.cursor", _
                "screen.cursors", _
                "static", _
                "super", _
                "then", _
                "this", _
                "type", _
                "width", _
                "while", _
                "with")


    '===== Functions and general keywords 2nd highest priority in autocomplete list ===========
        .KeyWordList2.AddItems("and", _
                "abs", _
                "acos", _
                "alias", _
                "asc", _
                "asin", _
                "atan", _
                "atn", _
                "bin$", _
                "bind", _
                "byte", _
                "call", _
                "callback", _
                "callfunc", _
                "ceil", _
                "chdir", _
                "chdrive", _
                "chr$", _
                "cint", _
                "clng", _
                "cls", _
                "codeptr", _
                "command$", _
                "commandcount", _
                "convbase$", _
                "cos", _
                "csrlin", _
                "defint", _
                "data", _
                "date$", _
                "dec", _
                "deflng", _
                "defstr", _
                "defbyte", _
                "defdbl", _
                "defdword", _
                "defshort", _
                "defsng", _
                "defword", _
                "delete$", _
                "direxists", _
                "dir$", _
                "doevents", _
                "double", _
                "dword", _
                "environ", _
                "environ$", _
                "event", _
                "exit", _
                "exp", _
                "extends", _
                "fileexists", _
                "field$", _
                "fix", _
                "floor", _
                "frac", _
                "get$", _
                "gosub", _
                "goto", _
                "height", _
                "hex$", _
                "instr", _
                "iif", _
                "inc", _
                "initarray", _
                "inkey$", _
                "inp", _
                "input", _
                "input$", _
                "insert$", _
                "integer", _
                "int", _
                "inv", _
                "is", _
                "kill", _
                "lbound", _
                "left", _
                "lcase$", _
                "left$", _
                "len", _
                "lflush", _
                "lib", _
                "libraryinst", _
                "locate", _
                "log", _
                "long", _
                "lprint", _
                "ltrim$", _
                "messagebox", _
                "messagedlg", _
                "mid$", _
                "mkdir", _
                "mod", _
                "not", _
                "or", _
                "out", _
                "paramstr$", _
                "paramstrcount", _
                "paramval", _
                "paramvalcount", _
                "pcopy", _
                "playwav", _
                "poke", _
                "pos", _
                "print", _
                "quicksort", _
                "randomize", _
                "return", _
                "redim", _
                "result", _
                "rename", _
                "replace$", _
                "replacesubstr$", _
                "restore", _
                "rgb", _
                "right$", _
                "rinstr", _
                "rmdir", _
                "rnd", _
                "round", _
                "rtrim$", _
                "run", _
                "sendmessageapi", _
                "setfocus", _
                "setconsoletitle", _
                "sgn", _
                "shell", _
                "shl", _
                "short", _
                "showmessage", _
                "shr", _
                "single", _
                "sin", _
                "sizeof", _
                "sleep", _
                "sound", _
                "space$", _
                "sqr", _
                "string", _
                "string$", _
                "str$", _
                "strf$", _
                "step", _
                "stack.int", _
                "stack.str$", _
                "subi", _
                "swap", _
                "tally", _
                "tan", _
                "time$", _
                "timer", _
                "top", _
                "to", _
                "ucase$", _
                "until", _
                "ubound", _
                "unloadlibrary", _
                "udtptr", _
                "val", _
                "variant", _
                "varptr", _
                "varptr$", _
                "vartype", _
                "wend", _
                "weaktype", _
                "word", _
                "xor")

'        .KeyWordList3.Clear         'can leave as custom
        'properties...
        .KeyWordList3.AddItems("abortallio", _
                "accept", _
                "activeonly", _
                "additems", _
                "addstrings", _
                "addtabs", _
                "addbordericons", _
                "addchild", _
                "addchilditems", _
                "addcolumns", _
                "adddirtypes", _
                "adddrivetypes", _
                "addfiletypes", _
                "addlines", _
                "addoptions", _
                "addpanels", _
                "addsections", _
                "addstring", _
                "addstyles", _
                "addsubitem", _
                "addlight", _
                "addvisual", _
                "application.", _
                "application.Icon", _
                "application.IcoHandle", _
                "application.ExeName", _
                "application.Handle", _
                "application.HintColor", _
                "application.HintPause", _
                "application.HintHidePause", _
                "application.HelpFile", _
                "application.HintShortPause", _
                "application.Path", _
                "align", _
                "alignment", _
                "allowallup", _
                "allowclick", _
                "allowinplace", _
                "autoscroll", _
                "autoshow", _
                "autosize", _
                "backcolor", _
                "baudrate", _
                "bevelinner", _
                "bevelouter", _
                "bevelwidth", _
                "bitcount", _
                "bmp", _
                "bmphandle", _
                "bmpclosed", _
                "bmphandleclosed", _
                "bmphandleleaf", _
                "bmphandleminus", _
                "bmphandleopen", _
                "bmphandleplus", _
                "bmpleaf", _
                "bmpminus", _
                "bmpopen", _
                "bmpplus", _
                "borderstyle", _
                "bold", _
                "button", _
                "buttonstyle", _
                "caption", _
                "cancel", _
                "center", _
                "checked", _
                "checkboxes", _
                "charcase", _
                "circle", _
                "clientheight", _
                "clientwidth", _
                "clear", _
                "clearcolumns", _
                "close", _
                "closekey", _
                "color", _
                "colcount", _
                "colorhighlight", _
                "colorshadow", _
                "columnscount", _
                "columnclick", _
                "columnlist", _
                "columnstyle", _
                "colwidths", _
                "connect", _
                "connectionready", _
                "container", _
                "copytoclipboard", _
                "copyfrom", _
                "copymode", _
                "copyrect", _
                "createdb", _
                "createobject", _
                "createremote", _
                "cameralookat", _
                "createframe", _
                "createlightrgb", _
                "createmeshbuilder", _
                "curdir$", _
                "cursor", _
                "cuttoclipboard", _
                "databits", _
                "default", _
                "defaultcolwidth", _
                "defaultrowheight", _
                "delitems", _
                "delbordericons", _
                "deltabs", _
                "deletecol", _
                "deleterow", _
                "delfiletypes", _
                "dellines", _
                "deloptions", _
                "delsubitem", _
                "deldirtypes", _
                "deldrivetypes", _
                "directory", _
                "draw", _
                "dropdowncount", _
                "dropdb", _
                "drtcdrom", _
                "drtfixed", _
                "drtramdisk", _
                "drtremote", _
                "drtremovable", _
                "drtunknown", _
                "dtall", _
                "dthidden", _
                "dtnormal", _
                "dtreadonly", _
                "dtsystem", _
                "enabled", _
                "editormode", _
                "edittext", _
                "empty", _
                "escapestring", _
                "execute", _
                "extendedselect", _
                "extractres", _
                "false", _
                "family", _
                "fastload", _
                "fetchfield", _
                "fetchlengths", _
                "fetchrow", _
                "fieldseek", _
                "filename", _
                "fillrect", _
                "filter", _
                "fixedcolor", _
                "fixedcols", _
                "fixedrows", _
                "flat", _
                "flatbuttons", _
                "flatseperators", _
                "flip", _
                "focusbuttons", _
                "font", _
                "forecolor", _
                "formstyle", _
                "free", _
                "frequency", _
                "ftarchive", _
                "ftdirectory", _
                "fthidden", _
                "ftnormal", _
                "ftreadonly", _
                "ftsystem", _
                "ftvolumeid", _
                "fullcollapse", _
                "fullexpand", _
                "getashandle", _
                "getastext", _
                "gethostip", _
                "gethostname", _
                "getidofname", _
                "getobject", _
                "getpeername", _
                "goalwaysshoweditor", _
                "gocolmoving", _
                "gocolsizing", _
                "godrawfocusselected", _
                "goediting", _
                "gofixedhorzline", _
                "gofixedvertline", _
                "gohorzline", _
                "gorangeselect", _
                "gorowmoving", _
                "gorowselect", _
                "gorowsizing", _
                "gotabs", _
                "gothumbtracking", _
                "govertline", _
                "groupindex", _
                "gridheight", _
                "gridlines", _
                "gridlinewidth", _
                "gridwidth", _
                "handle", _
                "hasformat", _
                "hidescrollbars", _
                "hideselection", _
                "hidetitlebar", _
                "hint", _
                "horzincrement", _
                "horzmargin", _
                "horzposition", _
                "horzrange", _
                "horztracking", _
                "horzvisible", _
                "hottrack", _
                "icohandle", _
                "icon", _
                "init", _
                "insert", _
                "insertcol", _
                "insertrow", _
                "insertitem", _
                "insertsubitem", _
                "inserttab", _
                "interval", _
                "incrementaldisplay", _
                "inputmask", _
                "invoke", _
                "invokecopy", _
                "isclientready", _
                "isserverready", _
                "item", _
                "itemcount", _
                "itemheight", _
                "itemindex", _
                "itemseparator", _
                "keypreview", _
                "key", _
                "kind", _
                "labelstyle", _
                "largechange", _
                "largeimages", _
                "layout", _
                "line", _
                "linecount", _
                "linesize", _
                "load", _
                "loadfromfile", _
                "loadfromresource", _
                "loadfromstream", _
                "loadarray", _
                "lowercolor", _
                "lparam", _
                "mask", _
                "max", _
                "maxlength", _
                "maxwidth", _
                "memcopyfrom", _
                "memcopyto", _
                "min", _
                "minwidth", _
                "modalresult", _
                "modified", _
                "mousex", _
                "mousey", _
                "monochrome", _
                "move", _
                "multiline", _
                "multiselect", _
                "name", _
                "numbmps")

        'properties ... append, -- limited to 255 entries
        .KeyWordList3.AddItems("onbreak", _
                "onclick", _
                "onchange", _
                "onclose", _
                "oncolumnclick", _
                "ondblclick", _
                "ondrawcell", _
                "ondrawsection", _
                "onellipsisclick", _
                "onerror", _
                "oninitialize" _
                "oninitializesurface", _
                "onkeydown", _
                "onkeypress", _
                "onkeypressed", _
                "onkeyup", _
                "onlistdropdown", _
                "onmousedown", _
                "onmousemove", _
                "onmouseup", _
                "onmousewheel", _
                "onmoved", _
                "onobjectmove", _
                "onopen", _
                "onpaint", _
                "onresize", _
                "onring", _
                "onrxchar", _
                "onscroll", _
                "onsectionclick", _
                "onsectionresize", _
                "onsectiontrack", _
                "onselectcell", _
                "onsetedittext", _
                "onshow", _
                "ontimer", _
                "ontxempty", _
                "open", _
                "openkey", _
                "orientation", _
                "outlinestyle", _
                "pagesize", _
                "parent", _
                "paint", _
                "panel", _
                "parity", _
                "passwordchar", _
                "pastefromclipboard", _
                "peek", _
                "pixel", _
                "pixelformat", _
                "plaintext", _
                "popupmenu", _
                "port", _
                "position", _
                "protocol", _
                "pset", _
                "purgein", _
                "purgeout", _
                "query", _
                "readline", _
                "readinteger", _
                "readstring", _
                "readbinstr", _
                "readbufsize", _
                "readbyte", _
                "readnum", _
                "readonly", _
                "readstr", _
                "readudt", _
                "read", _
                "realconnect", _
                "rectangle", _
                "refresh", _
                "reload", _
                "render", _
                "repaint", _
                "rootkey", _
                "rotate", _
                "roundrect", _
                "rowblob", _
                "rowcount", _
                "rowheights", _
                "rowseek", _
                "rowselect", _
                "savetofile", _
                "savetostream", _
                "savearray", _
                "scale", _
                "scrollbars", _
                "scrollopposite", _
                "sender", _
                "seltext", _
                "selattributes", _
                "selectall", _
                "selectdb", _
                "selend", _
                "sellength", _
                "selstart", _
                "sections", _
                "seek", _
                "separator", _
                "setashandle", _
                "setastext",  _
                "setcameraposition", _
                "setposition", _
                "setquality", _
                "setrendermode", _
                "setrotation", _
                "settick", _
                "shapeform", _
                "show", _
                "showcolumnheaders", _
                "showhint", _
                "showicons", _
                "showmodal", _
                "showtext", _
                "showtitlebar", _
                "simpletext", _
                "simplepanel", _
                "size", _
                "sizegrip", _
                "sizemode", _
                "smallchange", _
                "smallimages", _
                "sorted", _
                "sorttype", _
                "spacing", _
                "state", _
                "stateimages", _
                "stopbits", _
                "stretch", _
                "stretchdraw", _
                "style", _
                "subitem", _
                "swapcols", _
                "swapitem", _
                "swaprows", _
                "tag", _
                "tab", _
                "tabheight", _
                "tabinactivecolor", _
                "tabinactivefont", _
                "taborder", _
                "tabposition", _
                "tabstops", _
                "tabwidth", _
                "text", _
                "terminate", _
                "textheight ", _
                "textout", _
                "textrect", _
                "textwidth", _
                "tickmarks", _
                "tickstyle", _
                "topindex", _
                "toprow", _
                "transparent", _
                "transparentcolor", _
                "transparentmode", _
                "true", _
                "underline", _
                "update", _
                "uppercolor", _
                "use3d", _
                "usehardware", _
                "vertposition ", _
                "vertrange", _
                "verticaltabs", _
                "verttracking ", _
                "vertvisible", _
                "vertincrement", _
                "vertmargin", _
                "visible", _
                "viewstyle", _
                "visiblecolcount", _
                "visiblerowcount", _
                "windowstate", _
                "waitforlastio", _
                "wanttabs", _
                "wmessage", _
                "wndproc", _
                "wordwrap", _
                "writeline", _
                "write", _
                "writebinstr", _
                "writebufsize", _
                "writebyte", _
                "writeinteger", _
                "writenum", _
                "writestr", _
                "writestring", _
                "writeudt")


        IF FILEEXISTS(Application.Path +"\tools\Qlookup.txt") THEN 
            .KeyWordLookUp.LoadFromFile (Application.Path +"\tools\Qlookup.txt")
        ELSEIF FILEEXISTS(Application.Path +"Qlookup.txt") THEN 
            .KeyWordLookUp.LoadFromFile (Application.Path +"Qlookup.txt")
        ELSE
            .KeyWordLookUp.Clear
        END IF

        DEFINT i
        FOR i = 0 TO MaxDim
            .DocPtr(i) = 0
            .CursorPos(i) = 0
            .AnchorPos(i) = 0
            .FirstLine(i) = 0
            .BookMarkCount(i) = 0
            .ListIncludes(i).Clear
            .ListResources(i).Clear
            .LexLanguage(i) = This.DefaultLexLanguage
            .ModuleType(i) = 0
            .ProjectTreeParsed(i) = False
        NEXT i
        MEMSET(VARPTR(This.BookMark(0, 0)), -1, 2 * (MaxDim+1) * SIZEOF(INTEGER))
        This.BackBMP.Width = 0
        This.BackBMP.Height = 0
        This.gBMP.Width = 0
        This.gBMP.Height = 0

      END WITH
    END SUB


    CONSTRUCTOR
        New
        MenuShortCutList  = ""                                          'don't add to NEW may corrupt on defaults
        'MEMSET(VARPTR(MenuFuncPtr(0)), 0, 1025 * SIZEOF(INTEGER))       'null function pointers 
    END CONSTRUCTOR

END TYPE

DIM IDE AS IDE_TYPE<IDE_MAX_FILES>
 
          