'-----------------------------------------------------------------------------------------
' RQInclude.bi Part of the RapidFRM project
' Main include file for FreeBasic windows applications
'
'   Based on RapidQ objects/components
'   Author: d_homans@yahoo.com.au
'   Version 1.60.2
'   Date:   21 Apr 2012
'-----------------------------------------------------------------------------------------
#UNDEF FALSE
#UNDEF TRUE
#DEFINE FALSE   0
#DEFINE TRUE    1

#IFNDEF PBM_SETBKCOLOR
#DEFINE PBM_SETBKCOLOR  8193                ' ProgressBar msg <=> CCM_SETBKCOLOR
#ENDIF
#IFNDEF TPM_NOANIMATION
#DEFINE TPM_NOANIMATION &h4000              ' Popup menu flag
#ENDIF
#IFNDEF UDN_DELTAPOS
#DEFINE UDN_DELTAPOS -722                   ' UpDown control
#ENDIF

#IFNDEF __win_commdlg_bi__
#INCLUDE "win/commdlg.bi"
#ENDIF

#IFNDEF __FILE_BI__
#INCLUDE "file.bi"
#ENDIF

#IFNDEF __crt_string_bi__
#INCLUDE "crt/string.bi"
#ENDIF

#DEFINE WM_LOAD_COMPONENTS	(WM_USER+1000)  ' One user message
#DEFINE TOOLBAR_IDX     500                 ' Start index Toolbars and buttons
#DEFINE SYS_TIMER_IDX   1000                ' Start index for sys timers

#UNDEF Delete                               '
#UNDEF Min                                  '
#UNDEF Max                                  ' Properties of some components
#UNDEF Transparent                          '
#UNDEF screen                               '

' Shared graphics functions
DECLARE SUB MakeCopyRect(dstHandle AS HWND, dstRect AS RECT PTR, srcHandle AS HWND, srcRect AS RECT PTR)

DECLARE SUB MakeLine(Handle AS HWND, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DECLARE SUB MakeRectangle(Handle AS HWND, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DECLARE SUB MakeFillRect(Handle AS HWND, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DECLARE SUB MakeRoundRect(Handle AS HWND, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, colr AS integer)
DECLARE SUB MakeCircle(Handle AS HWND, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer, FillColr AS integer)
DECLARE SUB MakeTextOut(Handle AS HWND, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
DECLARE FUNCTION GetTextSize(Handle AS HWND, Text AS string, WidthFlag AS integer) AS integer

DECLARE FUNCTION CreateDefaultFont() AS HFONT
DECLARE FUNCTION rqTALLY(srcString AS string, srchString AS string) AS integer
DECLARE FUNCTION rqFIELDSTR(srcString AS string, sepField AS string, numField AS integer) AS string
DECLARE FUNCTION rqREPLACESUBSTR(srcString AS string, oldToken AS string, newToken AS string) AS string

' ALL major objects from RapidQ plus some extras (UPDOWN,PROGRESSBAR)
' The following order must be kept in sync with RapidFRM
ENUM Q_OBJECTS
    Q_FORM, Q_EDIT, Q_RICHEDIT, Q_LABEL, Q_BUTTON, Q_COOLBTN, Q_OVALBTN, Q_CHECKBOX,
    Q_RADIOBUTTON, Q_PANEL, Q_TABCONTROL, Q_COMBOBOX, Q_LISTBOX, Q_GROUPBOX, Q_SCROLLBOX,
    Q_SCROLLBAR, Q_STRINGGRID, Q_LISTVIEW, Q_DIRTREE, Q_FILELISTBOX, Q_TREEVIEW,
    Q_OUTLINE, Q_GAUGE, Q_TRACKBAR, Q_HEADER, Q_STATUSBAR, Q_CANVAS, Q_IMAGE,
    Q_OLECONTAINER, Q_SPLITTER, Q_BITMAP, Q_IMAGELIST, Q_STRINGLIST, Q_TIMER, Q_SOCKET,
    Q_FILESTREAM, Q_MEMORYSTREAM, Q_FONT, Q_MYSQL, Q_OLEOBJECT, Q_REGISTRY, Q_OPENDIALOG,
    Q_SAVEDIALOG, Q_FONTDIALOG, Q_COLORDIALOG, Q_DXTimer, Q_DXSound, Q_DXScreen,
    Q_DXImageList, Q_D3DFace, Q_D3DMeshBuilder, Q_D3DFrame, Q_D3DLight, Q_D3DTexture,
    Q_D3DVector, Q_D3DWrap,
    Q_PRINTDIALOG, Q_UPDOWN, Q_PROGRESSBAR, Q_PAGESCROLLER
END ENUM

ENUM StyleBorder: bsNone, bsSingle, bsSizeable, bsDialog, bsToolWindow, bsSizeToolWin: END ENUM
ENUM ControlAlign: alNone, alTop, alBottom, alLeft, alRight, alClient: END ENUM
ENUM ButnTypes: bkCustom, bkOK, bkCancel, bkHelp, bkYes, bkNo, bkClose, bkAbort, bkRetry, bkIgnore, bkAll: END ENUM
ENUM TextAlign: taLeftJustify, taCenter, taRightJustify: END ENUM
ENUM BevelStyle: bvNone, bvLowered, bvRaised: END ENUM
ENUM LabelStyle: lsNone, lsRaised, lsRecessed: END ENUM
ENUM ScrollBarKind: sbHorizontal, sbVertical: END ENUM
ENUM LViewSort: stNone, stData, stText, stBoth: END ENUM
ENUM LViewStyle: vsIcon, vsSmallIcon, vsList, vsReport: END ENUM
ENUM TBarOrientation: tbHorizontal, tbVertical: END ENUM
ENUM TBarTickPos: tmBottomRight, tmTopLeft, tmBoth: END ENUM
ENUM TBarTickStyle: tsNone, tsAuto, tsManual: END ENUM
ENUM GaugeKind: gkText, gkHorizontalBar, gkVerticalBar, gkPie, gkNeedle: END ENUM
ENUM StringDup: dupIgnore, dupAccept, dupError: END ENUM

ENUM ImgType: itImage, itMask: END ENUM
ENUM ImgDrawStyle: dsFocused, dsSelected, dsNormal, dsTransparent: END ENUM
ENUM ColorChooseStyle: cdNormal, cdFullOpen, cdNoFullOpen: END ENUM
ENUM FontStyles: fsBold, fsItalic, fsUnderline, fsStrikeOut: END ENUM
ENUM BMPFormat: pfDevice, pf1bit, pf4bit, pf8bit, pf15bit, pf16bit, pf24bit, pf32bit: END ENUM

ENUM RETextExtend: ST_NEWCHARS=3, ST_UNICODE: END ENUM

ENUM SpinOrientation: spVertical, spHorizontal: END ENUM
ENUM ProgBar: pbHorizontal, pbVertical: END ENUM
ENUM PagerOrientation: pgHorizontal, pgVertical: END ENUM

'-----------------------------------------------------------------------------------------
' Some macro stuff
'-----------------------------------------------------------------------------------------
#MACRO ShowMessage(Txt)
    MessageBox(Application.hMainForm, Txt, "FB Debug", MB_OK)   ' Use "global" Form handle to capture focus
#ENDMACRO

' Properties: Common properties read/set
#MACRO PrivateProperties()
    xInit AS integer=0: OldWndProc AS WNDPROC: NewWndProc AS WNDPROC: xHandle AS HWND: xParent AS HWND
    xEnabled AS integer=1: xVisible AS integer=1: xTag AS integer=0: xShowHint AS integer=0
    xMin AS integer=0: xMax AS integer=100: xPosition AS integer=0: xSmallChange AS integer=1
    xLargeChange AS integer=10: xPageSize AS integer=10: xTransparent AS integer=1
    xBorderStyle AS integer=1
    xCaption AS string = "": xHint AS string = "": xText AS string = ""
#ENDMACRO

' INITIALLY settable (xInit AND bit = 0) THEN read only!
#MACRO ReadOnlyProperties(ObjName)
    PROPERTY ObjName.Handle() AS HWND: RETURN xHandle: END PROPERTY
    PROPERTY ObjName.Handle(value AS HWND): IF (xInit AND 1) = 0 THEN xInit += 1: xHandle=value: END IF: END PROPERTY
    PROPERTY ObjName.Parent() AS HWND: RETURN xParent: END PROPERTY
    PROPERTY ObjName.Parent(value AS HWND): IF (xInit AND 2) = 0 THEN xInit += 2: xParent=value: END IF: END PROPERTY
#ENDMACRO

' Properties:  read/set general
#MACRO GeneralProperties(ObjName)
    PROPERTY ObjName.Enabled() AS integer: RETURN xEnabled: END PROPERTY
    PROPERTY ObjName.Enabled(value AS integer): xEnabled=value: EnableWindow(Handle, value): END PROPERTY
    PROPERTY ObjName.Visible() AS integer: RETURN xVisible: END PROPERTY
    PROPERTY ObjName.Visible(value AS integer): xVisible=value: IF value=True THEN ShowWindow(Handle, SW_SHOW) ELSE ShowWindow(Handle, SW_HIDE): END IF: END PROPERTY
    PROPERTY ObjName.Tag() AS integer: RETURN xTag: END PROPERTY
    PROPERTY ObjName.Tag(value AS integer): xTag=value: END PROPERTY
    PROPERTY ObjName.ShowHint() AS integer: RETURN xShowHint: END PROPERTY
    PROPERTY ObjName.ShowHint(value AS integer): xShowHint=value: END PROPERTY
#ENDMACRO

' Properties: read/set window dynamics
#MACRO PositionalProperties(ObjName)
    PROPERTY ObjName.Height() AS integer: RETURN xHeight: END PROPERTY
    PROPERTY ObjName.Height(value AS integer): xHeight=value: MoveWindow(Handle, Left, Top, Width, Height, True): END PROPERTY
    PROPERTY ObjName.Left() AS integer: RETURN xLeft: END PROPERTY
    PROPERTY ObjName.Left(value AS integer): xLeft=value: MoveWindow(Handle, Left, Top, Width, Height, True): END PROPERTY
    PROPERTY ObjName.Top() AS integer: RETURN xTop: END PROPERTY
    PROPERTY ObjName.Top(value AS integer): xTop=value: MoveWindow(Handle, Left, Top, Width, Height, True): END PROPERTY
    PROPERTY ObjName.Width() AS integer: RETURN xWidth: END PROPERTY
    PROPERTY ObjName.Width(value AS integer): xWidth=value: MoveWindow(Handle, Left, Top, Width, Height, True): END PROPERTY
#ENDMACRO

' Properties (text): Caption read/set
#MACRO CapProperties(ObjName)
    PROPERTY ObjName.Caption() AS string: RETURN xCaption: END PROPERTY
    PROPERTY ObjName.Caption(value AS string): xCaption=value: SetWindowText(Handle, xCaption): END PROPERTY
#ENDMACRO

' Properties (text): Hint read/set
#MACRO HintProperties(ObjName)
    PROPERTY ObjName.Hint() AS string: RETURN xHint: END PROPERTY
    PROPERTY ObjName.Hint(value AS string): xHint=value: END PROPERTY
#ENDMACRO

' Properties (text): Text & Hint read/set
#MACRO TxtHintProperties(ObjName)
    PROPERTY ObjName.Text() AS string: RETURN xText: END PROPERTY
    PROPERTY ObjName.Text(value AS string): xText=value: SetWindowText(Handle, xText): END PROPERTY
    PROPERTY ObjName.Hint() AS string: RETURN xHint: END PROPERTY
    PROPERTY ObjName.Hint(value AS string): xHint=value: END PROPERTY
#ENDMACRO

'-----------------------------------------------------------------------------------------
TYPE QSCREEN
    AS integer Width
    AS integer Height
    AS integer ClientWidth
    AS integer ClientHeight
    AS RECT rct

    AS integer MouseBtns
    AS integer MouseX
    AS integer MouseY

    DECLARE CONSTRUCTOR
END TYPE

CONSTRUCTOR QSCREEN
WITH THIS
    .Width = GetSystemMetrics(SM_CXVIRTUALSCREEN)
    .Height = GetSystemMetrics(SM_CYVIRTUALSCREEN)
    SystemParametersInfo(SPI_GETWORKAREA, 0, @rct, 0)
    .ClientWidth = .rct.Right - .rct.Left + 1
    .ClientHeight = .rct.Bottom - .rct.Top + 1
END WITH
END CONSTRUCTOR

TYPE APP_TIMER
    ObjIndex AS integer
    Parent AS HWND
    Enabled AS integer
    Interval AS integer
    OnTimer AS SUB()
END TYPE

TYPE QAPPLICATION
    AS HINSTANCE hInstance
    AS string*256 FullName              ' Full path and exe name
    AS string*256 Path                  ' Full path
    AS string*80 Name                   ' exe name only
    AS HWND hMainForm
    AS HWND hWndTTip                    ' Tooltip window
    AS LOGFONTA RQlfont                 ' Logical font structure as per RQ
    AS HFONT hfont                      ' Default font handle

    DECLARE SUB Terminate
    DECLARE CONSTRUCTOR
    DECLARE DESTRUCTOR
END TYPE

SUB QAPPLICATION.Terminate
    SendMessage(hMainForm, WM_CLOSE, 0, 0)
END SUB

CONSTRUCTOR QAPPLICATION
WITH THIS
    .hInstance = GetModuleHandle(NULL)
    GetModuleFileName(.hInstance, .FullName, 255)
    .Path = LEFT(.FullName, INSTRREV(.FullName, "\")-1)
    .Name = RIGHT(.FullName, LEN(.FullName)-INSTRREV(.FullName, "\"))
    .hMainForm=0
    .hWndTTip = 0
    .hfont=CreateDefaultFont
END WITH
END CONSTRUCTOR

DESTRUCTOR QAPPLICATION
END DESTRUCTOR

'-----------------------------------------------------------------------------------------
' Global "system" wide data
'-----------------------------------------------------------------------------------------
DIM SHARED AS QSCREEN Screen
DIM SHARED AS QAPPLICATION Application
DIM SHARED AS WNDCLASSEX wc
DIM SHARED AS HHOOK MouseHook
DIM SHARED AS APP_TIMER App_Timer


' #0 =====================================================================================
TYPE QFORM
' Private (not)
    ObjId AS integer        = 0                             ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = "RQClass"                     ' Base class
    ObjStyle AS UINT        = 0                             '
    OldWndProc AS UINT      = 0
    NewWndProc AS UINT      = 0
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 320
    xHeight AS integer      = 240

    xCaption AS string      = ""
    xClientHeight AS integer
    xClientWidth AS integer
    xHandle AS HWND
    xHint AS string         = ""
    xInit AS integer        = 0
    xParent AS HWND

    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY ClientHeight() AS integer
    DECLARE PROPERTY ClientHeight(value AS integer)
    DECLARE PROPERTY ClientWidth() AS integer
    DECLARE PROPERTY ClientWidth(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    AutoScroll AS integer = 1       ' |integer|RW|True|False|True
    BorderStyle AS integer = 2      ' |integer|RW|bsSizeable|bsNone|bsSingle|bsSize...
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crC...
    Font AS HWND                    ' |QFONT|R|<default>
    FormStyle AS integer            ' |INTEGER|R|fsNormal
    IcoHandle AS integer            ' |RESOURCE|W|
    Icon AS string                  ' |STRING|W|
    KeyPreview AS integer           ' |INTEGER|RW|False|False|True
    ModalResult AS integer          ' |INTEGER|W|mrNone|mrNone|mrOK|mrCancel|mrAbort|mrRet...
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    ShowHint AS integer             ' |INTEGER|RW|False|False|True
    Visible AS integer              ' |INTEGER|RW|False|False|True
    WindowState AS integer          ' |INTEGER|RW|wsNormal|wsNormal|wsMinimized|wsMaximized
' Methods
''    DECLARE SUBI AddBorderIcons(...)
    DECLARE SUB Center()
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB Close()
    DECLARE SUB CopyRect(D AS RECT PTR, Image AS HWND, S AS RECT PTR)
''    DECLARE SUBI DelBorderIcons(...)
''    DECLARE SUB Draw(x AS integer, y AS integer, BMP AS HWND)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB HideTitleBar()
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, border AS integer)
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB Rotate(xOrigin AS integer, yOrigin AS integer, Angle AS integer)
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB ShapeForm(Filename AS string, TransparentColor AS UINT)
    DECLARE SUB Show()
    DECLARE FUNCTION ShowModal() AS integer
    DECLARE SUB ShowTitleBar()
''    DECLARE SUB StretchDraw(rct AS RECT PTR, BMP AS HWND)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextRect(rct AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
' Events
    OnClick AS SUB(Sender AS QFORM PTR)
    OnClose AS SUB(BYREF Action AS integer, Sender AS QFORM PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QFORM PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QFORM PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QFORM PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QFORM PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QFORM PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QFORM PTR)
    OnPaint AS SUB(Sender AS QFORM PTR)
    OnHint AS SUB(Hint AS string, Sender AS QFORM PTR)
    OnResize AS SUB(Sender AS QFORM PTR)
    OnShow AS SUB(Sender AS QFORM PTR)
END TYPE

PositionalProperties(QFORM)
CapProperties(QFORM)
HintProperties(QFORM)
ReadOnlyProperties(QFORM)

PROPERTY QFORM.ClientHeight() AS integer
DIM AS RECT rct
GetClientRect(Handle, @rct): xClientHeight=rct.Bottom-rct.Top: RETURN xClientHeight
END PROPERTY
PROPERTY QFORM.ClientHeight(value AS integer): END PROPERTY                 ' Read Only

PROPERTY QFORM.ClientWidth() AS integer
DIM AS RECT rct
GetClientRect(Handle, @rct): xClientWidth=rct.Right-rct.Left: RETURN xClientWidth
END PROPERTY
PROPERTY QFORM.ClientWidth(value AS integer): END PROPERTY                 ' Read Only

SUB QFORM.Center()
Left=(Screen.Width-Width)\2: Top=(Screen.Height-Height)\2
MoveWindow(Handle, Left, Top, Width, Height, 1)
END SUB
SUB QFORM.CopyRect(D AS RECT PTR, Image AS HWND, S AS RECT PTR)
MakeCopyRect(Handle, D, Image, S)
END SUB
SUB QFORM.Pset(x AS integer, y AS integer, c AS integer)
MakeLine(Handle, x, y, x+1, y+1, c)
END SUB
SUB QFORM.Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeLine(Handle, x1, y1, x2, y2, c)
END SUB
SUB QFORM.FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeFillRect(Handle, x1, y1, x2, y2, c)
END SUB
SUB QFORM.Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeRectangle(Handle, x1, y1, x2, y2, c)
END SUB
SUB QFORM.Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
MakeCircle(Handle, x1, y1, x2, y2, c, fill)
END SUB
SUB QFORM.RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
MakeRoundRect(Handle, x1, y1, x2, y2, x3, y3, c)
END SUB
SUB QFORM.TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
MakeTextOut(Handle, x, y, S, fc, bc)
END SUB
FUNCTION QFORM.TextHeight(Text AS string) AS integer
RETURN GetTextSize(Handle, Text, False)
END FUNCTION
FUNCTION QFORM.TextWidth(Text AS string) AS integer
RETURN GetTextSize(Handle, Text, True)
END FUNCTION

SUB QFORM.PreSetConfig()
DIM AS RECT rct
GetClientRect(Handle, @rct): xClientHeight=rct.Bottom-rct.Top: xClientWidth=rct.Right-rct.Left
END SUB

SUB QFORM.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB

' #1 =====================================================================================
TYPE QEDIT
' Private (not)
    ObjId AS integer        = Q_EDIT                        ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*8    = "EDIT"                        ' Base class
    ObjStyle AS UINT        = 0                             '
    PrivateProperties()                                     ' Common property variables
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 120
    xHeight AS integer      = 25

' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Text() AS string
    DECLARE PROPERTY Text(value AS string)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    AutoSize AS integer             ' |INTEGER|RW|True|False|True
    CharCase AS integer             ' |INTEGER|RW|ecNormal|ecNormal|ecUpperCase|ecLowerCase
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    EditText AS string              ' |STRING|RW|
    Font AS HWND                    ' |QFONT|R|<default>
    InputMask AS string             ' |STRING|RW|
    IsMasked AS integer             ' |INTEGER|RW|False|False|True
    MaxLength AS integer            ' |INTEGER|RW|0
    Modified AS integer             ' |INTEGER|RW|
    PasswordChar AS string          ' |STRING|RW|
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    ReadOnly AS integer             ' |INTEGER|RW|False|False|True
    SelLength AS integer            ' |INTEGER|RW|
    SelStart AS integer             ' |INTEGER|RW|
    SelText AS string               ' |STRING|RW|
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
    OnChange AS SUB(Sender AS QEDIT PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QEDIT PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QEDIT PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QEDIT PTR)
END TYPE

GeneralProperties(QEDIT)
PositionalProperties(QEDIT)
TxtHintProperties(QEDIT)
ReadOnlyProperties(QEDIT)

PROPERTY QEDIT.BorderStyle() AS integer: RETURN xBorderStyle: END PROPERTY
PROPERTY QEDIT.BorderStyle(value AS integer): IF Value<>0 THEN xBorderStyle=1 ELSE xBorderStyle=0: END IF: END PROPERTY

SUB QEDIT.PreSetConfig()
END SUB
SUB QEDIT.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB


' #2 =====================================================================================
TYPE QRICHEDIT
' Private (not)
    ObjId AS integer        = Q_RICHEDIT                        ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "RichEdit20A"                     ' Base class
    ObjStyle AS UINT        = ES_AUTOHSCROLL OR ES_AUTOVSCROLL OR ES_MULTILINE OR WS_VSCROLL OR WS_HSCROLL
    PrivateProperties()                                         ' Common property variables
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 200
    xHeight AS integer      = 100
    xColor AS integer       = &hffffff
    xPlaintext AS integer   = 0

' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Plaintext() AS integer
    DECLARE PROPERTY Plaintext(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Text() AS string
    DECLARE PROPERTY Text(value AS string)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Alignment AS integer            ' |INTEGER|RW|taLeftJustify|taLeftJustify|taRightJustify|taCenter
    Font AS HWND                    ' |QFONT|R|<default>
    HideScrollBars AS integer       ' |INTEGER|RW|True|False|True
    HideSelection AS integer        ' |INTEGER|RW|True|False|True
    LineCount AS integer            ' |INTEGER|RW|
    Modified AS integer             ' |INTEGER|R|
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    Readonly AS integer             ' |INTEGER|RW|False|False|True
    ScrollBars AS integer           ' |INTEGER|RW|ssNone|ssNone|ssHorizontal|ssVertical|ssBoth
    SelAttributes AS HWND           ' |QFONT|W|<default>
    SelLength AS integer            ' |INTEGER|RW|
    SelStart AS integer             ' |INTEGER|RW|
    SelText AS string               ' |STRING|RW|
    TabOrder AS integer             ' |INTEGER|RW|
    WantTabs AS integer             ' |INTEGER|RW|False|False|True
    WhereX AS integer               ' |INTEGER|R|
    WhereY AS integer               ' |INTEGER|R|
    Wordwrap AS integer             ' |INTEGER|RW|True|False|True
''    Line|ARRAY of STRING|RW|
' Methods
    DECLARE SUB AddStrings(value AS string)             ' FUDGE: ONLY one string at a time!
    DECLARE SUB Clear()
    DECLARE SUB LoadFromFile(FileName AS string)
''    CopyToClipboard SUB Copy selected text to clipboard 0 W
''    CutToClipboard SUB Cut selected text to clipboard 0 W
''    LoadFromStream SUB (Stream AS QFILESTREAM/QMEMORYSTREAM) Load text from a stream 1 WX
''    PasteFromClipboard SUB Paste text from clipboard 0 W
    DECLARE SUB SaveToFile(FileName AS string)
''    SaveToStream SUB (Stream AS QFILESTREAM/QMEMORYSTREAM) Save text to a stream 1 W
    DECLARE SUB SelectAll()

' Events
    OnChange AS SUB(Sender AS QRICHEDIT PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QRICHEDIT PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QRICHEDIT PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QRICHEDIT PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QRICHEDIT PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QRICHEDIT PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QRICHEDIT PTR)
END TYPE

#IFDEF __win_richedit_bi__

GeneralProperties(QRICHEDIT)
PositionalProperties(QRICHEDIT)
TxtHintProperties(QRICHEDIT)
ReadOnlyProperties(QRICHEDIT)

PROPERTY QRICHEDIT.BorderStyle() AS integer: RETURN xBorderStyle: END PROPERTY
PROPERTY QRICHEDIT.BorderStyle(value AS integer): IF Value<>0 THEN xBorderStyle=1 ELSE xBorderStyle=0: END IF: END PROPERTY
PROPERTY QRICHEDIT.Color() AS integer: RETURN xColor: END PROPERTY
PROPERTY QRICHEDIT.Color(value AS integer): xColor=value: SendMessage(Handle, EM_SETBKGNDCOLOR, 0, CAST(COLORREF,value)): END PROPERTY
PROPERTY QRICHEDIT.Plaintext() AS integer: RETURN xPlaintext: END PROPERTY
PROPERTY QRICHEDIT.Plaintext(value AS integer)
DIM AS UINT Which
    IF value=0 THEN Which=TM_RICHTEXT ELSE Which=TM_PLAINTEXT
    xPlaintext=value: SendMessage(Handle, EM_SETTEXTMODE, Which, 0)
END PROPERTY

SUB QRICHEDIT.SelectAll()
DIM AS CHARRANGE txtRange
    txtRange.cpMin=0: txtRange.cpMax=-1
    SendMessage(Handle, EM_EXSETSEL, 0, CAST(LPARAM,@txtRange))
END SUB
SUB QRICHEDIT.Clear()
    SelectAll()
    SendMessage(Handle, WM_CLEAR, 0, 0)
END SUB
SUB QRICHEDIT.AddStrings(value AS string)
DIM AS SETTEXTEX stex: stex.flags=ST_NEWCHARS: stex.codepage=CP_ACP
    value=value+CHR(13)+CHR(10)
    SendMessage(Handle, EM_SETTEXTEX, CAST(WPARAM,@stex), CAST(LPARAM, STRPTR(value)))
END SUB
SUB QRICHEDIT.LoadFromFile(FileName AS string)
DIM AS string tstr
DIM AS integer FileNum=FreeFile
    Clear()
    IF NOT FileExists(FileName) THEN EXIT SUB
    OPEN FileName FOR INPUT AS #FileNum
    DO UNTIL(EOF(1))
        LINE INPUT #FileNum, tstr: THIS.AddStrings tstr
    LOOP
    CLOSE #FileNum
END SUB
SUB QRICHEDIT.SaveToFile(FileName AS string)
DIM AS string*256 tstr
DIM AS integer i, tCount, FileNum=FreeFile
    OPEN FileName FOR OUTPUT AS #FileNum
    tCount=SendMessage(Handle, EM_GETLINECOUNT, 0, 0)
    FOR i=0 TO tCount-1
        tstr=CHR(255)  ' set max chars of buffer
        SendMessage(Handle, EM_GETLINE, CAST(WPARAM,i), CAST(LPARAM,@tstr))
        IF tstr<>"" THEN PRINT #FileNum, RTRIM(tstr);
    NEXT i
    Close #FileNum
END SUB

SUB QRICHEDIT.PreSetConfig()
END SUB
SUB QRICHEDIT.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB
#ENDIF


' #3 =====================================================================================
TYPE QLABEL
' Private (not)
    ObjId AS integer        = Q_LABEL                       ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = "STATIC"                      ' Base class
    ObjStyle AS UINT        = SS_NOTIFY                     '
    PrivateProperties()                                     ' Common property variables
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 75
    xHeight AS integer      = 25

' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Transparent() AS integer
    DECLARE PROPERTY Transparent(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Alignment AS integer            ' |INTEGER|RW|taLeftJustify|taLeftJustify|taRightJustify|taCenter
    Angle AS integer                ' |INTEGER|RW|0
    Autosize AS integer             ' |INTEGER|RW|False|False|True
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|....
    Font AS HWND                    ' |QFONT|R|<default>
    LabelStyle AS integer           ' |INTEGER|RW|lsNone|lsNone|lsRaised|lsRecessed
    Layout AS integer               ' |INTEGER|RW|tlTop|tlTop|tlCenter|tlBottom
    LowerColor AS integer           ' |INTEGER|RW|<default>|<default>|<choose>
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    UpperColor AS integer           ' |INTEGER|RW|<default>|<default>|<choose>
    Wordwrap AS integer             ' |INTEGER|RW|False|False|True
    ' Methods
    ' Events
    OnClick AS SUB(Sender AS QLABEL PTR)
    OnDblClick AS SUB(Sender AS QLABEL PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QLABEL PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QLABEL PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QLABEL PTR)
END TYPE

GeneralProperties(QLABEL)
PositionalProperties(QLABEL)
CapProperties(QLABEL)
HintProperties(QLABEL)
ReadOnlyProperties(QLABEL)
PROPERTY QLABEL.Transparent() AS integer: RETURN xTransparent: END PROPERTY
PROPERTY QLABEL.Transparent(value AS integer): xTransparent=value: END PROPERTY

SUB QLABEL.PreSetConfig()
END SUB
SUB QLABEL.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #4 =====================================================================================
TYPE QBUTTON
' Private (not)
    ObjId AS integer        = Q_BUTTON                      ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_PUSHBUTTON                 '
    PrivateProperties()                                     ' Common property variables
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 75
    xHeight AS integer      = 25

' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    BMP AS string                   ' |STRING|RW|
    BMPHandle AS integer            ' |RESOURCE|W|
    Cancel AS integer               ' |INTEGER|RW|False|False|True
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|....
    Default AS integer              ' |INTEGER|RW|False|False|True
    Font AS HWND                    ' |QFONT|R|<default>
    Kind AS integer                 ' |INTEGER|RW|bkCustom|bkCustom|bkOK|bkCancel|bkHelp|bkYes|bkNo|....
    Layout AS integer               ' |INTEGER|RW|blBMPLeft|blBMPLeft|blBMPRight|blBMPTop|blBMPBottom
    ModalResult AS integer          ' |INTEGER|W|mrNone|mrNone|mrOK|mrCancel|mrAbort|mrRetry|mrIgnore....
    NumBMPs AS integer              ' |INTEGER|RW|
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    Spacing AS integer              ' |INTEGER|RW|4
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
    OnClick AS SUB(Sender AS QBUTTON PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QBUTTON PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QBUTTON PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QBUTTON PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QBUTTON PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QBUTTON PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QBUTTON PTR)
END TYPE

GeneralProperties(QBUTTON)
PositionalProperties(QBUTTON)
CapProperties(QBUTTON)
HintProperties(QBUTTON)
ReadOnlyProperties(QBUTTON)

SUB QBUTTON.PreSetConfig()
END SUB
SUB QBUTTON.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #5 =====================================================================================
TYPE QCOOLBTN
' Private (not)
    ObjId AS integer        = Q_COOLBTN                     ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_OWNERDRAW                  '
    PrivateProperties()                                     ' Common property variables
    xBackColor AS integer   = &hd4d0c8
    xForeColor AS integer   = &h0
    xHeight AS integer      = 25
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 25
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE SUB CoolBtnDraw(lParm AS LPARAM)

' Properties
    DECLARE PROPERTY BackColor() AS integer
    DECLARE PROPERTY BackColor(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY ForeColor() AS integer
    DECLARE PROPERTY ForeColor(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    AllowAllUp AS integer           ' |INTEGER|RW|False|False|True
    BMP AS string                   ' |W|
    BMPHandle AS integer            ' |RESOURCE|W|
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBea...
    Down AS integer                 ' |INTEGER|RW|False|False|True
    Flat AS integer                 ' |INTEGER|RW|False|False|True
    Font AS HWND                    ' |QFONT|R|<default>
    GroupIndex AS integer = 0       ' |INTEGER|RW|0
    Layout AS integer               ' |INTEGER|RW|blBMPLeft|blBMPLeft|blBMPRight|blBMPTop|blBMPBottom
    NumBMPs AS integer = 0          ' |INTEGER|RW|
    Spacing AS integer = 4          ' |INTEGER|RW|4
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
    OnClick AS SUB(Sender AS QCOOLBTN PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QCOOLBTN PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QCOOLBTN PTR)
END TYPE

GeneralProperties(QCOOLBTN)
PositionalProperties(QCOOLBTN)
CapProperties(QCOOLBTN)
HintProperties(QCOOLBTN)
ReadOnlyProperties(QCOOLBTN)

PROPERTY QCOOLBTN.BackColor() AS integer: RETURN xBackColor: END PROPERTY
PROPERTY QCOOLBTN.BackColor(value AS integer): xBackColor=value: END PROPERTY
PROPERTY QCOOLBTN.ForeColor() AS integer: RETURN xForeColor: END PROPERTY
PROPERTY QCOOLBTN.ForeColor(value AS integer): xForeColor=value: END PROPERTY

SUB QCOOLBTN.CoolBtnDraw(lParm AS LPARAM)
DIM AS DRAWITEMSTRUCT PTR lpDIS = CAST(DRAWITEMSTRUCT PTR, lParm)
DIM AS RECT rct
DIM AS HGDIOBJ Original                                             ' Save original
DIM AS string*64 ButnText
DIM AS integer lenth=GetWindowText(Handle, CAST(LPSTR, @ButnText), 63)

    Original=SelectObject(lpDIS->hDC, GetStockObject(DC_BRUSH))
    rct=lpDIS->rcItem
    IF lpDIS->itemState AND ODS_DISABLED THEN                       ' Btn Disabled?
        DrawFrameControl(lpDIS->hdc, @rct, DFC_BUTTON, DFCS_BUTTONPUSH)
        SetDCBrushColor(lpDIS->hDC, CAST(COLORREF, &hbfbfbf))       ' Color btn disabled
        SetTextColor(lpDIS->hdc, &h7f7f7f)                          ' Color Txt disabled
    ELSEIF  lpDIS->itemState AND ODS_SELECTED THEN
        DrawFrameControl(lpDIS->hdc, @rct, DFC_BUTTON, DFCS_BUTTONPUSH OR DFCS_PUSHED)
        SetDCBrushColor(lpDIS->hDC, CAST(COLORREF, ForeColor))      ' Color btn
        SetTextColor(lpDIS->hdc, BackColor)                         ' Color Txt
    ELSE
        DrawFrameControl(lpDIS->hdc, @rct, DFC_BUTTON, DFCS_BUTTONPUSH)
        SetDCBrushColor(lpDIS->hDC, CAST(COLORREF, BackColor))      ' Color btn
        SetTextColor(lpDIS->hdc, ForeColor)                         ' Color Txt
    END IF
    SetBkMode(lpDIS->hdc, 1)                                        ' 1=TRANSPARENT, 2=OPAQUE
    rct.Left += 2: rct.Right -=2: rct.top +=2: rct.Bottom -= 2
    FillRect(lpDIS->hdc, @rct, NULL)                                ' Use current Brush color
    DrawText(lpDIS->hdc, ButnText, lenth, @rct, DT_CENTER Or DT_SINGLELINE Or DT_VCENTER)
    SelectObject(lpDIS->hDC, Original)                              ' Set back to original
END SUB

SUB QCOOLBTN.PreSetConfig()
END SUB
SUB QCOOLBTN.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #6 =====================================================================================
TYPE QOVALBTN
' Private (not)
    ObjId AS integer        = Q_OVALBTN                     ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_OWNERDRAW                  '
    PrivateProperties()                                     ' Common property variables
    xHeight AS integer      = 35
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 75
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE SUB OvalBtnDraw(lParm AS LPARAM)

' Properties
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Transparent() AS integer
    DECLARE PROPERTY Transparent(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    BMP AS string                   ' |STRING|W|
    BMPHandle AS HWND               ' |RESOURCE|W|
    Color AS integer = &hd7d7d7     '       Main button color
    ColorHighLight AS integer = 0   '       FUDGE: Temporarily using this for the Font text color!!!!!!
    ColorShadow AS integer          ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|...
    Down AS integer                 ' |INTEGER|RW|False|False|True
    Flat AS integer                 ' |INTEGER|RW|False|False|True
    Font AS HWND                    ' |QFONT|R|<default>
    GroupIndex AS integer           ' |INTEGER|RW|0
    Layout AS integer               ' |INTEGER|RW|blBMPLeft|blBMPLeft|blBMPRight|blBMPTop|blBMPBottom
    NumBMPs AS integer              ' |INTEGER|RW|
    Spacing AS integer              ' |INTEGER|RW|
    TabOrder AS integer             ' |INTEGER|RW|
    TransParentColor AS integer     ' |INTEGER|RW|<default>|<default>|<choose>
' Methods
' Events
    OnClick AS SUB(Sender AS QOVALBTN PTR)
END TYPE

GeneralProperties(QOVALBTN)
PositionalProperties(QOVALBTN)
CapProperties(QOVALBTN)
HintProperties(QOVALBTN)
ReadOnlyProperties(QOVALBTN)

PROPERTY QOVALBTN.Transparent() AS integer: RETURN xTransparent: END PROPERTY
PROPERTY QOVALBTN.Transparent(value AS integer): xTransparent=value: END PROPERTY

SUB QOVALBTN.OvalBtnDraw(lParm AS LPARAM)
DIM AS DRAWITEMSTRUCT PTR lpDrawItStr = CAST(DRAWITEMSTRUCT PTR, lParm)
DIM AS RECT rct
DIM AS HGDIOBJ Original                                             ' Save original
DIM ButnText AS string*64
DIM AS integer lenth=GetWindowText(Handle, CAST(LPSTR, @ButnText), 63)

    Original=SelectObject(lpDrawItStr->hDC, GetStockObject(DC_BRUSH))
    SetBkMode(lpDrawItStr->hDC, Transparent)                        ' 1=TRANSPARENT, 2=OPAQUE
    rct=lpDrawItStr->rcItem

    IF lpDrawItStr->itemState AND ODS_DISABLED THEN                 ' Btn Disabled?
        SetDCBrushColor(lpDrawItStr->hDC, CAST(COLORREF, &hbfbfbf)) ' Color btn disabled
        SetTextColor(lpDrawItStr->hDC, &h7f7f7f)                    ' Color Txt disabled
    ELSEIF lpDrawItStr->itemState AND ODS_SELECTED THEN             ' Btn Selected?
        SetDCBrushColor(lpDrawItStr->hDC, CAST(COLORREF, Color))    ' Color btn
        SetTextColor(lpDrawItStr->hDC, ColorHighLight)              ' Color Txt (fudge!)
        rct.Left += 1: rct.Top += 1
    ELSE
        SetDCBrushColor(lpDrawItStr->hDC, CAST(COLORREF, Color))    ' Color btn
        SetTextColor(lpDrawItStr->hDC, ColorHighLight)              ' Color Txt (fudge!)
'        rct.Right -= 1: rct.Bottom -= 1
    END IF
    Ellipse(lpDrawItStr->hDC, rct.Left, rct.Top, rct.Right, rct.Bottom)
    DrawText(lpDrawItStr->hDC, ButnText, lenth, @rct, DT_CENTER OR DT_SINGLELINE OR DT_VCENTER)
    SelectObject(lpDrawItStr->hDC, Original)                        ' Set back to original
END SUB

SUB QOVALBTN.PreSetConfig()
END SUB
SUB QOVALBTN.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #7 =====================================================================================
TYPE QCHECKBOX
' Private (not)
    ObjId AS integer        = Q_CHECKBOX                    ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_AUTOCHECKBOX OR WS_DLGFRAME
    PrivateProperties()                                     ' Common property variables
    xHeight AS integer      = 20
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 100
    xChecked AS integer     = 0
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Checked() AS integer
    DECLARE PROPERTY Checked(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Font AS HWND                    ' |QFONT|R|<default>
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
    OnClick AS SUB(Sender AS QCHECKBOX PTR)
END TYPE

GeneralProperties(QCHECKBOX)
PositionalProperties(QCHECKBOX)
CapProperties(QCHECKBOX)
HintProperties(QCHECKBOX)
ReadOnlyProperties(QCHECKBOX)
PROPERTY QCHECKBOX.Checked() AS integer: xChecked=SendMessage(Handle,BM_GETCHECK,0,0): RETURN xChecked: END PROPERTY
PROPERTY QCHECKBOX.Checked(value AS integer): END PROPERTY

SUB QCHECKBOX.PreSetConfig()
END SUB
SUB QCHECKBOX.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #8 =====================================================================================
TYPE QRADIOBUTTON
' Private (not)
    ObjId AS integer        = Q_RADIOBUTTON                 ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_AUTORADIOBUTTON OR WS_DLGFRAME
    PrivateProperties()                                     ' Common property variables
    xHeight AS integer      = 20
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 100
    xChecked AS integer     = 0
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Checked() AS integer
    DECLARE PROPERTY Checked(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Font AS HWND                    ' |QFONT|R|<default>
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
    OnClick AS SUB(Sender AS QRADIOBUTTON PTR)
END TYPE

GeneralProperties(QRADIOBUTTON)
PositionalProperties(QRADIOBUTTON)
CapProperties(QRADIOBUTTON)
HintProperties(QRADIOBUTTON)
ReadOnlyProperties(QRADIOBUTTON)
PROPERTY QRADIOBUTTON.Checked() AS integer: xChecked=SendMessage(Handle,BM_GETCHECK,0,0): RETURN xChecked: END PROPERTY
PROPERTY QRADIOBUTTON.Checked(value AS integer): END PROPERTY

SUB QRADIOBUTTON.PreSetConfig()
END SUB
SUB QRADIOBUTTON.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB


' #9 =====================================================================================
TYPE QPANEL
' Private (not)
    ObjId AS integer        = Q_PANEL                           ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "STATIC"                          ' Base class
    ObjStyle AS UINT        = SS_NOTIFY OR SS_CENTER OR SS_CENTERIMAGE
    PrivateProperties()                                         ' Common property variables
    xBevelInner AS integer  = bvNone
    xHeight AS integer      = 40
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 175
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY BevelInner() AS integer
    DECLARE PROPERTY BevelInner(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Alignment AS integer            ' |INTEGER|RW|taCenter|taLeftJustify|taRightJustify|taCenter
    BevelOuter AS integer           ' |INTEGER|RW|bvRaised|bvNone|bvLowered|bvRaised
    BevelWidth AS integer = 1       ' |INTEGER|RW|1
    ClientHeight AS integer         ' |INTEGER|RW|
    ClientWidth AS integer          ' |INTEGER|RW|
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|c....
    Font AS HWND                    ' |QFONT|R|<default>
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
    OnClick AS SUB(Sender AS QPANEL PTR)
    OnDblClick AS SUB(Sender AS QPANEL PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QPANEL PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QPANEL PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QPANEL PTR)
END TYPE

GeneralProperties(QPANEL)
PositionalProperties(QPANEL)
CapProperties(QPANEL)
HintProperties(QPANEL)
ReadOnlyProperties(QPANEL)

PROPERTY QPANEL.BevelInner() AS integer: RETURN xBevelInner: END PROPERTY
PROPERTY QPANEL.BevelInner(value AS integer): xBevelInner=value: END PROPERTY
PROPERTY QPANEL.BorderStyle() AS integer: RETURN xBorderStyle: END PROPERTY
PROPERTY QPANEL.BorderStyle(value AS integer): xBorderStyle=value: END PROPERTY

SUB QPANEL.PreSetConfig()
    IF BorderStyle=bsSingle THEN ObjStyle += WS_THICKFRAME
END SUB
SUB QPANEL.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #10 ====================================================================================
TYPE QTABCONTROL
' Private (not)
    ObjId AS integer        = Q_TABCONTROL                      ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "SysTabControl32"                 ' Base class
    ObjStyle AS UINT        = WS_CLIPSIBLINGS                   '
    PrivateProperties()                                         ' Common property variables
    xButtonStyle AS integer = False
    xClientHeight AS integer= 100-28
    xClientWidth AS integer = 150-8
    xFlatButtons AS integer = False
    xHeight AS integer      = 100
    xLeft AS integer        = 0
    xMultiLine AS integer   = False
    xTop AS integer         = 0
    xWidth AS integer       = 150
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY ButtonStyle() AS integer
    DECLARE PROPERTY ButtonStyle(value AS integer)
    DECLARE PROPERTY ClientHeight() AS integer
    DECLARE PROPERTY ClientHeight(value AS integer)
    DECLARE PROPERTY ClientWidth() AS integer
    DECLARE PROPERTY ClientWidth(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY FlatButtons() AS integer
    DECLARE PROPERTY FlatButtons(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY MultiLine() AS integer
    DECLARE PROPERTY MultiLine(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|crSize|crSiz....
    FlatSeperators AS integer       ' |INTEGER|RW|False|False|True
    FocusButtons AS integer         ' |INTEGER|RW|False|False|True
    Font AS HWND                    ' |QFONT|R|<default>
    HotTrack AS integer             ' |INTEGER|RW|False|False|True
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    ScrollOpposite AS integer       ' |INTEGER|RW|False|False|True
    TabHeight AS integer            ' |INTEGER|RW|
    TabInactiveColor AS integer     ' |INTEGER|RW|<default>|<default>|<choose>
    TabInactiveFont AS HWND         ' |QFONT|R|<default>
    TabIndex AS integer             ' |INTEGER|RW|
    TabOrder AS integer             ' |INTEGER|RW|
    TabPosition AS integer          ' |INTEGER|RW|
    TabWidth AS integer             ' |INTEGER|RW|
    VerticalTabs AS integer         ' |INTEGER|RW|False|False|True
''    Tab AS string                     ' |ARRAY of STRING|RW|    My version csv string!!!!!
' Methods
   DECLARE SUB AddTabs(value AS string)         ' BIG cheat: ONE TAB string at a time!
   DECLARE SUB DelTabs(value AS integer)        ' BIG cheat: delete by single index number only
' Events
    OnChange AS SUB(Sender AS QTABCONTROL PTR)
END TYPE

GeneralProperties(QTABCONTROL)
PositionalProperties(QTABCONTROL)
HintProperties(QTABCONTROL)
ReadOnlyProperties(QTABCONTROL)

PROPERTY QTABCONTROL.ButtonStyle() AS integer: RETURN xButtonStyle: END PROPERTY
PROPERTY QTABCONTROL.ButtonStyle(value AS integer)
IF value<>False THEN xButtonStyle=True ELSE xButtonStyle=False
END PROPERTY
PROPERTY QTABCONTROL.ClientHeight() AS integer   ' 1st Tab Row 28 pix high, subsequent rows 21 pix
DIM AS integer i=SendMessage(Handle,TCM_GETROWCOUNT,0,0): RETURN (Height-i*21-7)
END PROPERTY
PROPERTY QTABCONTROL.ClientHeight(value AS integer): END PROPERTY               ' Readonly
PROPERTY QTABCONTROL.ClientWidth() AS integer: RETURN Width-8: END PROPERTY
PROPERTY QTABCONTROL.ClientWidth(value AS integer): END PROPERTY                ' Readonly
PROPERTY QTABCONTROL.FlatButtons() AS integer: RETURN xFlatButtons: END PROPERTY
PROPERTY QTABCONTROL.FlatButtons(value AS integer)
IF value<>False THEN xFlatButtons=True ELSE xFlatButtons=False
END PROPERTY
PROPERTY QTABCONTROL.MultiLine() AS integer: RETURN xMultiLine: END PROPERTY
PROPERTY QTABCONTROL.MultiLine(value AS integer)
IF value<>False THEN xMultiLine=True ELSE xMultiLine=False
END PROPERTY

SUB QTABCONTROL.AddTabs(value AS string)
DIM AS TC_ITEM tie
DIM AS integer i=SendMessage(Handle,TCM_GETITEMCOUNT,0,0)

    tie.mask = TCIF_TEXT OR TCIF_IMAGE
    tie.pszText = STRPTR(value)
    TabCtrl_InsertItem(Handle, i, @tie)
END SUB

SUB QTABCONTROL.DelTabs(value AS integer)
TabCtrl_DeleteItem(Handle,value)
END SUB

SUB QTABCONTROL.PreSetConfig()
    IF MultiLine=True THEN ObjStyle += TCS_MULTILINE
    IF ButtonStyle=True THEN ObjStyle += TCS_BUTTONS
    IF FlatButtons=True THEN ObjStyle += TCS_FLATBUTTONS
END SUB
SUB QTABCONTROL.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #11 ====================================================================================
TYPE QCOMBOBOX
' Private (not)
    ObjId AS integer        = Q_COMBOBOX                        ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "COMBOBOX"                        ' Base class
    ObjStyle AS UINT        = WS_VSCROLL OR CBS_DROPDOWNLIST
    PrivateProperties()                                         ' Common property variables
    xDropDownCount AS integer = 8                               ' DropDown height....
    xHeight AS integer      = 141                               ' ....trial & error
    xItemCount AS integer   = 0
    xItemIndex AS integer   = -1
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 150
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY DropDownCount() AS integer
    DECLARE PROPERTY DropDownCount(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY ItemCount() AS integer
    DECLARE PROPERTY ItemCount(value AS integer)
    DECLARE PROPERTY ItemIndex() AS integer
    DECLARE PROPERTY ItemIndex(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Text() AS string
    DECLARE PROPERTY Text(value AS string)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    CopyMode AS integer             ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCopy|cmMerge.......
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|crSize......
    Font AS HWND                    ' |QFONT|R|<default>
    ItemHeight AS integer           ' |INTEGER|RW|
    MaxLength AS integer            ' |INTEGER|RW|
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    Sorted AS integer               ' |INTEGER|RW|False|False|True
    Style AS integer                ' |INTEGER|RW|csDropDown|csDropDown|csSimple|csDropDownList|csOwnerDra.....
    TabOrder AS integer             ' |INTEGER|RW|
''    Item AS string                            ' |ARRAY of STRING|RW|
' Methods
    DECLARE SUB AddItems(value AS string)       ' BIG cheat: ONE item string at a time!
' Events
    OnChange AS SUB(Sender AS QCOMBOBOX PTR)
    OnDrawItem AS SUB(Index AS integer, State AS integer, Rct AS RECT PTR, Sender AS QCOMBOBOX PTR)
    OnMeasureItem AS SUB(Index AS integer, Height AS integer, Sender AS QCOMBOBOX PTR)
END TYPE

GeneralProperties(QCOMBOBOX)
PositionalProperties(QCOMBOBOX)
HintProperties(QCOMBOBOX)
ReadOnlyProperties(QCOMBOBOX)

' FUDGE: Should get the item height to determine the combobox height! Following is a guesstimate
PROPERTY QCOMBOBOX.DropDownCount(value AS integer): xDropDownCount=value: Height=21+value*15: END PROPERTY
PROPERTY QCOMBOBOX.DropDownCount() AS integer: RETURN xDropDownCount: END PROPERTY
PROPERTY QCOMBOBOX.ItemIndex(value AS integer): SendMessage(Handle, CB_SETCURSEL, value, 0): xItemIndex=value: END PROPERTY
PROPERTY QCOMBOBOX.ItemIndex() AS integer: xItemIndex=SendMessage(Handle, CB_GETCURSEL, 0, 0): RETURN xItemIndex: END PROPERTY
PROPERTY QCOMBOBOX.Text(value AS string): END PROPERTY                        ' Read only
PROPERTY QCOMBOBOX.Text() AS string
DIM AS string*256 zItemTxt: SendMessage(Handle, CB_GETLBTEXT, ItemIndex, CAST(LPARAM, @zItemTxt)): xText=zItemTxt: RETURN xText
END PROPERTY
PROPERTY QCOMBOBOX.ItemCount(value AS integer): END PROPERTY                    ' Read Only
PROPERTY QCOMBOBOX.ItemCount() AS integer: xItemCount=SendMessage(Handle, CB_GETCOUNT, 0, 0): RETURN xItemCount: END PROPERTY

SUB QCOMBOBOX.AddItems(value AS string)
    SendMessage(Handle, CB_ADDSTRING, 0, CAST(LPARAM, STRPTR(value)))
END SUB

SUB QCOMBOBOX.PreSetConfig()
END SUB
SUB QCOMBOBOX.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB


' #12 ====================================================================================
TYPE QLISTBOX
' Private (not)
    ObjId AS integer        = Q_LISTBOX                         ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "LISTBOX"                         ' Base class
    ObjStyle AS UINT        = WS_VSCROLL OR WS_HSCROLL OR LBS_NOTIFY                '  OR LBS_DISABLENOSCROLL
    PrivateProperties()                                         ' Common property variables
    xHeight AS integer      = 100
    xItem(1) AS string
    xItemCount AS integer   = 0
    xItemIndex AS integer   = -1
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xTopIndex AS integer    = 0
    xWidth AS integer       = 120
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Item(idx AS integer) AS string
    DECLARE PROPERTY Item(idx AS integer, value AS string)
    DECLARE PROPERTY ItemCount() AS integer
    DECLARE PROPERTY ItemCount(value AS integer)
    DECLARE PROPERTY ItemIndex() AS integer
    DECLARE PROPERTY ItemIndex(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Text() AS string
    DECLARE PROPERTY Text(value AS string)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY TopIndex() AS integer
    DECLARE PROPERTY TopIndex(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer = alNone       ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Columns AS integer = 1          ' |INTEGER RW 0 W
    CopyMode AS integer             ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCopy|cmMergePaint|.....
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|crSize|crSiz.....
    ExtendedSelect AS integer = False  ' |INTEGER|RW|False|False|True
    Font AS HWND                    ' |QFONT|R|<default>
    ItemHeight AS integer           ' |INTEGER|RW|
    MultiSelect AS integer = False  ' |INTEGER|RW|False|False|True
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    SelCount AS integer = 0         ' |INTEGER|R|
    Sorted AS integer = False       ' |INTEGER|RW|False|False|True
    Style AS integer = 0            ' |INTEGER|RW|lbStandard|lbStandard|lbOwnerDrawFixed|lbOwnerDrawVariable
    TabOrder AS integer             ' |INTEGER|RW|
    TabWidth AS integer             ' |INTEGER|RW|0
''    Selected() AS integer           ' |ARRAY of INTEGER|RW|
' Methods
    DECLARE SUB AddItems(value AS string)         ' BIG cheat: ONE item string at a time!
    DECLARE SUB Clear()
' Events
    OnClick AS SUB(Sender AS QLISTBOX PTR)
    OnDblClick AS SUB(Sender AS QLISTBOX PTR)
    OnDrawItem AS SUB(Index AS integer, State AS integer, Rct AS RECT PTR, Sender AS QLISTBOX PTR)
    OnEnter AS SUB(Sender AS QLISTBOX PTR)
    OnMeasureItem AS SUB(Index AS integer, Height AS integer, Sender AS QLISTBOX PTR)
END TYPE

GeneralProperties(QLISTBOX)
PositionalProperties(QLISTBOX)
HintProperties(QLISTBOX)
ReadOnlyProperties(QLISTBOX)

PROPERTY QLISTBOX.Item(idx AS integer) AS string
DIM AS string*256 zItemTxt: SendMessage(Handle, LB_GETTEXT, idx, CAST(LPARAM, @zItemTxt)): RETURN zItemTxt
END PROPERTY
PROPERTY QLISTBOX.Item(idx AS integer,value AS string): END PROPERTY      ' Do nothing

PROPERTY QLISTBOX.BorderStyle() AS integer: RETURN xBorderStyle: END PROPERTY
PROPERTY QLISTBOX.BorderStyle(value AS integer): IF Value<>0 THEN xBorderStyle=1 ELSE xBorderStyle=0: END IF: END PROPERTY
PROPERTY QLISTBOX.ItemCount(value AS integer): END PROPERTY
PROPERTY QLISTBOX.ItemCount() AS integer: xItemCount=SendMessage(Handle, LB_GETCOUNT, 0, 0): RETURN xItemCount: END PROPERTY
PROPERTY QLISTBOX.ItemIndex(value AS integer): SendMessage(Handle, LB_SETCURSEL, value, 0): xItemIndex=value: END PROPERTY
PROPERTY QLISTBOX.ItemIndex() AS integer: xItemIndex=SendMessage(Handle, LB_GETCURSEL, 0, 0): RETURN xItemIndex: END PROPERTY
PROPERTY QLISTBOX.Text(value AS string): END PROPERTY                        ' Read only
PROPERTY QLISTBOX.Text() AS string
DIM AS string*256 zItemTxt: SendMessage(Handle, LB_GETTEXT, ItemIndex, CAST(LPARAM, @zItemTxt)): xText=zItemTxt: RETURN xText
END PROPERTY
PROPERTY QLISTBOX.TopIndex(value AS integer)
IF (value>=0) AND (value<ItemCount) THEN SendMessage(Handle, LB_SETTOPINDEX, CAST(WPARAM, value), 0): xTopIndex=value: END IF
END PROPERTY
PROPERTY QLISTBOX.TopIndex() AS integer: xTopIndex=SendMessage(Handle, LB_GETTOPINDEX, 0, 0): RETURN xTopIndex: END PROPERTY

SUB QLISTBOX.AddItems(value AS string)
DIM AS integer i=SendMessage(Handle, LB_GETCOUNT, 0, 0)
    SendMessage(Handle, LB_INSERTSTRING, i, CAST(LPARAM, STRPTR(value)))
END SUB
SUB QLISTBOX.Clear()
    SendMessage(Handle, LB_RESETCONTENT, 0, 0)
END SUB

SUB QLISTBOX.PreSetConfig()
END SUB
SUB QLISTBOX.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #13 ====================================================================================
TYPE QGROUPBOX
' Private (not)
    ObjId AS integer        = Q_GROUPBOX                        ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "BUTTON"                          ' Base class
    ObjStyle AS UINT        = BS_GROUPBOX                       '
    PrivateProperties()                                         ' Common property variables
    xHeight AS integer      = 100
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 150
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crAr
    Font AS HWND                    ' |QFONT|R|<default>
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
''    OnClick AS SUB(Sender AS QGROUPBOX PTR)
''    OnDblClick AS SUB(Sender AS QGROUPBOX PTR)
''    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QGROUPBOX PTR)
''    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QGROUPBOX PTR)
''    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QGROUPBOX PTR)
END TYPE

GeneralProperties(QGROUPBOX)
PositionalProperties(QGROUPBOX)
CapProperties(QGROUPBOX)
HintProperties(QGROUPBOX)
ReadOnlyProperties(QGROUPBOX)

SUB QGROUPBOX.PreSetConfig()
END SUB
SUB QGROUPBOX.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #14 ====================================================================================
TYPE QSCROLLBOX
' Private (not)
    ObjId AS integer        = Q_SCROLLBOX                       ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "BUTTON"                          ' Base class
    ObjStyle AS UINT        = BS_FLAT OR WS_VSCROLL OR WS_HSCROLL
    PanH AS integer         = 200                               '|
    PanX AS integer         = 0                                 '|
    PanY AS integer         = 0                                 '| Panel inside scrollbox
    PanW AS integer         = 300                               '|
    PanHandle AS HWND                                           '|
    PrivateProperties()                                         ' Common property variables
    xHeight AS integer      = 100
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 150

' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE SUB ScrollTheBox(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)

' Properties
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    AutoScroll AS integer           ' |INTEGER|RW|True|False|True
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBe...
    Font AS HWND                    ' |QFONT|R|<default>
    HorzIncrement AS integer = 8    ' |INTEGER|RW|8
    HorzMargin AS integer = 0       ' |INTEGER|RW|0
    HorzPosition AS integer = 0     ' |INTEGER|RW|0
    HorzRange AS integer = 0        ' |INTEGER|RW|0
    HorzTracking AS integer         ' |INTEGER|RW|False|False|True
    HorzVisible AS integer          ' |INTEGER|RW|True|False|True
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    TabOrder AS integer             ' |INTEGER|RW|
    VertIncrement AS integer = 8    ' |INTEGER|RW|8
    VertMargin AS integer = 0       ' |INTEGER|RW|0
    VertPosition AS integer = 0     ' |INTEGER|RW|0
    VertRange AS integer = 0        ' |INTEGER|RW|0
    VertTracking AS integer         ' |INTEGER|RW|False|False|True
    VertVisible AS integer          ' |INTEGER|RW|True|False|True
' Methods
' Events
    OnClick AS SUB(Sender AS QSCROLLBOX PTR)
    OnDblClick AS SUB(Sender AS QSCROLLBOX PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QSCROLLBOX PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QSCROLLBOX PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QSCROLLBOX PTR)
    OnResize AS SUB(Sender AS QSCROLLBOX PTR)
END TYPE

GeneralProperties(QSCROLLBOX)
PositionalProperties(QSCROLLBOX)
HintProperties(QSCROLLBOX)
ReadOnlyProperties(QSCROLLBOX)

PROPERTY QSCROLLBOX.BorderStyle() AS integer: RETURN xBorderStyle: END PROPERTY
PROPERTY QSCROLLBOX.BorderStyle(value AS integer): IF Value<>0 THEN xBorderStyle=1 ELSE xBorderStyle=0: END IF: END PROPERTY

SUB QSCROLLBOX.PreSetConfig()
END SUB

' Place a LARGE "moveable" panel inside the scrollbox (uses dimensions of the parent window!)
SUB QSCROLLBOX.PostConfig()
#IFDEF __SCROLLBOX
DIM AS SCROLLINFO scrInfo
DIM AS RECT rct

    ' Create a child panel that is "scrolled"
    GetClientRect(GetParent(Handle), @rct)
    PanX=0: PanY=0: PanW=rct.Right-rct.Left: PanH=rct.Bottom-rct.Top

    scrInfo.cbSize=SIZEOF(scrInfo)                          ' Set parameters of the ScrollBox
    scrInfo.fMask=SIF_RANGE OR SIF_PAGE OR SIF_POS
    scrInfo.nMin=1: scrInfo.nMax=PanW: scrInfo.nPage=10: scrInfo.nPos=1
    SetScrollInfo(Handle, SB_HORZ, @ScrInfo, 1)
    scrInfo.nMin=1: scrInfo.nMax=PanH: scrInfo.nPage=10: scrInfo.nPos=1
    SetScrollInfo(Handle, SB_VERT, @ScrInfo, 1)

    PanHandle=CreateWindowEx(0, "STATIC", "", WS_CHILD OR WS_VISIBLE OR SS_NOTIFY, _
                                0, 0, PanW, PanH, Handle, CAST(HMENU,10000), 0, 0)

    NewWndProc=@ScrollBoxWndProc
    OldWndProc=CAST(WNDPROC, SetWindowLong(Handle, GWL_WNDPROC, CAST(long, @ScrollBoxWndProc)))

    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
#ENDIF
END SUB

' Called from the ScrollBox WndProc
SUB QSCROLLBOX.ScrollTheBox(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
#IFDEF __SCROLLBOX
DIM AS integer BarPos, Delta, Which

    IF wMsg=WM_HSCROLL THEN Which=SB_HORZ ELSE Which=SB_VERT
    BarPos=GetScrollPos(hWnd, Which): Delta=0
    SELECT CASE wParam
        CASE 0: IF BarPos>1 THEN BarPos -= 1  : Delta =  -1: END IF
        CASE 1: IF BarPos<100 THEN BarPos += 1: Delta =   1: END IF
        CASE 2: IF BarPos>10 THEN BarPos -= 10: Delta = -10: END IF
        CASE 3: IF BarPos<91 THEN BarPos += 10: Delta =  10: END IF
    END SELECT
    ' NB Opposite move direction: eg ScrollBar moves RIGHT -> Contents scrolls LEFT ...etc!
    IF Delta <> 0 THEN
        SetScrollPos(hWnd, Which, BarPos, 1)                ' Set scrollbar pos
        IF Which=SB_HORZ THEN
            PanX = PanX - PanW*Delta/100                    ' Opposite to ScrollBar
        ELSE
            PanY = PanY - PanH*Delta/100                    ' Opposite to ScrollBar
        END IF
        MoveWindow(PanHandle, PanX, PanY, PanW, PanH, 1)    ' Move the inner panel
    END IF
#ENDIF
END SUB


' #15 ====================================================================================
TYPE QSCROLLBAR
' Private (not)
    ObjId AS integer        = Q_SCROLLBAR                   ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = "SCROLLBAR"                   ' Base class
    ObjStyle AS UINT        = 0                             '
    PrivateProperties()                                     ' Common property variables
    xHeight AS integer      = 20
    xKind AS integer        = 0                             ' sbHorizontal
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 100
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled    (value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Kind() AS integer
    DECLARE PROPERTY Kind(value AS integer)
    DECLARE PROPERTY LargeChange() AS integer
    DECLARE PROPERTY LargeChange(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Min() AS integer
    DECLARE PROPERTY Min(value AS integer)
    DECLARE PROPERTY Max() AS integer
    DECLARE PROPERTY Max(value AS integer)
    DECLARE PROPERTY PageSize() AS integer
    DECLARE PROPERTY PageSize(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY SmallChange() AS integer
    DECLARE PROPERTY SmallChange(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBea...
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
    OnChange AS SUB(Sender AS QSCROLLBAR PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QSCROLLBAR PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QSCROLLBAR PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QSCROLLBAR PTR)
    OnScroll AS SUB(ScrollCode AS byte, ScrollPos AS integer, Sender AS QSCROLLBAR PTR)
END TYPE

GeneralProperties(QSCROLLBAR)
PositionalProperties(QSCROLLBAR)
HintProperties(QSCROLLBAR)
ReadOnlyProperties(QSCROLLBAR)

PROPERTY QSCROLLBAR.Kind() AS integer: RETURN xKind: END PROPERTY
PROPERTY QSCROLLBAR.Kind(value AS integer): IF (Value=1) THEN xKind=1: ObjStyle=1: END IF: END PROPERTY
PROPERTY QSCROLLBAR.Min() AS integer: RETURN xMin: END PROPERTY
PROPERTY QSCROLLBAR.Min(value AS integer)
    IF (value >= Min) AND (value < Max) THEN xMin=value: SetScrollRange(Handle, SB_CTL, Min, Max, 1): END IF
END PROPERTY
PROPERTY QSCROLLBAR.Max() AS integer: RETURN xMax: END PROPERTY
PROPERTY QSCROLLBAR.Max(value AS integer)
    IF (value > Min) THEN xMax=value: SetScrollRange(Handle, SB_CTL, Min, Max, 1): END IF
END PROPERTY
PROPERTY QSCROLLBAR.Position() AS integer: RETURN xPosition: END PROPERTY
PROPERTY QSCROLLBAR.Position(value AS integer)
    IF (value >= Min) AND (value <= Max) THEN xPosition=value: SetScrollPos(Handle, SB_CTL, value, 1): END IF
END PROPERTY
PROPERTY QSCROLLBAR.SmallChange() AS integer: RETURN xSmallChange: END PROPERTY
PROPERTY QSCROLLBAR.SmallChange(value AS integer)
    IF (value >= 1) AND (value <= Max) THEN xSmallChange=value: END IF
END PROPERTY
PROPERTY QSCROLLBAR.LargeChange() AS integer: RETURN xLargeChange: END PROPERTY
PROPERTY QSCROLLBAR.LargeChange(value AS integer)
    IF (value >= 1) AND (value <= Max) THEN xLargeChange=value: END IF
END PROPERTY
PROPERTY QSCROLLBAR.PageSize() AS integer: RETURN xPageSize: END PROPERTY
PROPERTY QSCROLLBAR.PageSize(value AS integer)
    IF (value >= 1) AND (value <= Max) THEN xPageSize=value: END IF
END PROPERTY

SUB QSCROLLBAR.PreSetConfig()
END SUB
SUB QSCROLLBAR.PostConfig()
DIM AS SCROLLINFO ScrollInf

    ScrollInf.cbSize=SIZEOF(ScrollInf)
    ScrollInf.fMask=SIF_ALL
    ScrollInf.nMin=Min: ScrollInf.nMax=Max: ScrollInf.nPage=LargeChange: ScrollInf.nPos=Position
    SetScrollInfo(Handle, SB_CTL, @ScrollInf, 1)
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB


' #16 ====================================================================================
TYPE QSTRINGGRID
' Private (not)
    ObjId AS integer        = Q_STRINGGRID                  ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = "STATIC"                      ' Base class
    ObjStyle AS UINT        = SS_OWNERDRAW OR SS_NOTIFY     '
    PrivateProperties()                                     ' Common property variables
    xHeight AS integer      = 100
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 150
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Col AS integer                  ' |INTEGER|RW|
    ColCount AS integer = 3         ' |INTEGER|RW|3
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    ColWidths AS integer = 64       ' |ARRAY -> FIXED my version|RW|64
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBea....
    DefaultColWidth AS integer = 64 ' |INTEGER|RW|50
    DefaultRowHeight AS integer = 20' |INTEGER|RW|18
    EditorMode AS integer           ' |INTEGER|RW|
    FixedColor AS integer           ' |INTEGER|RW|<default>|<default>|<choose>
    FixedCols AS integer = 1        ' |INTEGER|RW|1
    FixedRows AS integer = 1        ' |INTEGER|RW|1
    Font AS HWND                    ' |QFONT|R|<default>
    GridHeight AS integer           ' |INTEGER|RW|
    GridLineWidth AS integer = 1    ' |INTEGER|RW|1
    GridWidth AS integer            ' |INTEGER|RW|
    LeftCol AS integer = 0          ' |INTEGER|RW|0
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    Row AS integer = 0              ' |INTEGER|RW|0
    RowCount AS integer = 8         ' |INTEGER|RW|5
    RowHeights AS integer = 20      ' |ARRAY -> FIXED in my version|RW|18
    ScrollBars AS integer           ' |INTEGER|RW|ssBoth|ssNone|ssHorizontal|ssVertical|ssBoth
    Separator AS string             ' |STRING|RW|
    TabOrder AS integer             ' |INTEGER|RW|
    TopRow AS integer = 0           ' |INTEGER|RW|0
    VisibleColCount AS integer = 3  ' |INTEGER|R|3
    VisibleRowCount AS integer = 5  ' |INTEGER|R|5
''    Cell AS string()                  ' |2D ARRAY of STRING|RW|
''    ColumnList AS string()            ' |ARRAY of STRING|RW|
''    ColumnStyle AS integer()          ' |ARRAY of INTEGER|RW|gcsNone|gcsList|gcsEllipsis|gcsNone
''    ColWidths AS integer()            ' |ARRAY of INTEGER|RW|
''    RowHeights AS integer()           ' |ARRAY of INTEGER|RW|
''    TabStops AS integer()             ' |ARRAY of INTEGER|RW|
' Methods
' Events
    OnDrawCell AS SUB(Col AS integer, Row AS integer, State AS integer, Rct AS RECT PTR, Sender AS QSTRINGGRID PTR)
    OnEllipsisClick AS SUB(Col AS integer, Row AS integer, Sender AS QSTRINGGRID PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QSTRINGGRID PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QSTRINGGRID PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QSTRINGGRID PTR)
    OnListDropDown AS SUB(Col AS integer, Row AS integer, BYREF S AS string, Sender AS QSTRINGGRID PTR)
    OnSelectCell AS SUB(Col AS integer, Row AS integer, CanSelect AS integer, Sender AS QSTRINGGRID PTR)
    OnSetEditText AS SUB(Col AS integer, Row AS integer, Value AS string, Sender AS QSTRINGGRID PTR)
END TYPE

GeneralProperties(QSTRINGGRID)
PositionalProperties(QSTRINGGRID)
HintProperties(QSTRINGGRID)
ReadOnlyProperties(QSTRINGGRID)

PROPERTY QSTRINGGRID.BorderStyle() AS integer: RETURN xBorderStyle: END PROPERTY
PROPERTY QSTRINGGRID.BorderStyle(value AS integer): IF Value<>0 THEN xBorderStyle=1 ELSE xBorderStyle=0: END IF: END PROPERTY

SUB QSTRINGGRID.PreSetConfig()
END SUB
SUB QSTRINGGRID.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #17 ====================================================================================
TYPE QLISTVIEW
' Private (not)
    ObjId AS integer        = Q_LISTVIEW                        ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "SysListView32"                   ' Base class
    ObjStyle AS UINT        = LVS_REPORT                        ' OR LVS_OWNERDATA - user must keep track of all storage
    PrivateProperties()                                         ' Common property variables
    xColumnsCount AS integer= 0
    xGridLines AS integer   = False
    xHeight AS integer      = 100
    xLeft AS integer        = 0
    xRowSelect AS integer   = False
    xShowColumnHeaders AS integer = True
    xTop AS integer         = 0
    xViewStyle AS integer   = vsReport
    xWidth AS integer       = 150
    xSubCount(0 TO 63) AS integer                               ' index of SubItems per Item index
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY ColumnsCount() AS integer
    DECLARE PROPERTY ColumnsCount(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY GridLines() AS integer
    DECLARE PROPERTY GridLines(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY RowSelect() AS integer
    DECLARE PROPERTY RowSelect(value AS integer)
    DECLARE PROPERTY ShowColumnHeaders() AS integer
    DECLARE PROPERTY ShowColumnHeaders(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY ViewStyle() AS integer
    DECLARE PROPERTY ViewStyle(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    CheckBoxes AS integer           ' |INTEGER|RW|False|False|True
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    ColumnClick AS integer          ' |INTEGER|RW|True|False|True
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBea...
    Font AS HWND                    ' |QFONT|R|<default>
    HideSelection AS integer        ' |INTEGER|RW|False|False|True
    HotTrack AS integer             ' |INTEGER|RW|False|False|True
    ItemCount AS integer            ' |INTEGER|RW|
    ItemIndex AS integer            ' |INTEGER|RW|
    LargeImages AS HWND             ' |QIMAGELIST|W|
    MultiSelect AS integer          ' |INTEGER|RW|False|False|True
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    ReadOnly AS integer             ' |INTEGER|RW|False|False|True
    SelCount AS integer             ' |INTEGER|RW|
    SmallImages AS HWND             ' |QIMAGELIST|W|
    SortType AS integer             ' |INTEGER|RW|stNone|stNone|stText
    StateImages AS HWND             ' |QIMAGELIST|W|
    TabOrder AS integer             ' |INTEGER|RW|
''    Column                        ' |ARRAY of ColumnType|RW|
''    Item                          ' |ARRAY of ItemType|RW|
''    Selected                      ' |ARRAY of INTEGER|RW|
''    SubItem                       ' |2D ARRAY of STRING|RW|
' Methods
    DECLARE SUB Clear()
    DECLARE SUB AddColumns(cWidth AS integer, value AS string)      ' FUDGE: One column at a time
    DECLARE SUB AddItems(value AS string)                           ' FUDGE: One string at a time (each Row in col 0)
    DECLARE SUB AddSubItem(index AS integer, value AS string)       ' Add to each column of row index

''    ClearColumns SUB()
''    InsertItem SUB(index AS integer, string AS string)
''    DelItems SUBI(integer,....)
''    DelSubItem SUB(index AS integer, SubIndex AS integer)
''    InsertSubItem SUB(index AS integer, SubIndex AS integer, string AS string)
''    SwapItem SUB(index1 AS integer, index2 AS integer)
' Events
    OnClick AS SUB(Sender AS QLISTVIEW PTR)
    OnChange AS SUB(Index AS integer, Change AS byte, Sender AS QLISTVIEW PTR)
    OnColumnClick AS SUB(Column AS integer, Sender AS QLISTVIEW PTR)
    OnDblClick AS SUB(Sender AS QLISTVIEW PTR)
    OnKeyPressed AS SUB(Key AS byte, Sender AS QLISTVIEW PTR)
END TYPE

GeneralProperties(QLISTVIEW)
PositionalProperties(QLISTVIEW)
HintProperties(QLISTVIEW)
ReadOnlyProperties(QLISTVIEW)

PROPERTY QLISTVIEW.BorderStyle() AS integer: RETURN xBorderStyle: END PROPERTY
PROPERTY QLISTVIEW.BorderStyle(value AS integer): IF value<>0 THEN xBorderStyle=1 ELSE xBorderStyle=0: END IF: END PROPERTY
PROPERTY QLISTVIEW.ColumnsCount() AS integer: RETURN xColumnsCount: END PROPERTY
PROPERTY QLISTVIEW.ColumnsCount(value AS integer): END PROPERTY                 ' Read Only
PROPERTY QLISTVIEW.GridLines() AS integer: RETURN xGridLines: END PROPERTY
PROPERTY QLISTVIEW.GridLines(value AS integer): xGridLines=value: END PROPERTY
PROPERTY QLISTVIEW.RowSelect() AS integer: RETURN xRowSelect: END PROPERTY
PROPERTY QLISTVIEW.RowSelect(value AS integer): xRowSelect=value: END PROPERTY
PROPERTY QLISTVIEW.ShowColumnHeaders() AS integer: RETURN xShowColumnHeaders: END PROPERTY
PROPERTY QLISTVIEW.ShowColumnHeaders(value AS integer)
    IF value<>0 THEN xShowColumnHeaders=1 ELSE xShowColumnHeaders=0: END IF
END PROPERTY
PROPERTY QLISTVIEW.ViewStyle() AS integer: RETURN xViewStyle: END PROPERTY
PROPERTY QLISTVIEW.ViewStyle(value AS integer): END PROPERTY                    ' FUDGE: Only one style!

SUB QLISTVIEW.Clear
    SendMessage(Handle, LVM_DELETEALLITEMS, 0, 0)
    Erase(xSubCount)
END SUB
SUB QLISTVIEW.AddColumns(cWidth AS integer, value AS string)
DIM AS LVCOLUMN lvColmn
    lvColmn.mask=LVCF_FMT OR LVCF_TEXT OR LVCF_WIDTH
    lvColmn.fmt=LVCFMT_LEFT: lvColmn.cx=cWidth: lvColmn.pszText=STRPTR(value)
    SendMessage(Handle, LVM_INSERTCOLUMN, xColumnsCount, CAST(LPARAM, @lvColmn))
    xColumnsCount += 1
END SUB
SUB QLISTVIEW.AddItems(value AS string)
DIM AS LVITEM lvItm
DIM AS integer itmCount=SendMessage(Handle,LVM_GETITEMCOUNT,0,0)
    lvItm.mask=LVIF_TEXT: lvItm.iItem=itmCount: lvItm.pszText=STRPTR(value): lvItm.cchTextMax=LEN(value)+1
    SendMessage(Handle, LVM_INSERTITEM, 0, CAST(LPARAM, @lvItm))
END SUB
SUB QLISTVIEW.AddSubItem(index AS integer, value AS string)
DIM AS LVITEM lvItm
    xSubCount(index) += 1
    lvItm.mask=LVIF_TEXT: lvItm.iItem=index: lvItm.iSubItem=xSubCount(index)
    lvItm.pszText=STRPTR(value): lvItm.cchTextMax=LEN(value)+1
    SendMessage(Handle, LVM_SETITEM, 0, CAST(LPARAM, @lvItm))
END SUB

SUB QLISTVIEW.PreSetConfig()
    IF ShowColumnHeaders=False THEN ObjStyle += LVS_NOCOLUMNHEADER
END SUB
SUB QLISTVIEW.PostConfig()
    IF GridLines=True THEN ListView_SetExtendedListViewStyle(Handle,LVS_EX_GRIDLINES)
    IF RowSelect=True THEN ListView_SetExtendedListViewStyle(Handle,LVS_EX_FULLROWSELECT)
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB


' #18 ====================================================================================
TYPE QDIRTREE
' Private (not)
    ObjId AS integer        = Q_DIRTREE                         ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "SysTreeView32"                   ' Base class
    ObjStyle AS UINT        = TVS_HASLINES OR TVS_LINESATROOT OR TVS_HASBUTTONS             '  TVS_CHECKBOXES
    PrivateProperties()                                         ' Common property variables
    xDirectory AS string*64 = ""
    xDrive AS string*4      = LEFT(Application.Path,3)
    xHeight AS integer      = 150
    xInitialDir AS string*64= Application.Path
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 150

' Extras
    hImgList AS HIMAGELIST
    xHistory(0 TO 7) AS string*128
    xLevel AS integer = 0
    xLayer1 AS HTREEITEM

    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE SUB UpdateTreeView(lParm AS LPARAM)
    DECLARE SUB xLoadImages()
    DECLARE FUNCTION xAddItem(txtFolder AS string, Prev AS HTREEITEM) AS HTREEITEM
    DECLARE SUB xFillTree(stFolder AS string)
    DECLARE SUB xClearEntireTree()

' Properties
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Directory() AS string
    DECLARE PROPERTY Directory(value AS string)
    DECLARE PROPERTY Drive() AS string
    DECLARE PROPERTY Drive(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY InitialDir() AS string
    DECLARE PROPERTY InitialDir(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|crSize|crSizeN..
    FastLoad AS integer             ' |INTEGER|RW|False|False|True
    Font AS HWND                    ' |QFONT|R|<default>
    HideSelection AS integer        ' |INTEGER|RW|False|False|True
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    ReadOnly AS integer             ' |INTEGER|RW|False|False|True
    ReadOnStart AS integer          ' |INTEGER|RW|False|False|True
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
    DECLARE SUB Reload
' Events
    OnChange AS SUB(Sender AS QDIRTREE PTR)
END TYPE

GeneralProperties(QDIRTREE)
PositionalProperties(QDIRTREE)
HintProperties(QDIRTREE)
ReadOnlyProperties(QDIRTREE)

PROPERTY QDIRTREE.BorderStyle() AS integer: RETURN xBorderStyle: END PROPERTY
PROPERTY QDIRTREE.BorderStyle(value AS integer): IF value<>0 THEN xBorderStyle=1 ELSE xBorderStyle=0: END IF: END PROPERTY
PROPERTY QDIRTREE.Directory() AS string: RETURN xDirectory: END PROPERTY
PROPERTY QDIRTREE.Directory(value AS string): END PROPERTY
PROPERTY QDIRTREE.Drive() AS string: RETURN xDrive: END PROPERTY
PROPERTY QDIRTREE.Drive(value AS string): END PROPERTY                      ' FUDGE: Currently read only
PROPERTY QDIRTREE.InitialDir() AS string: RETURN xInitialDir: END PROPERTY
PROPERTY QDIRTREE.InitialDir(value AS string): xInitialDir=value: END PROPERTY

SUB QDIRTREE.Reload
xClearEntireTree
xFillTree(InitialDir)
Directory=InitialDir
'TreeView_Expand(Handle, xLayer1, TVE_EXPAND)
END SUB

SUB QDIRTREE.UpdateTreeView(lParm AS LPARAM)
DIM AS NMTREEVIEW PTR lpTview = CAST(NMTREEVIEW PTR, lParm)
DIM AS HTREEITEM Curnt
DIM AS TVITEMEX TVitem
DIM AS string*64 tstr

    Curnt=CAST(HTREEITEM, SendMessage(Handle, TVM_GETNEXTITEM, TVGN_CARET, 0))
    TVitem.mask=TVIF_HANDLE OR TVIF_TEXT
    TVitem.hItem=Curnt
    TVitem.pszText=STRPTR(tstr): TVitem.cchTextMax=64
    SendMessage(Handle, TVM_GETITEM, 0, CAST(LPARAM, @TVItem))
    IF (TVitem.Mask AND TVIF_TEXT)>0 THEN               ' Text valid?
        CHDIR tstr
        xDirectory=CURDIR                               ' READ only???????
        xClearEntireTree()
        xFillTree(CURDIR)
'        ShowMessage(Directory)
    END IF
END SUB

SUB QDIRTREE.xClearEntireTree()
    TreeView_DeleteAllItems(Handle)
    FOR i AS integer = 0 TO 7: xHistory(i)="": NEXT i
    xLevel=0
END SUB

SUB QDIRTREE.xLoadImages
DIM AS HICON hIco

#IFDEF __DIRTREE
    hImgList=ImageList_Create(GetSystemMetrics(SM_CXSMICON), _
                        GetSystemMetrics(SM_CYSMICON), ILC_COLORDDB OR ILC_MASK, 2, 0)

    FOR i AS integer = 3 TO 4
        hIco=ExtractIcon(0, "Shell32.DLL", i)
        ImageList_ReplaceIcon(hImgList, -1, hIco)
        DestroyIcon(hIco)
    NEXT i
'    ShowMessage(STR(ImageList_GetImageCount(hImgList)))
    TreeView_SetImageList(Handle, hImgList, TVSIL_NORMAL)
#ENDIF
END SUB

FUNCTION QDIRTREE.xAddItem(txtFolder AS string, Prev AS HTREEITEM) AS HTREEITEM
DIM AS TVINSERTSTRUCT tvIns

    CLEAR(tvIns, 0, LEN(tvIns))
    tvIns.Item.Mask=TVIF_TEXT OR TVIF_IMAGE OR TVIF_SELECTEDIMAGE
    tvIns.item.pszText=STRPTR(txtFolder)
    tvIns.item.cchTextMax=LEN(txtFolder)
    tvIns.item.iImage=0
    tvIns.item.iSelectedImage=1
    tvIns.hInsertAfter=0
    tvIns.hParent=Prev
    RETURN TreeView_InsertItem(Handle, @tvIns)
END FUNCTION

SUB QDIRTREE.xFillTree(stFolder AS string)
DIM AS string tstr
DIM AS HTREEITEM hPrev

    tstr=stFolder
    tstr=rqREPLACESUBSTR(tstr,"/","\")              ' Just in case!
    xLayer1 = xAddItem(tstr,TVI_ROOT)
    IF RIGHT(tstr,1)<>"\" THEN tstr += "\*" ELSE tstr += "*"
    tstr=DIR(tstr,&h10)
    WHILE tstr<>""
        IF NOT((tstr=".") OR (tstr="..")) THEN
            hPrev = xAddItem(tstr, xLayer1)
            xHistory(xLevel)=xHistory(xLevel)+tstr+"~"
        END IF
        tstr=DIR()
    WEND
    xLevel += 1
END SUB

SUB QDIRTREE.PreSetConfig()
END SUB

SUB QDIRTREE.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
    CHDIR InitialDir
    xLoadImages
    xFillTree(CURDIR)
    xDirectory=CURDIR
END SUB



' #19 ====================================================================================
TYPE QFILELISTBOX
' Private (not)
    ObjId AS integer        = Q_FILELISTBOX                     ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "LISTBOX"                         ' Base class
    ObjStyle AS UINT        = WS_VSCROLL OR WS_HSCROLL OR LBS_NOTIFY            ' OR LBS_DISABLENOSCROLL
    PrivateProperties()                                         ' Common property variables
    xDirectory AS string    = Application.Path
    xDrive AS string        = "C:"
    xFilename AS string*128 = ""
    xHeight AS integer      = 150
    xItem(1) AS string
    xItemCount AS integer   = 0
    xItemIndex AS integer   = -1
    xLeft AS integer        = 0
    xMask AS string         = "*.*"
    xTop AS integer         = 0
    xTopIndex AS integer    = 0
    xWidth AS integer       = 150

' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE SUB Clear()
    DECLARE SUB FillItems()
    DECLARE SUB SelectFile()

' Properties
    DECLARE PROPERTY Directory() AS string
    DECLARE PROPERTY Directory(value AS string)
    DECLARE PROPERTY Drive() AS string
    DECLARE PROPERTY Drive(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY FileName() AS string
    DECLARE PROPERTY FileName(value AS string)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Item(idx AS integer) AS string
    DECLARE PROPERTY Item(idx AS integer,value AS string)
    DECLARE PROPERTY ItemCount() AS integer
    DECLARE PROPERTY ItemCount(value AS integer)
    DECLARE PROPERTY ItemIndex() AS integer
    DECLARE PROPERTY ItemIndex(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Mask() AS string
    DECLARE PROPERTY Mask(value AS string)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY TopIndex() AS integer
    DECLARE PROPERTY TopIndex(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|crSize|crSiz.....
    ExtendedSelect AS integer       ' |INTEGER|RW|False|False|True
    Font AS HWND                    ' |QFONT|R|<default>
    ItemHeight AS integer           ' |INTEGER|RW|
    MultiSelect AS integer          ' |INTEGER|RW|False|False|True
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    SelCount AS integer             ' |INTEGER|R|
''    Selected() AS integer           ' |ARRAY of INTEGER|RW|
    ShowIcons AS integer            ' |INTEGER|RW|False|False|True
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
    OnChange AS SUB(Sender AS QFILELISTBOX PTR)
    OnClick AS SUB(Sender AS QFILELISTBOX PTR)
    OnDblClick AS SUB(Sender AS QFILELISTBOX PTR)
END TYPE

GeneralProperties(QFILELISTBOX)
PositionalProperties(QFILELISTBOX)
HintProperties(QFILELISTBOX)
ReadOnlyProperties(QFILELISTBOX)

PROPERTY QFILELISTBOX.Item(idx AS integer) AS string
DIM AS string*256 zItemTxt: SendMessage(Handle, LB_GETTEXT, idx, CAST(LPARAM, @zItemTxt)): RETURN zItemTxt
END PROPERTY
PROPERTY QFILELISTBOX.Item(idx AS integer,value AS string): END PROPERTY      ' Do nothing
PROPERTY QFILELISTBOX.Directory(value AS string): xDirectory=value: Clear(): FillItems(): END PROPERTY
PROPERTY QFILELISTBOX.Directory() AS string: RETURN xDirectory: END PROPERTY
PROPERTY QFILELISTBOX.Drive(value AS string): xDrive=value: END PROPERTY
PROPERTY QFILELISTBOX.Drive() AS string: RETURN xDrive: END PROPERTY
PROPERTY QFILELISTBOX.Filename(value AS string): END PROPERTY               ' Read only
PROPERTY QFILELISTBOX.Filename() AS string: SelectFile(): RETURN xFileName: END PROPERTY
PROPERTY QFILELISTBOX.Mask(value AS string): xMask=value: Clear(): FillItems(): END PROPERTY
PROPERTY QFILELISTBOX.Mask() AS string: RETURN xMask: END PROPERTY
PROPERTY QFILELISTBOX.ItemCount(value AS integer): END PROPERTY
PROPERTY QFILELISTBOX.ItemCount() AS integer: xItemCount=SendMessage(Handle, LB_GETCOUNT, 0, 0): RETURN xItemCount: END PROPERTY
PROPERTY QFILELISTBOX.ItemIndex(value AS integer): SendMessage(Handle, LB_SETCURSEL, value, 0): xItemIndex=value: END PROPERTY
PROPERTY QFILELISTBOX.ItemIndex() AS integer: xItemIndex=SendMessage(Handle, LB_GETCURSEL, 0, 0): RETURN xItemIndex: END PROPERTY
PROPERTY QFILELISTBOX.TopIndex(value AS integer)
IF (value>=0) AND (value<ItemCount) THEN SendMessage(Handle, LB_SETTOPINDEX, CAST(WPARAM, value), 0): xTopIndex=value: END IF
END PROPERTY
PROPERTY QFILELISTBOX.TopIndex() AS integer: xTopIndex=SendMessage(Handle, LB_GETTOPINDEX, 0, 0): RETURN xTopIndex: END PROPERTY

SUB QFILELISTBOX.SelectFile()
DIM AS string*128 tstr
DIM AS string*64 tok
    IF RIGHT(Directory,1)="\" THEN tstr=Directory ELSE tstr=Directory+"\"
    SendMessage(Handle, LB_GETTEXT, ItemIndex, CAST(LPARAM,@tok))
    tstr += tok
    xFileName=tstr
END SUB
SUB QFILELISTBOX.FillItems()
DIM AS string FName, tstr
    tstr=Directory: IF RIGHT(tstr,1)<>"\" THEN tstr += "\"
    FName=DIR(tstr+Mask, &h2f)
    WHILE LEN(FName)>0
        SendMessage(Handle, LB_INSERTSTRING, ItemCount, CAST(LPARAM, STRPTR(FName)))
        FName=DIR()
    WEND
END SUB
SUB QFILELISTBOX.Clear()
    SendMessage(Handle, LB_RESETCONTENT, 0, 0)
END SUB
SUB QFILELISTBOX.PreSetConfig()
END SUB
SUB QFILELISTBOX.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
    Clear()
    FillItems()
END SUB




' #20 ====================================================================================
TYPE QTREEVIEW
' Private (not)
    ObjId AS integer        = Q_TREEVIEW                        ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "SysTreeView32"                   ' Base class
    ObjStyle AS UINT        = TVS_HASLINES OR TVS_LINESATROOT OR TVS_HASBUTTONS
    PrivateProperties()                                         ' Common property variables
    xHeight AS integer      = 100
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 120
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    BorderStyle AS integer          ' |INTEGER|RW|bsSingle|bsNone|bsSingle
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBe...
    Font AS HWND                    ' |QFONT|R|<default>
    HideSelection AS integer = 0    ' |INTEGER|RW|False|False|True
    Images AS UINT                  ' QIMAGELIST PTR !!!
    Indent AS integer = 20          ' |INTEGER|RW|19
    ItemCount AS integer            ' |INTEGER|RW|
    ItemIndex AS integer            ' |INTEGER|RW|
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    ReadOnly AS integer = 0         ' |INTEGER|RW|False|False|True
    ShowButtons AS integer = 1      ' |INTEGER|RW|True|False|True
    ShowLines AS integer = 1        ' |INTEGER|RW|True|False|True
    ShowRoot AS integer = 1         ' |INTEGER|RW|True|False|True
    SortType AS integer = 0         ' |INTEGER|RW|stText|stNone|stText|
    StateImages AS UINT             ' QIMAGELIST PTR !!!
    TabOrder AS integer             ' |INTEGER|RW|
''    Item                          ' |ARRAY of TreeNodeType|RW|
' Methods
''    AddItems                      ' |STRING|W|
' Events
    OnClick AS SUB(Sender AS QTREEVIEW PTR)
    OnChange AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnChanging AS SUB(Index AS integer, AllowChange AS integer, Sender AS QTREEVIEW PTR)
    OnCollapse AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnCollapsing AS SUB(Index AS integer, AllowCollapse AS integer, Sender AS QTREEVIEW PTR)
    OnDblClick AS SUB(Sender AS QTREEVIEW PTR)
    OnDeletion AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnEdited AS SUB(Index AS integer, BYREF S AS string, Sender AS QTREEVIEW PTR)
    OnEditing AS SUB(Index AS integer, AllowEdit AS integer, Sender AS QTREEVIEW PTR)
    OnExpand AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnExpanding AS SUB(Index AS integer, AllowExpansion AS integer, Sender AS QTREEVIEW PTR)
    OnGetImageIndex AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnGetSelectedIndex AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QTREEVIEW PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QTREEVIEW PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QTREEVIEW PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QTREEVIEW PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QTREEVIEW PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QTREEVIEW PTR)
END TYPE

GeneralProperties(QTREEVIEW)
PositionalProperties(QTREEVIEW)
HintProperties(QTREEVIEW)
ReadOnlyProperties(QTREEVIEW)

SUB QTREEVIEW.PreSetConfig()
END SUB
SUB QTREEVIEW.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB


' #21 ====================================================================================
TYPE QOUTLINE
' Private (not)
    ObjId AS integer        = Q_OUTLINE                     ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = ""                            ' Base class
    ObjStyle AS UINT        = 0                             '
    PrivateProperties()                                     ' Common property variables
    xHeight AS integer      = 0
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 0
' Properties
' Methods
' Events
END TYPE


' #22 ====================================================================================
TYPE QGAUGE
' Private (not)
    ObjId AS integer        = Q_GAUGE                       ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*16   = "STATIC"                      ' Base class
    ObjStyle AS UINT        = SS_OWNERDRAW                  '
    PrivateProperties()                                     ' Common property variables
    xBackColor AS integer   = &hffffff
    xColor AS integer       = &h9f9f9f
    xForeColor AS integer   = 0
    xHeight AS integer      = 25
    xShowText AS integer    = True
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 100
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE SUB GaugeDraw(lParm AS LPARAM)

' Properties
    DECLARE PROPERTY BackColor() AS integer
    DECLARE PROPERTY BackColor(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY ForeColor() AS integer
    DECLARE PROPERTY ForeColor(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Min() AS integer
    DECLARE PROPERTY Min(value AS integer)
    DECLARE PROPERTY Max() AS integer
    DECLARE PROPERTY Max(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY ShowText() AS integer
    DECLARE PROPERTY ShowText(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|crSize|crSizeNE...
    Font AS HWND                    ' |QFONT|R|<default>
    Kind AS integer                 ' |INTEGER|RW|gkHorizontalBar|gkText|gkHorizontalBar|gkVerticalBar|gkPie|gkNeedle
' Methods
' Events
END TYPE

GeneralProperties(QGAUGE)
PositionalProperties(QGAUGE)
HintProperties(QGAUGE)
ReadOnlyProperties(QGAUGE)

PROPERTY QGAUGE.BackColor() AS integer: RETURN xBackColor: END PROPERTY
PROPERTY QGAUGE.BackColor(value AS integer): xBackColor=value: END PROPERTY

PROPERTY QGAUGE.BorderStyle() AS integer: RETURN xBorderStyle: END PROPERTY
PROPERTY QGAUGE.BorderStyle(value AS integer): IF Value<>0 THEN xBorderStyle=1 ELSE xBorderStyle=0: END IF: END PROPERTY
PROPERTY QGAUGE.Color() AS integer: RETURN xColor: END PROPERTY
PROPERTY QGAUGE.Color(value AS integer): xColor=value: END PROPERTY
PROPERTY QGAUGE.ForeColor() AS integer: RETURN xForeColor: END PROPERTY
PROPERTY QGAUGE.ForeColor(value AS integer): xForeColor=value: END PROPERTY
PROPERTY QGAUGE.Min() AS integer: RETURN xMin: END PROPERTY
PROPERTY QGAUGE.Min(value AS integer): IF (value >= 0) AND (value < Max) THEN xMin=value: END IF: END PROPERTY
PROPERTY QGAUGE.Max() AS integer: RETURN xMax: END PROPERTY
PROPERTY QGAUGE.Max(value AS integer): IF value > Min THEN xMax=value: END IF: END PROPERTY
PROPERTY QGAUGE.Position() AS integer: RETURN xPosition: END PROPERTY
PROPERTY QGAUGE.Position(value AS integer)
IF (value >= Min) AND (value <= Max) THEN: xPosition=value: InvalidateRect(Handle,NULL,1): END IF
END PROPERTY
PROPERTY QGAUGE.ShowText() AS integer: RETURN xShowText: END PROPERTY
PROPERTY QGAUGE.ShowText(value AS integer): IF Value<>0 THEN Value=1: END IF: xShowText=value: END PROPERTY

SUB QGAUGE.GaugeDraw(lParm AS LPARAM)
DIM AS DRAWITEMSTRUCT PTR lpDrawItStr=CAST(DRAWITEMSTRUCT PTR, lParm)
DIM AS RECT rct, tmpRECT
DIM AS HGDIOBJ Original                                                 ' Save original

    IF Visible=False THEN EXIT SUB
    Original=SelectObject(lpDrawItStr->hDC, GetStockObject(DC_BRUSH))
    rct=lpDrawItStr->rcItem

    IF lpDrawItStr->itemState AND ODS_DISABLED THEN                         ' Gauge disabled?
        SetDCBrushColor(lpDrawItStr->hDC, CAST(COLORREF, &hbfbfbf))         ' Color gauge disabled
        Rectangle(lpDrawItStr->hDC, rct.Left, rct.Top, rct.Right, rct.Bottom)
        SetDCBrushColor(lpDrawItStr->hDC, CAST(COLORREF, &h7f7f7f))         ' Color gauge disabled
        Rectangle(lpDrawItStr->hDC, rct.Left, rct.Top, (rct.Right-rct.Left)\2, rct.Bottom)
        IF ShowText THEN
            DIM GaugeText AS string*64 = "Disabled"
            DIM AS integer lenth = LEN(RTRIM(GaugeText))
            SetTextColor(lpDrawItStr->hDC, CAST(COLORREF, 0))               ' Text disabled
            SetBKMode(lpDrawItStr->hDC, 1)                                  ' Transparent
            DrawText(lpDrawItStr->hDC, GaugeText, lenth, @rct, DT_CENTER OR DT_SINGLELINE OR DT_VCENTER)
        END IF
    ELSE
        DIM AS integer lenth = Position*100/Max                             ' Pos * Step value
        SetDCBrushColor(lpDrawItStr->hDC, CAST(COLORREF, BackColor))        ' Color gauge
        IF BorderStyle=0 THEN
            FillRect(lpDrawItStr->hDC, @rct, CAST(HBRUSH, BackColor))
        ELSE
            Rectangle(lpDrawItStr->hDC, rct.Left, rct.Top, rct.Right, rct.Bottom)
        END IF
        SetDCBrushColor(lpDrawItStr->hDC, CAST(COLORREF, ForeColor))        ' Color gauge bar
        IF BorderStyle=0 THEN
            tmpRECT=rct: tmpRECT.Right=lenth
            FillRect(lpDrawItStr->hDC, @tmpRECT, CAST(HBRUSH, ForeColor))
        ELSE
            Rectangle(lpDrawItStr->hDC, rct.Left, rct.Top, lenth, rct.Bottom)
        END IF
        IF ShowText THEN
            DIM GaugeText AS string*64 = STR(Position*100/Max)+"%"
            lenth = LEN(RTRIM(GaugeText))
            SetTextColor(lpDrawItStr->hDC, CAST(COLORREF, Color))           ' Color gauge
            SetBKMode(lpDrawItStr->hDC, 0)                                  ' Transparent
            DrawText(lpDrawItStr->hDC, GaugeText, lenth, @rct, DT_CENTER OR DT_SINGLELINE OR DT_VCENTER)
        END IF
    END IF
    SelectObject(lpDrawItStr->hDC, Original)                                ' Set back to original
END SUB

SUB QGAUGE.PreSetConfig()
END SUB
SUB QGAUGE.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #23 ====================================================================================
TYPE QTRACKBAR
' Private (not)
    ObjId AS integer        = Q_TRACKBAR                    ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*18   = "msctls_trackbar32"           ' Base class
    ObjStyle AS UINT        = TBS_ENABLESELRANGE OR TBS_AUTOTICKS OR TBS_TOOLTIPS
    PrivateProperties()                                     ' Common property variables
    xFrequency AS integer   = 10
    xHeight AS integer      = 45
    xLeft AS integer        = 0
    xOrientation AS integer = tbHorizontal
    xTickMarks AS integer   = tmBottomRight
    xTickStyle AS integer   = tsAuto
    xTop AS integer         = 0
    xWidth AS integer       = 150
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Properties
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Frequency() AS integer
    DECLARE PROPERTY Frequency(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Min() AS integer
    DECLARE PROPERTY Min(value AS integer)
    DECLARE PROPERTY Max() AS integer
    DECLARE PROPERTY Max(value AS integer)
    DECLARE PROPERTY Orientation() AS integer
    DECLARE PROPERTY Orientation(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY TickMarks() AS integer
    DECLARE PROPERTY TickMarks(value AS integer)
    DECLARE PROPERTY TickStyle() AS integer
    DECLARE PROPERTY TickStyle(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBe...
    LineSize AS integer = 1         ' |INTEGER|RW|1
    PageSize AS integer = 2         ' |INTEGER|RW|2
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    SelEnd AS integer               ' |INTEGER|RW|
    SelStart AS integer             ' |INTEGER|RW|
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
    OnChange AS SUB(Sender AS QTRACKBAR PTR)
END TYPE

GeneralProperties(QTRACKBAR)
PositionalProperties(QTRACKBAR)
HintProperties(QTRACKBAR)
ReadOnlyProperties(QTRACKBAR)

PROPERTY QTRACKBAR.Frequency() AS integer: RETURN xFrequency: END PROPERTY
PROPERTY QTRACKBAR.Frequency(value AS integer): xFrequency=value: END PROPERTY
PROPERTY QTRACKBAR.Orientation() AS integer: RETURN xOrientation: END PROPERTY
PROPERTY QTRACKBAR.Orientation(value AS integer): IF value<>0 THEN value=1: END IF: xOrientation=value: END PROPERTY
PROPERTY QTRACKBAR.TickMarks() AS integer: RETURN xTickMarks: END PROPERTY
PROPERTY QTRACKBAR.TickMarks(value AS integer): IF (value >= 0) AND (value <=2) THEN xTickMarks=value: END IF: END PROPERTY
PROPERTY QTRACKBAR.TickStyle() AS integer: RETURN xTickStyle: END PROPERTY
PROPERTY QTRACKBAR.TickStyle(value AS integer): IF (value >= 0) AND (value <=2) THEN xTickStyle=value: END IF: END PROPERTY
PROPERTY QTRACKBAR.Min() AS integer: RETURN xMin: END PROPERTY
PROPERTY QTRACKBAR.Min(value AS integer)
    IF (value >= 0) AND (value < Max) THEN xMin=value: SendMessage(Handle, TBM_SETRANGE, 1, MAKELPARAM(Min, Max)): END IF
END PROPERTY
PROPERTY QTRACKBAR.Max() AS integer: RETURN xMax: END PROPERTY
PROPERTY QTRACKBAR.Max(value AS integer)
    IF value > Min THEN xMax=value: SendMessage(Handle, TBM_SETRANGE, 1, MAKELPARAM(Min, Max)): END IF
END PROPERTY
PROPERTY QTRACKBAR.Position() AS integer: RETURN xPosition: END PROPERTY
PROPERTY QTRACKBAR.Position(value AS integer)
    IF (value >= Min) AND (value <= Max) THEN xPosition=value: SendMessage(Handle, TBM_SETPOS, 1, CAST(LPARAM, value)): END IF
END PROPERTY

SUB QTRACKBAR.PreSetConfig()
    IF Orientation=tbVertical THEN ObjStyle += TBS_VERT
    IF TickMarks=tmBoth THEN
        ObjStyle += TBS_BOTH
    ELSEIF TickMarks=tmTopLeft THEN
        IF Orientation=tbHorizontal THEN ObjStyle += TBS_TOP ELSE ObjStyle += TBS_LEFT
    ELSE
        IF Orientation=tbHorizontal THEN ObjStyle += TBS_BOTTOM ELSE ObjStyle += TBS_RIGHT
    END IF
END SUB
SUB QTRACKBAR.PostConfig()
DIM AS UINT value=0
    IF TickStyle<>0 THEN SendMessage(Handle, TBM_SETTICFREQ, CAST(WPARAM,10), 0)
    IF TickMarks=tmBottomRight THEN
        IF Orientation=tbHorizontal THEN value=TBTS_TOP ELSE value=TBTS_LEFT
    ELSE
        IF Orientation=tbHorizontal THEN value=TBTS_BOTTOM ELSE value=TBTS_RIGHT
    END IF
    SendMessage(Handle, TBM_SETTIPSIDE, CAST(WPARAM,value), 0)
    SendMessage(Handle, WM_SETFONT, CAST(WPARAM,Application.hfont), 1)
END SUB



' #24 ====================================================================================
TYPE QHEADER
' Private (not)
    ObjId AS integer        = Q_HEADER                          ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "SysHeader32"                     ' Base class
    ObjStyle AS UINT        = WS_BORDER OR HDS_BUTTONS OR HDS_HORZ
    PrivateProperties()                                         ' Common property variables
    xSectionsCount AS integer = 4
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY SectionsCount() AS integer
    DECLARE PROPERTY SectionsCount(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)

    Align AS integer                ' |INTEGER|RW|alTop|alNone|alTop|alBottom|alLeft|alRight|alClient
    ClientHeight AS integer         ' |INTEGER|RW|
    ClientWidth AS integer          ' |INTEGER|RW|
    CopyMode AS integer             ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCop...
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBea...
    Font AS HWND                    ' |QFONT|R|<default>
    Height AS integer
    HotTrack AS integer             ' |INTEGER|RW|False|False|True
    Left AS integer
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    Top AS integer
    Width AS integer
''    Pixel                         ' |2D ARRAY of INTEGER|RW|
''    Sections                      ' |ARRAY of SectionsType|RW|
' Methods
    DECLARE SUB AddSections(value AS string)         ' BIG cheat: ONE section at a time!
' Events
    OnDrawSection AS SUB(Index AS integer, Pressed AS integer, Rct AS RECT PTR, Sender AS QHEADER PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QHEADER PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QHEADER PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QHEADER PTR)
    OnResize AS SUB(Sender AS QHEADER PTR)
    OnSectionClick AS SUB(Index AS integer, Sender AS QHEADER PTR)
    OnSectionResize AS SUB(Index AS integer, Sender AS QHEADER PTR)
    OnSectionTrack AS SUB(Index AS integer, Width AS integer, State AS integer, Sender AS QHEADER PTR)
END TYPE

GeneralProperties(QHEADER)
HintProperties(QHEADER)
ReadOnlyProperties(QHEADER)
PROPERTY QHEADER.SectionsCount() AS integer: RETURN xSectionsCount: END PROPERTY
PROPERTY QHEADER.SectionsCount(value AS integer): xSectionsCount=value: END PROPERTY

SUB QHEADER.AddSections(value AS string)
DIM AS integer i=SendMessage(Handle,HDM_GETITEMCOUNT,0,0)
DIM AS RECT rct
DIM AS HD_LAYOUT Layout
DIM AS WINDOWPOS wPos
DIM AS HDITEMA hdItem

    GetClientRect(GetParent(Handle), @rct)
    IF i=0 THEN
        Layout.prc=@rct
        Layout.pwpos=@wPos
        SendMessage(Handle, HDM_LAYOUT, 0, CAST(LPARAM, @Layout))
        SetWindowPos(Handle, wPos.hwndInsertAfter, wPos.x, wPos.y, wPos.cx, _
                                            wPos.cy, wPos.flags OR SWP_SHOWWINDOW)
    END IF
    hdItem.mask=HDI_TEXT OR HDI_FORMAT OR HDI_WIDTH
    hdItem.fmt=HDF_CENTER OR HDF_STRING
    hdItem.cxy=(rct.Right-rct.Left)\SectionsCount
    hdItem.cchTextMax=LEN(value)+1
    hdItem.pszText=STRPTR(value)
    SendMessage(Handle, HDM_INSERTITEM, 0, CAST(LPARAM, @hdItem))
    ' HDM_INSERTITEM: wparam = 1 (insertAfter) "upsets" the order, so...
    '             use wparam = 0 (insertAfter=False) and insert items backwards!
END SUB

SUB QHEADER.PreSetConfig()
END SUB
SUB QHEADER.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #25 ====================================================================================
TYPE QSTATUSBAR
' Private (not)
    ObjId AS integer        = Q_STATUSBAR                       ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "msctls_statusbar32"              ' Base class
    ObjStyle AS UINT        = 0                                 '
    PrivateProperties()                                         ' Common property variables
    xSimpleText AS string   = ""
    xSimplePanel AS integer = True
    xSizeGrip AS integer    = True
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY SimplePanel() AS integer
    DECLARE PROPERTY SimplePanel(value AS integer)
    DECLARE PROPERTY SimpleText() AS string
    DECLARE PROPERTY SimpleText(value AS string)
    DECLARE PROPERTY SizeGrip() AS integer
    DECLARE PROPERTY SizeGrip(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)

    Align AS integer                ' |INTEGER|RW|alBottom|alNone|alTop|alBottom|alLeft|alRight|alClient
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBea.....
    Height AS integer = 20          ' |INTEGER|RW|19
    Left AS integer                 ' |INTEGER|RW|
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    TabOrder AS integer             ' |INTEGER|RW|
    Top AS integer                  ' |INTEGER|RW|
    Width AS integer                ' |INTEGER|RW|
''    Panel                         ' |ARRAY of PanelType|RW|
' Methods
''    DECLARE SUB AddPanels(...)                  ' STRING, infinite
    DECLARE SUB Clear()
' Events
    OnResize AS SUB(Sender AS QSTATUSBAR PTR)
END TYPE

GeneralProperties(QSTATUSBAR)
HintProperties(QSTATUSBAR)
ReadOnlyProperties(QSTATUSBAR)
PROPERTY QSTATUSBAR.SimpleText() AS string: RETURN xSimpleText: END PROPERTY
PROPERTY QSTATUSBAR.SimpleText(value AS string): xSimpleText=value: SetWindowText(Handle, xSimpleText): END PROPERTY
PROPERTY QSTATUSBAR.SimplePanel() AS integer: RETURN xSimplePanel: END PROPERTY
PROPERTY QSTATUSBAR.SimplePanel(Value AS integer): IF value=0 THEN xSimplePanel=0 ELSE xSimplePanel=1: END IF: END PROPERTY
PROPERTY QSTATUSBAR.SizeGrip() AS integer: RETURN xSizeGrip: END PROPERTY
PROPERTY QSTATUSBAR.SizeGrip(Value AS integer): IF value=0 THEN xSizeGrip=0 ELSE xSizeGrip=1: END IF: END PROPERTY

SUB QSTATUSBAR.Clear()
    SimpleText=""
    SetWindowText(Handle, "")
END SUB

SUB QSTATUSBAR.PreSetConfig()
    IF SizeGrip=True THEN ObjStyle += SBARS_SIZEGRIP            ' Defaults to (always) on!!
END SUB
SUB QSTATUSBAR.PostConfig()
'DIM AS UINT tStyle
'    IF SizeGrip=False THEN
'        tStyle = GetWindowLong(Handle, GWL_STYLE) - SBARS_SIZEGRIP - WS_THICKFRAME
'        SetWindowLong(Handle, GWL_STYLE, tStyle)
'    END IF
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #26 ====================================================================================
TYPE QCANVAS
' Private (not)
    ObjId AS integer        = Q_CANVAS                          ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "STATIC"                          ' Base class
    ObjStyle AS UINT        = WS_CLIPCHILDREN OR SS_NOTIFY                                 '
    PrivateProperties()                                         ' Common property variables
    xHeight AS integer      = 105
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 105
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
    ClientHeight AS integer         ' |INTEGER|RW|
    ClientWidth AS integer          ' |INTEGER|RW|
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    CopyMode AS integer             ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCopy|cmMer...
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|crSiz...
    Font AS HWND                    ' |QFONT|R|<default>
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
''    Pixel                           ' |ARRAY of INTEGER|RW|
' Methods
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect(D AS RECT PTR, Image AS HWND, S AS RECT PTR)
''    DECLARE SUB Draw(x AS integer, y AS integer, BMP AS HWND)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, border AS integer)
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB Rotate(xOrigin AS integer, yOrigin AS integer, Angle AS integer)
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
''    DECLARE SUB StretchDraw(rct AS RECT PTR, BMP AS HWND)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextRect(rct AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
' Events
    OnClick AS SUB(Sender AS QCANVAS PTR)
    OnDblClick AS SUB(Sender AS QCANVAS PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QCANVAS PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QCANVAS PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QCANVAS PTR)
    OnPaint AS SUB(Sender AS QCANVAS PTR)
END TYPE
GeneralProperties(QCANVAS)
PositionalProperties(QCANVAS)
HintProperties(QCANVAS)
ReadOnlyProperties(QCANVAS)

SUB QCANVAS.CopyRect(D AS RECT PTR, Image AS HWND, S AS RECT PTR)
MakeCopyRect(Handle, D, Image, S)
END SUB
SUB QCANVAS.Pset(x AS integer, y AS integer, c AS integer)
MakeLine(Handle, x, y, x+1, y+1, c)
END SUB
SUB QCANVAS.Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeLine(Handle, x1, y1, x2, y2, c)
END SUB
SUB QCANVAS.FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeFillRect(Handle, x1, y1, x2, y2, c)
END SUB
SUB QCANVAS.Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeRectangle(Handle, x1, y1, x2, y2, c)
END SUB
SUB QCANVAS.Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
MakeCircle(Handle, x1, y1, x2, y2, c, fill)
END SUB
SUB QCANVAS.RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
MakeRoundRect(Handle, x1, y1, x2, y2, x3, y3, c)
END SUB
SUB QCANVAS.TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
MakeTextOut(Handle, x, y, S, fc, bc)
END SUB
FUNCTION QCANVAS.TextHeight(Text AS string) AS integer
RETURN GetTextSize(Handle, Text, False)
END FUNCTION
FUNCTION QCANVAS.TextWidth(Text AS string) AS integer
RETURN GetTextSize(Handle, Text, True)
END FUNCTION

SUB QCANVAS.PreSetConfig()
END SUB
SUB QCANVAS.PostConfig()
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #27 ====================================================================================
TYPE QIMAGE
' Private (not)
    ObjId AS integer        = Q_IMAGE               ' Component ID
    ObjIndex AS integer     = 0                     ' Unique number per object
    ObjClass AS string*16   = "STATIC"              ' Base class
    ObjStyle AS UINT        = WS_CLIPCHILDREN OR SS_NOTIFY OR SS_BITMAP
    PrivateProperties()                             ' Common property variables
    xHeight AS integer      = 100
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 100
    xAutosize AS integer    = False
    xBMP AS string          = ""
    xBMPHandle AS integer   = 0
    hBMP AS HWND            = 0
' Extras
    DECLARE DESTRUCTOR
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Autosize() AS integer
    DECLARE PROPERTY Autosize(value AS integer)
    DECLARE PROPERTY BMP() AS string
    DECLARE PROPERTY BMP(FileName AS string)
    DECLARE PROPERTY BMPHandle() AS integer
    DECLARE PROPERTY BMPHandle(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Transparent() AS integer
    DECLARE PROPERTY Transparent(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alNone|alNone|alTop|alBottom|alLeft|alRight|alClient
''    Center AS integer               ' |INTEGER|RW|False|False|True
    CopyMode AS integer             ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCopy|cmMe...
    Cursor AS integer               ' |INTEGER|RW|crDefault|crDefault|crNone|crArrow|crCross|crIBeam|crSiz...
    Font AS HWND                    ' |QFONT|R|<default>
    ICOHandle AS HWND               ' |RESOURCE|W|
    Icon AS string                  ' |STRING|W|
    IncrementalDisplay AS integer   ' |INTEGER|RW|False|False|True
    PopupMenu AS HMENU              ' |QPOPUPMENU|W|
    Stretch AS integer              ' |INTEGER|RW|False|False|True
''    Pixel                           ' |ARRAY of INTEGER|RW|
' Methods
''    DECLARE SUB Center()
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect(D AS RECT PTR, Image AS HWND, S AS RECT PTR)
''    DECLARE SUB Draw(x AS integer, y AS integer, BMP AS HWND)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
''    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, border AS integer)
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
''    DECLARE SUB Repaint()
''    DECLARE SUB Rotate(xOrigin AS integer, yOrigin AS integer, Angle AS integer)
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB StretchDraw(rct AS RECT PTR, BMP AS HWND)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
''    DECLARE SUB TextRect(rct AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
' Events
    OnClick AS SUB(Sender AS QIMAGE PTR)
    OnDblClick AS SUB(Sender AS QIMAGE PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QIMAGE PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QIMAGE PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QIMAGE PTR)
END TYPE
GeneralProperties(QIMAGE)
PositionalProperties(QIMAGE)
HintProperties(QIMAGE)
ReadOnlyProperties(QIMAGE)

PROPERTY QIMAGE.Autosize() AS integer: RETURN xAutosize: END PROPERTY
PROPERTY QIMAGE.Autosize(value AS integer): xAutosize=value: END PROPERTY
PROPERTY QIMAGE.Transparent() AS integer: RETURN xTransparent: END PROPERTY
PROPERTY QIMAGE.Transparent(value AS integer): xTransparent=value: END PROPERTY
PROPERTY QIMAGE.BMP() AS string: RETURN xBMP: END PROPERTY
PROPERTY QIMAGE.BMP(FileName AS string)
DIM AS integer W=Width,H=Height
IF AutoSize THEN W=0: H=0: END IF
IF hBMP>0 THEN DeleteObject(hBMP)
hBMP=LoadImage(NULL,FileName,IMAGE_BITMAP, W, H, LR_LOADFROMFILE OR LR_DEFAULTSIZE)
SendMessage(Handle, STM_SETIMAGE, IMAGE_BITMAP, CAST(LPARAM,hBMP))
IF AutoSize THEN
DIM AS RECT rct: GetWindowRect(Handle,@rct): Width=rct.Right-rct.Left: Height=rct.Bottom-rct.Top
END IF
END PROPERTY
PROPERTY QIMAGE.BMPHandle() AS integer: RETURN 0: END PROPERTY
PROPERTY QIMAGE.BMPHandle(Resource AS integer)
DIM AS integer W=Width,H=Height
DIM AS string resString="#" & Resource
IF AutoSize THEN W=0: H=0: END IF
IF hBMP>0 THEN DeleteObject(hBMP)
hBMP=LoadImage(Application.hInstance,resString,IMAGE_BITMAP, W, H, LR_DEFAULTCOLOR)
SendMessage(Handle, STM_SETIMAGE, IMAGE_BITMAP, CAST(LPARAM,hBMP))
IF AutoSize THEN
DIM AS RECT rct: GetWindowRect(Handle,@rct): Width=rct.Right-rct.Left: Height=rct.Bottom-rct.Top
END IF
END PROPERTY

SUB QIMAGE.PreSetConfig()
END SUB
SUB QIMAGE.PostConfig()
SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB

SUB QIMAGE.CopyRect(D AS RECT PTR, Image AS HWND, S AS RECT PTR)
MakeCopyRect(Handle, D, Image, S)
END SUB
SUB QIMAGE.Pset(x AS integer, y AS integer, c AS integer)
MakeLine(Handle, x, y, x+1, y+1, c)
END SUB
SUB QIMAGE.Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeLine(Handle, x1, y1, x2, y2, c)
END SUB
SUB QIMAGE.Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeRectangle(Handle, x1, y1, x2, y2, c)
END SUB
SUB QIMAGE.FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeFillRect(Handle, x1, y1, x2, y2, c)
END SUB
SUB QIMAGE.Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
MakeCircle(Handle, x1, y1, x2, y2, c, fill)
END SUB
SUB QIMAGE.RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
MakeRoundRect(Handle, x1, y1, x2, y2, x3, y3, c)
END SUB
SUB QIMAGE.TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
MakeTextOut(Handle, x, y, S, fc, bc)
END SUB
FUNCTION QIMAGE.TextHeight(Text AS string) AS integer
RETURN GetTextSize(Handle, Text, False)
END FUNCTION
FUNCTION QIMAGE.TextWidth(Text AS string) AS integer
RETURN GetTextSize(Handle, Text, True)
END FUNCTION

DESTRUCTOR QIMAGE
IF hBMP>0 THEN DeleteObject(hBMP)
END DESTRUCTOR


'  =======================================================================================
'# 28 QOLECONTAINER * Properties *
'# 29 QSPLITTER * Properties *

'# 30 ====================================================================================
TYPE QBITMAP
' Private (not)
    ObjId AS integer        = Q_BITMAP              ' Component ID
    ObjIndex AS integer     = 0                     ' Unique number per object
    ObjClass AS string*16   = ""                    ' Non-visible class
    ObjStyle AS UINT        = 0                     '

    xBitMap AS BITMAP
    xBMP AS string          = ""
    xBMPHandle AS integer   = 0                     ' Resource ident number
    xEmpty AS integer       = True
    xHandle AS HWND         = 0
    xHeight AS integer      = 100
    xMonochrome AS integer  = False
    xWidth AS integer       = 100
' Extras
    DECLARE DESTRUCTOR

' Properties
    DECLARE PROPERTY BMP() AS string
    DECLARE PROPERTY BMP(FileName AS string)
    DECLARE PROPERTY BMPHandle() AS integer
    DECLARE PROPERTY BMPHandle(value AS integer)
    DECLARE PROPERTY Empty() AS integer
    DECLARE PROPERTY Empty(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Monochrome() AS integer
    DECLARE PROPERTY Monochrome(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    CopyMode AS integer                     ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCop....
    Font AS HWND                            ' |QFONT|R|<default>
''    Pixel                                   ' |2D ARRAY of INTEGER|RW|
    PixelFormat AS integer                  ' |INTEGER|RW|pfDevice|pfDevice|pf1bit|pf4bit|pf8bit|pf15bit|pf16bit|pf24bit|pf32bit
    Transparent AS integer                  ' |INTEGER|RW|False|False|True
    TransparentColor AS integer             ' |INTEGER|RW|<default>|<default>|<choose>
    TransparentMode AS integer              ' |INTEGER|RW|0
' Methods
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect(D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    DECLARE SUB Draw(x AS integer, y AS integer, BMP AS HWND)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
''    DECLARE SUB LoadFromFile(FileName AS string)
''    DECLARE SUB LoadFromStream(Stream)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, borderc AS integer)
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Rotate(xOrigin AS integer, yOrigin AS integer, Angle AS integer)
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB SaveToFile(FileName AS string)
''    DECLARE SUB SaveToStream(Stream)
    DECLARE SUB StretchDraw(rct AS RECT PTR, BMP AS HWND)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextRect(rct AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
' Events
END TYPE

PROPERTY QBITMAP.BMP() AS string: RETURN xBMP: END PROPERTY
PROPERTY QBITMAP.BMP(FileName AS string)
DIM AS UINT BmpFlags=LR_LOADFROMFILE
    IF Monochrome THEN BmpFlags += LR_MONOCHROME
    xHandle=LoadImage(NULL,FileName,IMAGE_BITMAP, 0, 0, BmpFlags OR LR_DEFAULTSIZE)
    GetObject(xHandle, SIZEOF(xBitMap), @xBitMap)
    Width=xBitMap.bmwidth
    Height=xBitMap.bmHeight
    xEmpty=False
END PROPERTY
PROPERTY QBITMAP.BMPHandle() AS integer: RETURN 0: END PROPERTY
PROPERTY QBITMAP.BMPHandle(ResNum AS integer)
DIM AS string resString="#" & ResNum
DIM AS UINT BmpFlags=0
    IF Monochrome THEN BmpFlags += LR_MONOCHROME
    xHandle=LoadImage(Application.hInstance,resString,IMAGE_BITMAP, 0, 0, BmpFlags OR LR_DEFAULTSIZE)
    GetObject(xHandle, SIZEOF(xBitMap), @xBitMap)
    Width=xBitMap.bmwidth
    Height=xBitMap.bmHeight
    xEmpty=False
END PROPERTY
PROPERTY QBITMAP.Empty() AS integer: RETURN xEmpty: END PROPERTY
PROPERTY QBITMAP.Empty(value AS integer): END PROPERTY                  ' Read only
PROPERTY QBITMAP.Handle() AS HWND: RETURN xHandle: END PROPERTY
PROPERTY QBITMAP.Handle(value AS HWND): END PROPERTY                    ' Read only
PROPERTY QBITMAP.Height() AS integer: RETURN xHeight: END PROPERTY
PROPERTY QBITMAP.Height(value AS integer): xHeight=value: END PROPERTY
PROPERTY QBITMAP.Monochrome() AS integer: RETURN xMonochrome: END PROPERTY
PROPERTY QBITMAP.Monochrome(value AS integer): xMonochrome=value: END PROPERTY
PROPERTY QBITMAP.Width() AS integer: RETURN xWidth: END PROPERTY
PROPERTY QBITMAP.Width(value AS integer): xWidth=value: END PROPERTY

SUB QBITMAP.Pset(x AS integer, y AS integer, c AS integer)
MakeLine(Handle, x, y, x+1, y+1, c)
END SUB
SUB QBITMAP.Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeLine(Handle, x1, y1, x2, y2, c)
END SUB
SUB QBITMAP.FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeFillRect(Handle, x1, y1, x2, y2, c)
END SUB
SUB QBITMAP.Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
MakeRectangle(Handle, x1, y1, x2, y2, c)
END SUB
SUB QBITMAP.Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
MakeCircle(Handle, x1, y1, x2, y2, c, fill)
END SUB
SUB QBITMAP.RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
MakeRoundRect(Handle, x1, y1, x2, y2, x3, y3, c)
END SUB
SUB QBITMAP.TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
MakeTextOut(Handle, x, y, S, fc, bc)
END SUB
FUNCTION QBITMAP.TextHeight(Text AS string) AS integer
RETURN GetTextSize(Handle, Text, False)
END FUNCTION
FUNCTION QBITMAP.TextWidth(Text AS string) AS integer
RETURN GetTextSize(Handle, Text, True)
END FUNCTION

DESTRUCTOR QBITMAP
IF Handle>0 THEN DeleteObject(Handle)
END DESTRUCTOR


'# 31 ====================================================================================
''NB Methods AddBMPFile & AddBMPHandle have an additional paramater
TYPE QIMAGELIST
' Private (not)
    ObjId AS integer        = Q_IMAGELIST           ' Component ID
    ObjIndex AS integer     = 0                     ' Unique number per object
    ObjClass AS string*16   = ""                    ' Base class
    ObjStyle AS UINT        = 0                     '

    xBkColor AS COLORREF    = COLOR_BTNFACE
    xCount AS integer       = 0
    xHandle AS HIMAGELIST
    xHeight AS integer      = 100
    xWidth AS integer       = 100
    xMasked AS integer      = True
' Extras
    DECLARE CONSTRUCTOR

' Properties
    DECLARE PROPERTY BkColor() AS COLORREF
    DECLARE PROPERTY BkColor(value AS COLORREF)
    DECLARE PROPERTY Count() AS integer
    DECLARE PROPERTY Count(value AS integer)
    DECLARE PROPERTY Handle() AS HIMAGELIST
    DECLARE PROPERTY Handle(value AS HIMAGELIST)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Masked() AS integer
    DECLARE PROPERTY Masked(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    BlendColor AS UINT              ' |INTEGER|RW|<default>|<default>|<choose>
    DrawingStyle AS integer         ' |INTEGER|RW|dsNormal|dsFocused|dsSelected|dsNormal|dsTransparent
    GetBMP AS integer               ' |ARRAY of IMAGES/BMP|R|
    GetICO AS integer               ' |ARRAY of IMAGES/ICO|R|
    ImageType AS integer = itImage  ' |INTEGER|RW|itImage|itImage|itMask

' Methods
    DECLARE SUB AddBMPFile(FileName AS string, ImgCount AS integer, MaskColor AS UINT)
    DECLARE SUB AddBMPHandle(BMP_Resource AS integer, ImgCount AS integer, MaskColor AS UINT)
    DECLARE SUB AddICOFile(FileName AS string)
    DECLARE SUB AddICOHandle(ICO_Resource AS integer)
    DECLARE SUB Clear()
    DECLARE SUB Delete(Index AS integer)
''    DECLARE SUB Draw(Parnt AS HIMAGELIST, X AS integer, Y AS integer, Index AS integer)
''    DECLARE SUB InsertBMPFile(Index AS integer, Filename AS string, Mask AS integer)
''    DECLARE SUB InsertICOFile(Index AS integer, Filename AS string)
''    DECLARE SUB InsertBMPHandle(Index AS integer, BMP_Resource AS integer, Mask AS integer)
''    DECLARE SUB InsertICOHandle
' Events
END TYPE


PROPERTY QIMAGELIST.BkColor() AS COLORREF: RETURN xBkColor: END PROPERTY
PROPERTY QIMAGELIST.BkColor(value AS COLORREF): xBkColor=value: ImageList_SetBkColor(Handle, value): END PROPERTY
PROPERTY QIMAGELIST.Count() AS integer: xCount=ImageList_GetImageCount(Handle): RETURN xCount: END PROPERTY
PROPERTY QIMAGELIST.Count(value AS integer): xCount=value: ImageList_SetImageCount(Handle, value): END PROPERTY
PROPERTY QIMAGELIST.Handle() AS HIMAGELIST: RETURN xHandle: END PROPERTY
PROPERTY QIMAGELIST.Handle(value AS HIMAGELIST): END PROPERTY
PROPERTY QIMAGELIST.Height() AS integer: RETURN xHeight: END PROPERTY
PROPERTY QIMAGELIST.Height(value AS integer): xHeight=value: ImageList_SetIconSize(Handle, Width, value): END PROPERTY
PROPERTY QIMAGELIST.Masked() AS integer: RETURN xMasked: END PROPERTY
PROPERTY QIMAGELIST.Masked(value AS integer): IF value=0 THEN xMasked=0 ELSE xMasked=True: END IF: END PROPERTY
PROPERTY QIMAGELIST.Width() AS integer: RETURN xWidth: END PROPERTY
PROPERTY QIMAGELIST.Width(value AS integer): xWidth=value: ImageList_SetIconSize(Handle, value, Height): END PROPERTY

CONSTRUCTOR QIMAGELIST
    xHandle=ImageList_Create(Width, Height, ILC_MASK OR ILC_COLOR32, Count, 0)
END CONSTRUCTOR

SUB QIMAGELIST.Clear()
    ImageList_Remove(Handle, -1)                    ' Index = -1 remove all images
END SUB

SUB QIMAGELIST.Delete(Index AS integer)
    IF (Index>=0) AND (Index<Count) THEN: ImageList_Remove(Handle, Index): END IF
END SUB

SUB QIMAGELIST.AddBMPFile(FileName AS string, ImgCount AS integer, MaskColor AS UINT)
DIM AS HBITMAP hBmp
    hBmp=LoadImage(NULL, FileName, IMAGE_BITMAP, ImgCount*Width, Height, LR_LOADFROMFILE)    ' From file: Set entire image width
    IF Masked THEN
        ImageList_AddMasked(Handle, hBmp, CAST(COLORREF,MaskColor))                 ' Load bitmap with mask color
    ELSE
        ImageList_Add(Handle, hBmp, NULL)                                           ' No mask - no transparency
    END IF
    DeleteObject(hBmp)                                                              ' Clean up
END SUB

SUB QIMAGELIST.AddBMPHandle(BMP_Resource AS integer, ImgCount AS integer, MaskColor AS UINT)
DIM AS HBITMAP hBmp
DIM AS string idStr="#" & BMP_Resource
DIM AS integer tCount=Count
    hBmp=LoadImage(Application.hInstance, idStr, IMAGE_BITMAP, _
                                                ImgCount*Width, Height, 0)          ' From resource: Set entire image width
    IF Masked THEN
        ImageList_AddMasked(Handle, hBmp, CAST(COLORREF,MaskColor))                 ' Load bitmap with mask color
    ELSE
        ImageList_Add(Handle, hBmp, NULL)                                           ' No mask - no transparency
    END IF
    DeleteObject(hBmp)                                                              ' Clean up
    Count = tCount+ImgCount
END SUB

SUB QIMAGELIST.AddICOFile(FileName AS string)
DIM AS HICON hIco
    hIco=LoadImage(NULL, FileName, IMAGE_ICON, Width, Height, LR_LOADFROMFILE)
    ImageList_ReplaceIcon(Handle, -1, hIco)
    DeleteObject(hIco)
END SUB

SUB QIMAGELIST.AddICOHandle(ICO_Resource AS integer)
DIM AS HICON hIco
DIM AS string idStr="#" & ICO_Resource
    hIco=LoadImage(Application.hInstance, idStr, IMAGE_ICON, Width, Height, 0)
    ImageList_ReplaceIcon(Handle, -1, hIco)                                         ' Add each ico to list
    DeleteObject(hIco)                                                              ' Clean up
END SUB



' #32 ====================================================================================
TYPE QSTRINGLIST
' Private (not)
    ObjId AS integer        = Q_STRINGLIST              ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*16   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

' Extras
    xStringList AS string   = ""
    xDuplicates AS integer  = dupIgnore
    xItem AS string         = ""
    xItemCount AS integer   = 0
    xSorted AS integer      = False
' Properties
    DECLARE PROPERTY Duplicates() AS integer
    DECLARE PROPERTY Duplicates(value AS integer)
    DECLARE PROPERTY Item(value AS integer) AS string
    DECLARE PROPERTY Item(value AS integer, nStr AS string)
    DECLARE PROPERTY ItemCount() AS integer
    DECLARE PROPERTY ItemCount(value AS integer)
    DECLARE PROPERTY Sorted() AS integer
    DECLARE PROPERTY Sorted(value AS integer)

    Text AS string                              ' |STRING|RW|
' Methods
    DECLARE SUB AddItems(NewString AS string)               ' FUDGE: Only one string at a time
    DECLARE SUB AddList(List AS QSTRINGLIST)
    DECLARE FUNCTION Build(Start AS integer, End AS integer, Delim AS string) AS string
    DECLARE SUB Clear()
    DECLARE SUB DelItems(Index AS integer)
    DECLARE SUB Exchange(Index1 AS integer, Index2 AS integer)
    DECLARE FUNCTION IndexOf(FindString AS string) AS integer
    DECLARE SUB InsertItem(Index AS integer, NewString AS string)
    DECLARE SUB LoadFromFile(FileName AS string)
''    DECLARE SUB LoadFromStream(Stream AS QMEMORYSTREAM)
    DECLARE FUNCTION Parse(Source AS string, Delim AS string) AS long
    DECLARE SUB SaveToFile(FileName AS string)
''    DECLARE SUB SaveToStream(Stream AS QMEMORYSTREAM)
    DECLARE SUB Sort()
' Events

END TYPE

PROPERTY QSTRINGLIST.Duplicates() AS integer: RETURN xDuplicates: END PROPERTY
PROPERTY QSTRINGLIST.Duplicates(value AS integer): xDuplicates=value: END PROPERTY
PROPERTY QSTRINGLIST.ItemCount() AS integer
IF xStringList="" THEN
    RETURN 0
ELSE
    xItemCount=rqTALLY(xStringList,CHR(10))+1
    RETURN xItemCount
END IF
END PROPERTY
PROPERTY QSTRINGLIST.ItemCount(value AS integer): END PROPERTY              ' Read Only
PROPERTY QSTRINGLIST.Item(value AS integer) AS string
RETURN rqFIELDSTR(xStringList,CHR(10),value+1)                              ' 0 based!!
END PROPERTY
PROPERTY QSTRINGLIST.Item(value AS integer, nStr AS string): END PROPERTY   ' Read Only
PROPERTY QSTRINGLIST.Sorted() AS integer: RETURN xSorted: END PROPERTY
PROPERTY QSTRINGLIST.Sorted(value AS integer): IF value=0 THEN xSorted=False ELSE xSorted=True: END IF: END PROPERTY

' Check Duplicates & Sorted when adding strings
SUB QSTRINGLIST.AddItems(NewString AS string)                               ' One string at a time
DIM AS string tok, tstr
DIM AS integer i, j
    tok=rqFIELDSTR(NewString,CHR(10),1)                                    ' Truncate IF '\n' in string
    IF tok<>"" THEN
        IF ItemCount=0 THEN
            xStringList=tok
        ELSE
            tstr=CHR(10) & tok & CHR(10)                                    ' Use to look for duplicate
            IF NOT((Duplicates=dupIgnore) AND (INSTR(xStringList,tstr)>0)) THEN     ' Duplicates allowed?
                IF Sorted THEN
                    FOR i=1 TO ItemCount
                        tstr=rqFIELDSTR(xStringList,CHR(10),i)
                        IF tok < tstr THEN EXIT FOR
                    NEXT
                    IF i=1 THEN
                        xStringList=tok & CHR(10) & xStringList
                    ELSE
                        i -= 1: tstr=""
                        FOR j=1 TO i
                            tstr=tstr & rqFIELDSTR(xStringList,CHR(10),j) & CHR(10)
                        NEXT j
                        tstr=tstr & tok & CHR(10)
                        FOR j=j TO ItemCount
                            tstr=tstr & rqFIELDSTR(xStringList,CHR(10),j) & CHR(10)
                        NEXT j
                        xStringList=LEFT(tstr, LEN(tstr)-1)                     ' Remove trailing '\n'
                    END IF
                ELSE
                    xStringList=xStringList & CHR(10) & tok
                END IF
            END IF
        END IF
    END IF
END SUB
SUB QSTRINGLIST.AddList(List AS QSTRINGLIST)
    IF List.ItemCount>0 THEN
        DIM AS string tok
        FOR i AS integer = 0 TO List.ItemCount-1
            tok=List.Item(i): THIS.AddItems(tok)
        NEXT i
    END IF
END SUB
SUB QSTRINGLIST.Clear()
    ItemCount=0
    xStringList=""
END SUB
SUB QSTRINGLIST.DelItems(Index AS integer)
    IF Index < ItemCount THEN
        DIM AS string tstr=""
        FOR i AS integer = 0 TO ItemCount-1
            IF i <> Index THEN tstr=tstr & rqFIELDSTR(xStringList,CHR(10),i+1) & CHR(10)
        NEXT
        xStringList=LEFT(tstr,LEN(tstr)-1)
    END IF
END SUB
FUNCTION QSTRINGLIST.IndexOf(FindString AS string) AS integer
    FOR i AS integer = 0 TO ItemCount-1
        IF FindString=rqFIELDSTR(xStringList,CHR(10),i+1) THEN
            RETURN i
            EXIT FUNCTION
        END IF
    NEXT i
    RETURN -1
END FUNCTION
SUB QSTRINGLIST.LoadFromFile(FileName AS string)
    IF FileExists(FileName) THEN
        DIM AS integer ff=FreeFile
        DIM AS string tstr
        OPEN FileName FOR INPUT AS #ff
        DO UNTIL EOF(ff)
            LINE INPUT #ff, tstr
            THIS.AddItems(tstr)
        LOOP
        CLOSE #ff
    END IF
END SUB
SUB QSTRINGLIST.SaveToFile(FileName AS string)
DIM AS integer ff=FreeFile
    OPEN FileName FOR OUTPUT AS #ff
    FOR i AS integer = 1 TO ItemCount
        PRINT #ff, rqFIELDSTR(xStringList,CHR(10),i)
    NEXT
    CLOSE #ff
END SUB
SUB QSTRINGLIST.Sort()
    IF ItemCount>1 THEN
        DIM AS string tok
        DIM AS QSTRINGLIST List
        List.Sorted=True
        FOR i AS integer = 1 TO ItemCount
            tok=rqFIELDSTR(xStringList,CHR(10),i)
            List.AddItems(tok)
        NEXT i
        THIS.Clear
        THIS.AddList(List)
        List.Clear
    END IF
END SUB


' #33 ====================================================================================
TYPE QTIMER
' Private (not)
    ObjId AS integer        = Q_TIMER                   ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*16   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '
    PrivateProperties()                                 ' Common property variables
    xInterval AS integer

' Properties
    DECLARE PROPERTY Interval() AS integer
    DECLARE PROPERTY Interval(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    Enabled AS integer = 0
' Methods
' Events
    OnTimer AS SUB(Sender AS QTIMER PTR)
END TYPE

PROPERTY QTIMER.Interval() AS integer: RETURN xInterval: END PROPERTY
PROPERTY QTIMER.Interval(value AS integer): xInterval=value: END PROPERTY
PROPERTY QTIMER.Parent() AS HWND: RETURN xParent: END PROPERTY
PROPERTY QTIMER.Parent(value AS HWND): xParent=value: END PROPERTY
PROPERTY QTIMER.Tag() AS integer: RETURN xTag: END PROPERTY
PROPERTY QTIMER.Tag(value AS integer): xTag=value: END PROPERTY


' #41 ====================================================================================
TYPE QOPENDIALOG
' Private (not)
    ObjId AS integer        = Q_OPENDIALOG              ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*16   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    xCaption AS string*64 = "Open File"
    xFileName AS string*64 = ""
    xFilter AS string*128 = "All files (*.*)|*.*"
    xFilterIndex AS integer = 1
    xInitialDir AS string*128 = Application.Path
    xNuFilter(1 TO 128) AS byte                      ' Converted into the correct format

' Properties
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY FileName() AS string
    DECLARE PROPERTY FileName(value AS string)
    DECLARE PROPERTY Filter() AS string
    DECLARE PROPERTY Filter(value AS string)
    DECLARE PROPERTY FilterIndex() AS integer
    DECLARE PROPERTY FilterIndex(value AS integer)
    DECLARE PROPERTY InitialDir() AS string
    DECLARE PROPERTY InitialDir(value AS string)
' Methods
    DECLARE FUNCTION Execute() AS integer
' Events
END TYPE

PROPERTY QOPENDIALOG.Caption() AS string: RETURN xCaption: END PROPERTY
PROPERTY QOPENDIALOG.Caption(value AS string): xCaption=value: END PROPERTY
PROPERTY QOPENDIALOG.FileName() AS string: RETURN xFileName: END PROPERTY
PROPERTY QOPENDIALOG.FileName(value AS string): xFileName=value: END PROPERTY
PROPERTY QOPENDIALOG.Filter() AS string: RETURN xFilter: END PROPERTY
PROPERTY QOPENDIALOG.Filter(value AS string): xFilter=value: END PROPERTY
PROPERTY QOPENDIALOG.FilterIndex() AS integer: RETURN xFilterIndex: END PROPERTY
PROPERTY QOPENDIALOG.FilterIndex(value AS integer): xFilterIndex=value: END PROPERTY
PROPERTY QOPENDIALOG.InitialDir() AS string: RETURN xInitialDir: END PROPERTY
PROPERTY QOPENDIALOG.InitialDir(value AS string): xInitialDir=value: END PROPERTY

FUNCTION QOPENDIALOG.Execute() AS integer
DIM AS OPENFILENAME ofn
DIM AS integer i, cnt
DIM AS byte ch

    cnt=LEN(xFilter)                                        ' Get filter into correct format
    FOR i=1 TO cnt
        ch=ASC(xFilter, i)
        IF ch=0 THEN EXIT FOR                               ' End of text?
        IF ch=&h7c THEN ch=0                                ' "|" character -> NUL
        xNuFilter(i)=ch
    NEXT i
    xNuFilter(i)=0: i += 1: xNuFilter(i)=0                  ' Ensure two NUL chars to end

    CLEAR(@ofn, 0, SIZEOF(OPENFILENAME))
WITH ofn
    .lStructSize=SIZEOF(OPENFILENAME)
    .hwndOwner=Application.hMainForm
    .hInstance=Application.hInstance
    .lpstrFilter=CAST(ANY PTR, @xNuFilter(1))
    .nFilterIndex=xFilterIndex
    .lpstrFile=CAST(ANY PTR, @xFileName)
    .nMaxFile=SIZEOF(xFileName)
    .lpstrInitialDir=CAST(ANY PTR, @xInitialDir)
    .lpstrTitle=CAST(ANY PTR, @xCaption)
    .Flags=OFN_EXPLORER OR OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST
END WITH
    RETURN GetOpenFileName(@ofn)
END FUNCTION


' #42 ====================================================================================
TYPE QSAVEDIALOG
' Private (not)
    ObjId AS integer        = Q_SAVEDIALOG              ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*16   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    xCaption AS string*64 = "Open File"
    xFileName AS string*64 = ""
    xFilterIndex AS integer = 1
    xInitialDir AS string*128 = Application.Path
    xFilter AS string*128 = "All files (*.*)|*.*"
    xNuFilter(1 TO 128) AS byte                      ' Converted into the correct format

' Properties
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY FileName() AS string
    DECLARE PROPERTY FileName(value AS string)
    DECLARE PROPERTY Filter() AS string
    DECLARE PROPERTY Filter(value AS string)
    DECLARE PROPERTY FilterIndex() AS integer
    DECLARE PROPERTY FilterIndex(value AS integer)
    DECLARE PROPERTY InitialDir() AS string
    DECLARE PROPERTY InitialDir(value AS string)
' Methods
    DECLARE FUNCTION Execute() AS integer
' Events
END TYPE

PROPERTY QSAVEDIALOG.Caption() AS string: RETURN xCaption: END PROPERTY
PROPERTY QSAVEDIALOG.Caption(value AS string): xCaption=value: END PROPERTY
PROPERTY QSAVEDIALOG.FileName() AS string: RETURN xFileName: END PROPERTY
PROPERTY QSAVEDIALOG.FileName(value AS string): xFileName=value: END PROPERTY
PROPERTY QSAVEDIALOG.Filter() AS string: RETURN xFilter: END PROPERTY
PROPERTY QSAVEDIALOG.Filter(value AS string): xFilter=value: END PROPERTY
PROPERTY QSAVEDIALOG.FilterIndex() AS integer: RETURN xFilterIndex: END PROPERTY
PROPERTY QSAVEDIALOG.FilterIndex(value AS integer): xFilterIndex=value: END PROPERTY
PROPERTY QSAVEDIALOG.InitialDir() AS string: RETURN xInitialDir: END PROPERTY
PROPERTY QSAVEDIALOG.InitialDir(value AS string): xInitialDir=value: END PROPERTY

FUNCTION QSAVEDIALOG.Execute() AS integer
DIM AS OPENFILENAME ofn
DIM AS integer i, cnt
DIM AS byte ch

    cnt=LEN(xFilter)                                        ' Get filter into correct format
    FOR i=1 TO cnt
        ch=ASC(xFilter, i)
        IF ch=0 THEN EXIT FOR                               ' End of text?
        IF ch=&h7c THEN ch=0                                ' "|" character -> NUL
        xNuFilter(i)=ch
    NEXT i
    xNuFilter(i)=0: i += 1: xNuFilter(i)=0                  ' Ensure two NUL chars to end

    CLEAR(@ofn, 0, SIZEOF(OPENFILENAME))
WITH ofn
    .lStructSize=SIZEOF(OPENFILENAME)
    .hwndOwner=Application.hMainForm
    .hInstance=Application.hInstance
    .lpstrFilter=CAST(ANY PTR, @xNuFilter(1))
    .nFilterIndex=xFilterIndex
    .lpstrFile=CAST(ANY PTR, @xFileName)
    .nMaxFile=SIZEOF(xFileName)
    .lpstrInitialDir=CAST(ANY PTR, @xInitialDir)
    .lpstrTitle=CAST(ANY PTR, @xCaption)
    .Flags=OFN_EXPLORER OR OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST
END WITH
    RETURN GetSaveFileName(@ofn)
END FUNCTION


' #43 ====================================================================================
TYPE QFONTDIALOG
' Private (not)
    hFont AS HFONT                          ' Created font handle
    fntLF AS LOGFONT                        ' logical font structure
' Extras
' Properties

    Color AS integer                        ' |INTEGER|RW|<default>|<default>|<choose>
    FontCount AS integer                    ' |INTEGER|R|
    FontName AS string                      ' |ARRAY of STRING|R|
    MaxFontSize AS integer                  ' |INTEGER|RW|
    MinFontSize AS integer                  ' |INTEGER|RW|
    Name AS string                          ' |STRING|RW|
    Size AS integer                         ' |INTEGER|RW|
' Methods
    DECLARE SUB AddStyles(value AS integer)                 ' SUBI Add styles [bold, italic, etc] INTEGER, Infinite
    DECLARE SUB DelStyles(value AS integer)                 ' SUBI Delete styles [bold, italic, etc] INTEGER, Infinite
''    AddOptions SUBI Add options [fdLimitSize, fdNoSizeSel, etc.] INTEGER, Infinite
''    DelOptions SUBI Delete options [fdNoStyleSel, fdScalableOnly, etc.] INTEGER, Infinite
    DECLARE FUNCTION Execute() AS UINT
''    GetFont SUB GetFont(F AS QFONT) Get font attributes 1
''    SetFont SUB SetFont(F AS QFONT) Set font attributes 1
' Events
''    OnApply VOID User clicks on apply button 0

    DECLARE CONSTRUCTOR
END TYPE

CONSTRUCTOR QFONTDIALOG
    ' Fill the logfont structure
    GetObject(Application.hFont, SIZEOF(LOGFONT), @fntLF)
END CONSTRUCTOR

SUB QFONTDIALOG.AddStyles(value AS integer)
    SELECT CASE value
        CASE fsBold:        fntLF.lfWeight = FW_BOLD
        CASE fsItalic:      fntLF.lfItalic = 1
        CASE fsUnderline:   fntLF.lfUnderline = 1
        CASE fsStrikeOut:   fntLF.lfStrikeOut = 1
    END SELECT
END SUB

SUB QFONTDIALOG.DelStyles(value AS integer)
    SELECT CASE value
        CASE fsBold:        fntLF.lfWeight = FW_NORMAL
        CASE fsItalic:      fntLF.lfItalic = 0
        CASE fsUnderline:   fntLF.lfUnderline = 0
        CASE fsStrikeOut:   fntLF.lfStrikeOut = 0
    END SELECT
END SUB

FUNCTION QFONTDIALOG.Execute() AS UINT
DIM AS CHOOSEFONTA cf

    ' Load the choosefont structure
    Clear(@cf, 0, SIZEOF(CHOOSEFONTA))
    cf.lStructSize=SIZEOF(CHOOSEFONTA)
    cf.hwndOwner=Application.hMainForm
    cf.lpLogFont=CAST(ANY PTR, @fntLF)
    cf.rgbColors=Color
    cf.Flags=CF_SCREENFONTS OR CF_EFFECTS OR CF_INITTOLOGFONTSTRUCT

    IF ChooseFont(@cf) THEN
        hfont=CreateFontIndirect(cf.lpLogFont)
        Name=RTRIM(fntLF.lfFaceName)
        Color=cf.rgbColors
        RETURN CAST(UINT,hFont)
    ELSE
        RETURN 0
    END IF
END FUNCTION


' #44 ====================================================================================
TYPE QCOLORDIALOG
' Private (not)
    ObjId AS integer        = Q_COLORDIALOG             ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*16   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    xStyle AS integer = cdNormal
    xColor AS UINT = &hffffff

' Extras
' Properties
    DECLARE PROPERTY Color() AS UINT
    DECLARE PROPERTY Color(value AS UINT)
    DECLARE PROPERTY Style() AS integer
    DECLARE PROPERTY Style(value AS integer)

    Left AS integer                             ' |INTEGER|RW|
    Top AS integer                              ' |INTEGER|RW|
    Caption AS string                           ' |STRING|RW|
    Colors AS UINT PTR                          ' |Array of LONG|R|
' Methods
    DECLARE FUNCTION Execute() AS integer
' Events
END TYPE

PROPERTY QCOLORDIALOG.Color() AS UINT: RETURN xColor: END PROPERTY
PROPERTY QCOLORDIALOG.Color(value AS UINT): xColor=value: END PROPERTY
PROPERTY QCOLORDIALOG.Style() AS integer: RETURN xStyle: END PROPERTY
PROPERTY QCOLORDIALOG.Style(value AS integer): xStyle=value: END PROPERTY

FUNCTION QCOLORDIALOG.Execute() AS integer
DIM AS CHOOSECOLOR cc                   ' common dialog box structure
DIM AS UINT Colors(0 TO 15)             ' Custom colors - make static & retain?

    FOR i AS integer=0 TO 15: Colors(i)=&hdfdfdf: NEXT          ' "no" color

' Initialize CHOOSECOLOR structure
    Clear(@cc, 0, SIZEOF(CHOOSECOLOR))
    cc.lStructSize=SIZEOF(CHOOSECOLOR)
    cc.hwndOwner=Application.hMainForm
    cc.Flags=CC_ANYCOLOR OR CC_RGBINIT OR CC_SHOWHELP
    SELECT CASE Style
        CASE cdNormal
        CASE cdFullOpen: cc.Flags=cc.Flags OR CC_FULLOPEN
        CASE cdNoFullOpen: cc.Flags=cc.Flags OR CC_PREVENTFULLOPEN
    END SELECT
    cc.rgbResult=CAST(COLORREF, Color)                              ' Default selected color
    cc.lpCustColors=CAST(COLORREF PTR, @Colors(0))                  ' Custom color set

    IF ChooseColor(@cc) THEN
        Color=CAST(UINT, cc.rgbResult)
        RETURN True
    ELSE
        RETURN False
    END IF
END FUNCTION


'  =======================================================================================
'# 34 QSOCKET * Properties *
'# 35 QFILESTREAM * Properties *
'# 36 QMEMORYSTREAM * Properties *
'# 37 QFONT * Properties *
'# 38 QMYSQL * Properties *
'# 39 QOLEOBJECT * NB NO Properties *
'# 40 QREGISTRY * NB NO Properties *
'# 45 QDXTimer * Properties *
'# 46 QDXSound * Properties *
'# 47 QDXScreen * Properties *
'# 48 QDXImageList * Properties *
'# 49 QD3DFace * Properties *
'# 50 QD3DMeshBuilder * Properties *
'# 51 QD3DFrame * Properties *
'# 52 QD3DLight * Properties *
'# 53 QD3DTexture * Properties *
'# 54 QD3DVector * Properties *
'# 55 QD3DWrap * Properties *


' #56 ====================================================================================
TYPE QPRINTDIALOG
' Private (not)
    ObjId AS integer        = Q_PRINTDIALOG             ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*16   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    AllowToFile AS integer = True
    AllowToNetwork AS integer = True
''    FromPage AS integer = 0
''    ToPage AS integer = 0
    PrinterName AS string*64

' Method
    DECLARE FUNCTION Execute() AS integer
' Events
END TYPE

FUNCTION QPRINTDIALOG.Execute() AS integer
DIM AS PRINTDLG pd

    CLEAR(@pd, 0, SIZEOF(PRINTDLG))
	pd.lStructSize=SIZEOF(PRINTDLG)
    pd.hwndOwner=Application.hMainForm
    pd.Flags=PD_SHOWHELP
    IF AllowToFile=False THEN pd.Flags=pd.Flags OR PD_HIDEPRINTTOFILE
    IF AllowToNetwork=False THEN pd.Flags=pd.Flags OR PD_NONETWORKBUTTON

	IF PrintDlg(@pd) THEN
        DIM AS DEVNAMES PTR dn=GlobalLock(pd.hDevNames)
        PrinterName=*CAST(ZSTRING PTR, CAST(BYTE PTR, dn) + dn->wDeviceOffset)
        GlobalUnlock(dn)
        RETURN True
    ELSE
        RETURN False
    END IF
END FUNCTION

' #57 ====================================================================================
TYPE QUPDOWN
' Private (not)
    ObjId AS integer        = Q_UPDOWN                          ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "msctls_updown32"                 ' Base class
    ObjStyle AS UINT        = 0                                 '
    PrivateProperties()                                         ' Common property variables
    xHeight AS integer      = 75
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 25
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Min() AS integer
    DECLARE PROPERTY Min(value AS integer)
    DECLARE PROPERTY Max() AS integer
    DECLARE PROPERTY Max(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer = alLeft       ' |INTEGER|RW|alLeft||alLeft|alRight
    ArrowKeys AS integer = False    ' |INTEGER|RW|False|False|True
    Buddy AS HWND = 0               '  ONLY Edit controls????
    Orientation AS integer = 0      ' |spVertical|spVertical|spHorizontal
    TabOrder AS integer             ' |INTEGER|RW|
    Wrap AS integer = False         ' |INTEGER|RW|False|False|True
' Methods
' Events
    OnChange AS SUB(Sender AS QUPDOWN PTR)
END TYPE

GeneralProperties(QUPDOWN)
PositionalProperties(QUPDOWN)
HintProperties(QUPDOWN)
ReadOnlyProperties(QUPDOWN)
PROPERTY QUPDOWN.Min() AS integer: RETURN xMin: END PROPERTY
PROPERTY QUPDOWN.Min(value AS integer)
    IF (value >= 0) AND (value < Max) THEN xMin=value: SendMessage(Handle, UDM_SETRANGE, 0, MAKELPARAM(Min, Max)): END IF
END PROPERTY
PROPERTY QUPDOWN.Max() AS integer: RETURN xMax: END PROPERTY
PROPERTY QUPDOWN.Max(value AS integer)
    IF value > Min THEN xMax=value: SendMessage(Handle, UDM_SETRANGE, 0, MAKELPARAM(Min, Max)): END IF
END PROPERTY
PROPERTY QUPDOWN.Position() AS integer: RETURN xPosition: END PROPERTY
PROPERTY QUPDOWN.Position(value AS integer): xPosition=value: END PROPERTY

SUB QUPDOWN.PreSetConfig()
    IF Buddy>0 THEN ObjStyle += UDS_SETBUDDYINT
    IF Align<>alLeft THEN ObjStyle += UDS_ALIGNRIGHT
    IF Orientation=spHorizontal THEN ObjStyle += UDS_HORZ
    IF ArrowKeys THEN ObjStyle += UDS_ARROWKEYS
    IF Wrap THEN ObjStyle += UDS_WRAP
END SUB
SUB QUPDOWN.PostConfig()
    IF Buddy>0 THEN SendMessage(Handle, UDM_SETBUDDY, CAST(WPARAM,Buddy), 0)
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #58 ====================================================================================
TYPE QPROGRESSBAR
' Private (not)
    ObjId AS integer        = Q_PROGRESSBAR                     ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "msctls_progress32"               ' Base class
    ObjStyle AS UINT        = 0                                 '
    PrivateProperties()                                         ' Common property variables

    xBackColor AS integer   =&hffffff
    xForeColor AS integer   = 0
    xHeight AS integer      = 25
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 250
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY BackColor() AS integer
    DECLARE PROPERTY BackColor(value AS integer)
    DECLARE PROPERTY ForeColor() AS integer
    DECLARE PROPERTY ForeColor(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Min() AS integer
    DECLARE PROPERTY Min(value AS integer)
    DECLARE PROPERTY Max() AS integer
    DECLARE PROPERTY Max(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

    Align AS integer                ' |INTEGER|RW|alLeft||alLeft|alRight|
    Orientation AS integer          ' |INTEGER|RW|pbHorizontal|pbHorizontal|pbVertical
    TabOrder AS integer             ' |INTEGER|RW|
' Methods
' Events
END TYPE

GeneralProperties(QPROGRESSBAR)
PositionalProperties(QPROGRESSBAR)
HintProperties(QPROGRESSBAR)
ReadOnlyProperties(QPROGRESSBAR)

PROPERTY QPROGRESSBAR.BackColor() AS integer: RETURN xBackColor: END PROPERTY
PROPERTY QPROGRESSBAR.BackColor(value AS integer): xBackColor=value: END PROPERTY
PROPERTY QPROGRESSBAR.ForeColor() AS integer: RETURN xForeColor: END PROPERTY
PROPERTY QPROGRESSBAR.ForeColor(value AS integer): xForeColor=value: END PROPERTY
PROPERTY QPROGRESSBAR.Min() AS integer: RETURN xMin: END PROPERTY
PROPERTY QPROGRESSBAR.Min(value AS integer)
    IF (value >= 0) AND (value < Max) THEN xMin=value: SendMessage(Handle, PBM_SETRANGE, 0, MAKELPARAM(Min, Max)): END IF
END PROPERTY
PROPERTY QPROGRESSBAR.Max() AS integer: RETURN xMax: END PROPERTY
PROPERTY QPROGRESSBAR.Max(value AS integer)
    IF value > Min THEN xMax=value: SendMessage(Handle, PBM_SETRANGE, 0, MAKELPARAM(Min, Max)): END IF
END PROPERTY
PROPERTY QPROGRESSBAR.Position() AS integer: RETURN xPosition: END PROPERTY
PROPERTY QPROGRESSBAR.Position(value AS integer)
    IF (value >= Min) AND (value <= Max) THEN xPosition=value: SendMessage(Handle, PBM_SETPOS, CAST(WPARAM, value), 0): END IF
END PROPERTY

SUB QPROGRESSBAR.PreSetConfig()
END SUB
SUB QPROGRESSBAR.PostConfig()
    SendMessage(Handle, PBM_SETRANGE, 0, MAKELPARAM(Min,Max))
    SendMessage(Handle, PBM_SETBKCOLOR, 0, BackColor)
    SendMessage(Handle, PBM_SETBARCOLOR, 0, ForeColor)
    SendMessage(Handle,WM_SETFONT,CAST(WPARAM,Application.hfont),1)
END SUB



' #59 ====================================================================================
TYPE QPAGESCROLLER
' Private (not)
    ObjId AS integer        = Q_PAGESCROLLER                    ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*16   = "SysPager"                        ' Base class
    ObjStyle AS UINT        = 0                                 '
    PrivateProperties()                                         ' Common property variables

    xBackColor AS integer   =&hffffff
    xHeight AS integer      = 25
    xLeft AS integer        = 0
    xTop AS integer         = 0
    xWidth AS integer       = 250
    xOrientation AS integer = pgVertical                        ' Default
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()

' Properties
    DECLARE PROPERTY BackColor() AS integer
    DECLARE PROPERTY BackColor(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Orientation() AS integer
    DECLARE PROPERTY Orientation(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)

' Methods
' Events
END TYPE

GeneralProperties(QPAGESCROLLER)
PositionalProperties(QPAGESCROLLER)
HintProperties(QPAGESCROLLER)
ReadOnlyProperties(QPAGESCROLLER)

PROPERTY QPAGESCROLLER.BackColor() AS integer: RETURN xBackColor: END PROPERTY
PROPERTY QPAGESCROLLER.BackColor(value AS integer): xBackColor=value: END PROPERTY
PROPERTY QPAGESCROLLER.Orientation() AS integer: RETURN xOrientation: END PROPERTY
PROPERTY QPAGESCROLLER.Orientation(value AS integer)
IF value=0 THEN xOrientation=pgHorizontal ELSE xOrientation=pgVertical
END PROPERTY

SUB QPAGESCROLLER.PreSetConfig()
    IF Orientation=pgHorizontal THEN
        ObjStyle += PGS_HORZ
    ELSE
        ObjStyle += PGS_VERT
    END IF
END SUB
SUB QPAGESCROLLER.PostConfig()
    SendMessage(Handle, PGM_SETBORDER, 0, 5)
    SendMessage(Handle, PGM_SETBUTTONSIZE, 0, 20)
END SUB


'-------------------------------------------------------------------------------------------------------------
' Common code
'-------------------------------------------------------------------------------------------------------------
'
' Graphics stuff - shared by several components
'
SUB MakeCopyRect(dstHandle AS HWND, dstRect AS RECT PTR, srcHandle AS HWND, srcRect AS RECT PTR)
DIM AS HDC dstDC, srcDC
    dstDC=GETDC(dstHandle): srcDC=GetDC(srcHandle)
    SetStretchBltMode(dstDC,HALFTONE)
    StretchBlt(dstDC, dstRect->Left, dstRect->Top, dstRect->Right, dstRect->Bottom, _
                        srcDC, srcRect->Left, srcRect->Top, srcRect->Right, srcRect->Bottom, SRCCOPY)
    ReleaseDC(dstHandle, dstDC)
    ReleaseDC(srcHandle, srcDC)
END SUB
SUB MakeLine(Handle AS HWND, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DIM AS HDC hDC=GetDC(Handle)
DIM AS HGDIOBJ Original=SelectObject(hDC, GetStockObject(DC_BRUSH))             ' Save copy of original

    SelectObject(hDC, GetStockObject(DC_PEN))
    SetDCPenColor(hDC, CAST(COLORREF, colr))
    MoveToEx(hDC, x1, y1, NULL)
    LineTo(hDC, x2, y2)
    SelectObject(hDC, Original)
    ReleaseDC(Handle, hDC)
END SUB
SUB MakeRectangle(Handle AS HWND, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DIM AS HDC hDC=GetDC(Handle)
DIM AS HGDIOBJ Original=SelectObject(hDC, GetStockObject(DC_BRUSH))             ' Save copy of original

    SelectObject(hDC, GetStockObject(DC_PEN))
    SetDCPenColor(hDC, CAST(COLORREF, colr))
    MoveToEx(hDC, x1, y1, NULL)
    LineTo(hDC, x2, y1): LineTo(hDC, x2, y2)
    LineTo(hDC, x1, y2): LineTo(hDC, x1, y1)
    SelectObject(hDC, Original)
    ReleaseDC(Handle, hDC)
END SUB
SUB MakeFillRect(Handle AS HWND, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DIM AS HDC hDC=GetDC(Handle)
DIM AS HGDIOBJ Original=SelectObject(hDC, GetStockObject(DC_BRUSH))             ' Save copy of original

    SetDCBrushColor(hDC, CAST(COLORREF, Colr))
    SelectObject(hDC, GetStockObject(DC_PEN))
    SetDCPenColor(hDC, CAST(COLORREF, colr))
    Rectangle(hDC, x1, y1, x2, y2)
    SelectObject(hDC, Original)
    ReleaseDC(Handle, hDC)
END SUB
SUB MakeRoundRect(Handle AS HWND, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, colr AS integer)
DIM AS HDC hDC=GetDC(Handle)
DIM AS HGDIOBJ Original=SelectObject(hDC, GetStockObject(DC_BRUSH))             ' Save copy of original

    SetDCBrushColor(hDC, CAST(COLORREF, Colr))
    SelectObject(hDC, GetStockObject(DC_PEN))
    SetDCPenColor(hDC, CAST(COLORREF, colr))
    RoundRect(hDC, x1, y1, x2, y2, x3, y3)
    SelectObject(hDC, Original)
    ReleaseDC(Handle, hDC)
END SUB
SUB MakeCircle(Handle AS HWND, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer, FillColr AS integer)
DIM AS HDC hDC=GetDC(Handle)
DIM AS HGDIOBJ Original=SelectObject(hDC, GetStockObject(DC_BRUSH))             ' Save copy of original

    SetDCBrushColor(hDC, CAST(COLORREF, FillColr))
    SelectObject(hDC, GetStockObject(DC_PEN))
    SetDCPenColor(hDC, CAST(COLORREF, colr))
    Ellipse(hDC, x1, y1, x2, y2)
    SelectObject(hDC, Original)
    ReleaseDC(Handle, hDC)
END SUB
FUNCTION GetTextSize(Handle AS HWND, Text AS string, WidthFlag AS integer) AS integer
DIM AS HDC hDC=GetDC(Handle)
DIM AS SIZE siz

    GetTextExtentPoint32(hDC, Text, LEN(Text), @siz)
    IF WidthFlag THEN
        RETURN siz.cx
    ELSE
        RETURN siz.cy
    END IF
END FUNCTION
SUB MakeTextOut(Handle AS HWND, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
DIM AS HDC hDC=GetDC(Handle)
DIM AS HGDIOBJ Original=SelectObject(hDC, GetStockObject(DC_BRUSH))             ' Save copy of original
DIM AS integer lenth=LEN(S)
DIM AS SIZE siz
DIM AS RECT rct

    GetWindowRect(Handle, @rct)
    DO
        GetTextExtentPoint32(hDC, S, lenth, @siz)
        IF siz.cx <= (rct.Right-rct.Left-x) THEN EXIT DO
        lenth -= 1
    LOOP UNTIL lenth=0
    IF bc <> -1 THEN
        SetDCBrushColor(hDC, CAST(COLORREF, bc))
    ELSE
        SetBKmode(hDC, 1)                                                       ' Transparent
    END IF
    SetTextColor(hDC, CAST(COLORREF, fc))
    TextOut(hDC, x, y, S, lenth)
    SelectObject(hDC, Original)
END SUB
'
' GP DoEvents code
'
SUB DoEvents
DIM AS MSG wMsg

    WHILE PeekMessage(@wMsg, 0, 0, 0, PM_REMOVE)
        TranslateMessage(@wMsg)
        DispatchMessage(@wMsg)
    WEND
END SUB

'
' Default Font for the Application (copied from RQ)
'
FUNCTION CreateDefaultFont() AS HFONT
WITH Application.RQlfont
    .lfHeight = -11
    .lfWidth = 0
    .lfEscapement = 0
    .lfOrientation = 0
    .lfWeight = 400
    .lfItalic = 0
    .lfUnderline = 0
    .lfStrikeOut = 0
    .lfCharSet = 0
    .lfOutPrecision = 1
    .lfClipPrecision = 2
    .lfQuality = 1
    .lfPitchAndFamily = 34
    .lfFaceName = "MS Sans Serif"
END WITH
    RETURN CreateFontIndirect(@Application.RQlfont)
END FUNCTION

'
' MouseHook
'
FUNCTION MouseProc(nCode AS integer, wParam AS WPARAM, lParam AS LPARAM) AS UINT
DIM AS MOUSEHOOKSTRUCT PTR lpMseHook = CAST(MOUSEHOOKSTRUCT PTR, lParam)
DIM AS POINT PTR lpPoint = CAST(POINT PTR, lParam)

    IF nCode >= 0 THEN                                          ' If < 0 no processing required
        Screen.MouseX=lpPoint->x
        Screen.MouseY=lpPoint->y
        SELECT CASE lpMseHook->wHitTestCode
            CASE WM_LBUTTONDOWN : Screen.MouseBtns=MK_LBUTTON
            CASE WM_RBUTTONDOWN : Screen.MouseBtns=MK_RBUTTON
            CASE WM_MBUTTONDOWN : Screen.MouseBtns=MK_MBUTTON
            CASE ELSE
                Screen.MouseBtns=0
        END SELECT
    END IF
    RETURN CallNextHookEx(MouseHook, nCode, wParam, lParam)     ' Call the next hook
END FUNCTION

SUB HookTheMouse
DIM AS UINT ThreadID
DIM AS HOOKPROC lpHookProc

    lpHookProc = CAST(HOOKPROC, @MouseProc)                     ' Hook mouse
    ThreadID = GetCurrentThreadId()
    MouseHook = SetWindowsHookEx(WH_MOUSE, lpHookProc, 0, ThreadID)
END SUB

SUB UnHookTheMouse
    UnhookWindowsHookEx(MouseHook)                              ' Remove our windows mouse hook
END SUB

'
' Main Application timer - currently used for ShowHint
'
SUB InitSystemTimers(Parent AS HWND)
    App_Timer.ObjIndex = SYS_TIMER_IDX
    App_Timer.Parent = Parent
    App_Timer.Interval = 100
    App_Timer.Enabled = True
    SetTimer(Parent, SYS_TIMER_IDX, 100, 0)
END SUB

'
' Common string functions
'
' RapidQ FIELD$()
FUNCTION rqFIELDSTR(srcString AS string, sepField AS string, numField AS integer) AS string
DIM AS integer i, j, start, cnt
DIM AS string tstr

    IF (LEN(srcString)=0) OR (LEN(sepField)=0) OR (numField<1) OR _
                                    (INSTR(srcString,sepField)=0) THEN
        RETURN srcString                                        ' No change
        EXIT FUNCTION
    END IF

    start=1: cnt=LEN(srcString)
    IF numField>1 THEN
        FOR i=2 TO numField
            j=INSTR(start,srcString,sepField)
            start = j + LEN(sepField)                           ' Move start pt along input string
        NEXT
    END IF
    i = cnt-start+1
    tstr=RIGHT(srcString,i)
    i=INSTR(tstr,sepField)
    IF i>0 THEN
        tstr=LEFT(tstr,i-1)
    END IF

    RETURN tstr
END FUNCTION

' RapidQ TALLY()
FUNCTION rqTALLY(srcString AS string, srchString AS string) AS integer
DIM AS integer i, j, cnt, retVal

    retVal=0: cnt=LEN(srchString)
    IF (LEN(srcString)>0) AND (cnt>0) THEN
        FOR i=1 TO LEN(srcString)
            j=INSTR(i,srcString,srchString)
            IF j=0 THEN
                EXIT FOR
            ELSE
                retVal += 1
                i = j + cnt - 1
            END IF
        NEXT
    END IF

    RETURN retVal
END FUNCTION

' RapidQ REVERSE$()
FUNCTION rqREVERSESTR(srcString AS string) AS string
DIM AS integer idx
DIM AS string retStr=""

    idx = LEN(srcString) - 1
    WHILE(idx >= 0)
        retStr += CHR(srcString[idx])
        idx -= 1
    WEND

    RETURN retStr
END FUNCTION

' RapidQ REPLACESUBSTR$() IF newToken="" REMOVE (all) occurences of ..
FUNCTION rqREPLACESUBSTR(srcString AS string, oldToken AS string, newToken AS string) AS string
DIM AS integer i, cnt
DIM AS string tstr, tok

    IF (LEN(srcString)=0) OR (LEN(oldToken)=0) THEN
        RETURN srcString
        EXIT FUNCTION
    END IF

    cnt=rqTALLY(srcString,oldToken)
    IF cnt>0 THEN
        tstr=""
        FOR i=1 TO cnt
            tok=rqFIELDSTR(srcString,oldToken,i)
            tstr += tok
            IF newToken<>"" THEN                                ' IF "" then remove oldToken
                tstr += newToken                                ' ELSE Replace oldToken
            END IF
        NEXT
        tok=rqFIELDSTR(srcString,oldToken,i)                    ' Add the remainder of the line
        tstr += tok
    ELSE
        tstr=srcString
    END IF

    RETURN tstr
END FUNCTION

